#include <iostream>
#include <fstream>
using namespace std;
#include <math.h>


char* itoa(int val, int base);

int main()
{
	//=======================================================================================================================================================
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	const int NumXPoints = 100;
	const int NumYPoints = 100;
	const double dx = 1.0/NumXPoints;
	
	const int i_end = 1000;
	
	
	const double T_end = .04;
	
	const double dt = T_end*1.0/i_end;
	
	const double Re = .05;
	
	const double F_x = 1e-5;
	const double F_y = 0;

	
	const double c_el = 1.0/sqrt(3.0);
	
	
	const double tau_vi = 10;
	
	const double mu_p = 8.0;
	const double lambda = 50;
	const double tau_el = 1/(1e-6*mu_p/(c_el*c_el) + 0.5);

	
	// For the LB sim
	const double w0 = 4.0/9;
	
	const double w1 = 1.0/9;
	const double w3 = 1.0/9;
	const double w5 = 1.0/9;
	const double w7 = 1.0/9;
	
	const double w2 = 1.0/36;
	const double w4 = 1.0/36;
	const double w6 = 1.0/36;
	const double w8 = 1.0/36;
	
	
	// Elastic component
	const double w0_el = 1.0 - 2.0*c_el*c_el;
	const double w1_el = c_el*c_el/2.0;
	const double w2_el = c_el*c_el/2.0;
	const double w3_el = c_el*c_el/2.0;
	const double w4_el = c_el*c_el/2.0;
	
	const double e0x = 0;
	const double e0y = 0;
	
	const double e1x = 1.0;
	const double e1y = 0.0;
	
	const double e2x = 1.0;
	const double e2y = 1.0;
	
	const double e3x = 0.0;
	const double e3y = 1.0;
	
	const double e4x = -1.0;
	const double e4y = 1.0;
	
	const double e5x = -1.0;
	const double e5y = 0;
	
	const double e6x = -1.0;
	const double e6y = -1.0;
	
	const double e7x = 0;
	const double e7y = -1.0;
	
	const double e8x = 1.0;
	const double e8y = -1.0;
	
	int i=0, j=0, k=0, t=0, Nxt, Prv;
	
	double** rho = new double*[NumXPoints];
	double** ux = new double*[NumXPoints];
	double** uy = new double*[NumXPoints];
	
	double** ux_x = new double*[NumXPoints];
	double** uy_x = new double*[NumXPoints];
	double** ux_y = new double*[NumXPoints];
	double** uy_y = new double*[NumXPoints];
	
	double** Axx = new double*[NumXPoints];
	double** Axy = new double*[NumXPoints];
	double** Ayx = new double*[NumXPoints];
	double** Ayy = new double*[NumXPoints];
	
	double** Axx_x = new double*[NumXPoints];
	double** Ayx_y = new double*[NumXPoints];
	double** Axy_x = new double*[NumXPoints];
	double** Ayy_y = new double*[NumXPoints];
	
	double** Gxx = new double*[NumXPoints];
	double** Gxy = new double*[NumXPoints];
	double** Gyx = new double*[NumXPoints];
	double** Gyy = new double*[NumXPoints];
	
	double** gx = new double*[NumXPoints];
	double** gy = new double*[NumXPoints];
	
	double** phix = new double*[NumXPoints];
	double** phiy = new double*[NumXPoints];
	
	double** f0 = new double*[NumXPoints];
	double** f1 = new double*[NumXPoints];
	double** f2 = new double*[NumXPoints];
	double** f3 = new double*[NumXPoints];
	double** f4 = new double*[NumXPoints];
	double** f5 = new double*[NumXPoints];
	double** f6 = new double*[NumXPoints];
	double** f7 = new double*[NumXPoints];
	double** f8 = new double*[NumXPoints];
	
	double** h0xx = new double*[NumXPoints];
	double** h1xx = new double*[NumXPoints];
	double** h2xx = new double*[NumXPoints];
	double** h3xx = new double*[NumXPoints];
	double** h4xx = new double*[NumXPoints];
	double** h0yx = new double*[NumXPoints];
	double** h1yx = new double*[NumXPoints];
	double** h2yx = new double*[NumXPoints];
	double** h3yx = new double*[NumXPoints];
	double** h4yx = new double*[NumXPoints];
	double** h0xy = new double*[NumXPoints];
	double** h1xy = new double*[NumXPoints];
	double** h2xy = new double*[NumXPoints];
	double** h3xy = new double*[NumXPoints];
	double** h4xy = new double*[NumXPoints];
	double** h0yy = new double*[NumXPoints];
	double** h1yy = new double*[NumXPoints];
	double** h2yy = new double*[NumXPoints];
	double** h3yy = new double*[NumXPoints];
	double** h4yy = new double*[NumXPoints];
	
	double** dh0xx = new double*[NumXPoints];
	double** dh1xx = new double*[NumXPoints];
	double** dh2xx = new double*[NumXPoints];
	double** dh3xx = new double*[NumXPoints];
	double** dh4xx = new double*[NumXPoints];
	double** dh0yx = new double*[NumXPoints];
	double** dh1yx = new double*[NumXPoints];
	double** dh2yx = new double*[NumXPoints];
	double** dh3yx = new double*[NumXPoints];
	double** dh4yx = new double*[NumXPoints];
	double** dh0xy = new double*[NumXPoints];
	double** dh1xy = new double*[NumXPoints];
	double** dh2xy = new double*[NumXPoints];
	double** dh3xy = new double*[NumXPoints];
	double** dh4xy = new double*[NumXPoints];
	double** dh0yy = new double*[NumXPoints];
	double** dh1yy = new double*[NumXPoints];
	double** dh2yy = new double*[NumXPoints];
	double** dh3yy = new double*[NumXPoints];
	double** dh4yy = new double*[NumXPoints];
	
	double** h0xxeq = new double*[NumXPoints];
	double** h1xxeq = new double*[NumXPoints];
	double** h2xxeq = new double*[NumXPoints];
	double** h3xxeq = new double*[NumXPoints];
	double** h4xxeq = new double*[NumXPoints];
	double** h0yxeq = new double*[NumXPoints];
	double** h1yxeq = new double*[NumXPoints];
	double** h2yxeq = new double*[NumXPoints];
	double** h3yxeq = new double*[NumXPoints];
	double** h4yxeq = new double*[NumXPoints];
	double** h0xyeq = new double*[NumXPoints];
	double** h1xyeq = new double*[NumXPoints];
	double** h2xyeq = new double*[NumXPoints];
	double** h3xyeq = new double*[NumXPoints];
	double** h4xyeq = new double*[NumXPoints];
	double** h0yyeq = new double*[NumXPoints];
	double** h1yyeq = new double*[NumXPoints];
	double** h2yyeq = new double*[NumXPoints];
	double** h3yyeq = new double*[NumXPoints];
	double** h4yyeq = new double*[NumXPoints];
	
	double** f0eq = new double*[NumXPoints];
	double** f1eq = new double*[NumXPoints];
	double** f2eq = new double*[NumXPoints];
	double** f3eq = new double*[NumXPoints];
	double** f4eq = new double*[NumXPoints];
	double** f5eq = new double*[NumXPoints];
	double** f6eq = new double*[NumXPoints];
	double** f7eq = new double*[NumXPoints];
	double** f8eq = new double*[NumXPoints];
	
	double** df0 = new double*[NumXPoints];
	double** df1 = new double*[NumXPoints];
	double** df2 = new double*[NumXPoints];
	double** df3 = new double*[NumXPoints];
	double** df4 = new double*[NumXPoints];
	double** df5 = new double*[NumXPoints];
	double** df6 = new double*[NumXPoints];
	double** df7 = new double*[NumXPoints];
	double** df8 = new double*[NumXPoints];
	
	for(i=0; i<NumXPoints; i++)
	{
		rho[i] = new double[NumYPoints];
		ux[i] = new double[NumYPoints];
		uy[i] = new double[NumYPoints];
		
		ux_x[i] = new double[NumYPoints];
		uy_x[i] = new double[NumYPoints];
		ux_y[i] = new double[NumYPoints];
		uy_y[i] = new double[NumYPoints];
		
		Axx[i] = new double[NumYPoints];
		Ayx[i] = new double[NumYPoints];
		Axy[i] = new double[NumYPoints];
		Ayy[i] = new double[NumYPoints];
		
		Axx_x[i] = new double[NumYPoints];
		Ayx_y[i] = new double[NumYPoints];
		Axy_x[i] = new double[NumYPoints];
		Ayy_y[i] = new double[NumYPoints];
		
		Gxx[i] = new double[NumYPoints];
		Gyx[i] = new double[NumYPoints];
		Gxy[i] = new double[NumYPoints];
		Gyy[i] = new double[NumYPoints];
		
		gx[i] = new double[NumYPoints];
		gy[i] = new double[NumYPoints];
		
		phix[i] = new double[NumYPoints];
		phiy[i] = new double[NumYPoints];

		h0xx[i] = new double[NumYPoints];
		h1xx[i] = new double[NumYPoints];
		h2xx[i] = new double[NumYPoints];
		h3xx[i] = new double[NumYPoints];
		h4xx[i] = new double[NumYPoints];
		h0yx[i] = new double[NumYPoints];
		h1yx[i] = new double[NumYPoints];
		h2yx[i] = new double[NumYPoints];
		h3yx[i] = new double[NumYPoints];
		h4yx[i] = new double[NumYPoints];
		h0xy[i] = new double[NumYPoints];
		h1xy[i] = new double[NumYPoints];
		h2xy[i] = new double[NumYPoints];
		h3xy[i] = new double[NumYPoints];
		h4xy[i] = new double[NumYPoints];
		h0yy[i] = new double[NumYPoints];
		h1yy[i] = new double[NumYPoints];
		h2yy[i] = new double[NumYPoints];
		h3yy[i] = new double[NumYPoints];
		h4yy[i] = new double[NumYPoints];
		
		dh0xx[i] = new double[NumYPoints];
		dh1xx[i] = new double[NumYPoints];
		dh2xx[i] = new double[NumYPoints];
		dh3xx[i] = new double[NumYPoints];
		dh4xx[i] = new double[NumYPoints];
		dh0yx[i] = new double[NumYPoints];
		dh1yx[i] = new double[NumYPoints];
		dh2yx[i] = new double[NumYPoints];
		dh3yx[i] = new double[NumYPoints];
		dh4yx[i] = new double[NumYPoints];
		dh0xy[i] = new double[NumYPoints];
		dh1xy[i] = new double[NumYPoints];
		dh2xy[i] = new double[NumYPoints];
		dh3xy[i] = new double[NumYPoints];
		dh4xy[i] = new double[NumYPoints];
		dh0yy[i] = new double[NumYPoints];
		dh1yy[i] = new double[NumYPoints];
		dh2yy[i] = new double[NumYPoints];
		dh3yy[i] = new double[NumYPoints];
		dh4yy[i] = new double[NumYPoints];
		
		h0xxeq[i] = new double[NumYPoints];
		h1xxeq[i] = new double[NumYPoints];
		h2xxeq[i] = new double[NumYPoints];
		h3xxeq[i] = new double[NumYPoints];
		h4xxeq[i] = new double[NumYPoints];
		h0yxeq[i] = new double[NumYPoints];
		h1yxeq[i] = new double[NumYPoints];
		h2yxeq[i] = new double[NumYPoints];
		h3yxeq[i] = new double[NumYPoints];
		h4yxeq[i] = new double[NumYPoints];
		h0xyeq[i] = new double[NumYPoints];
		h1xyeq[i] = new double[NumYPoints];
		h2xyeq[i] = new double[NumYPoints];
		h3xyeq[i] = new double[NumYPoints];
		h4xyeq[i] = new double[NumYPoints];
		h0yyeq[i] = new double[NumYPoints];
		h1yyeq[i] = new double[NumYPoints];
		h2yyeq[i] = new double[NumYPoints];
		h3yyeq[i] = new double[NumYPoints];
		h4yyeq[i] = new double[NumYPoints];
		
		
		f0[i] = new double[NumYPoints];
		f1[i] = new double[NumYPoints];
		f2[i] = new double[NumYPoints];
		f3[i] = new double[NumYPoints];
		f4[i] = new double[NumYPoints];
		f5[i] = new double[NumYPoints];
		f6[i] = new double[NumYPoints];
		f7[i] = new double[NumYPoints];
		f8[i] = new double[NumYPoints];
		
		f0eq[i] = new double[NumYPoints];
		f1eq[i] = new double[NumYPoints];
		f2eq[i] = new double[NumYPoints];
		f3eq[i] = new double[NumYPoints];
		f4eq[i] = new double[NumYPoints];
		f5eq[i] = new double[NumYPoints];
		f6eq[i] = new double[NumYPoints];
		f7eq[i] = new double[NumYPoints];
		f8eq[i] = new double[NumYPoints];
		
		df0[i] = new double[NumYPoints];
		df1[i] = new double[NumYPoints];
		df2[i] = new double[NumYPoints];
		df3[i] = new double[NumYPoints];
		df4[i] = new double[NumYPoints];
		df5[i] = new double[NumYPoints];
		df6[i] = new double[NumYPoints];
		df7[i] = new double[NumYPoints];
		df8[i] = new double[NumYPoints];
	}
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	for(i=0; i<NumXPoints; i++)
	{
		for(j=0; j<NumYPoints; j++)
		{
			f0[i][j] = w0;
			f1[i][j] = w1;
			f2[i][j] = w2;
			f3[i][j] = w3;
			f4[i][j] = w4;
			f5[i][j] = w5;
			f6[i][j] = w6;
			f7[i][j] = w7;
			f8[i][j] = w8;
			
			h0xx[i][j] = w0_el;
			h1xx[i][j] = w1_el;
			h2xx[i][j] = w2_el;
			h3xx[i][j] = w3_el;
			h4xx[i][j] = w4_el;
			h0yx[i][j] = 0;
			h1yx[i][j] = 0;
			h2yx[i][j] = 0;
			h3yx[i][j] = 0;
			h4yx[i][j] = 0;
			h0xy[i][j] = 0;
			h1xy[i][j] = 0;
			h2xy[i][j] = 0;
			h3xy[i][j] = 0;
			h4xy[i][j] = 0;
			h0yy[i][j] = w0_el;
			h1yy[i][j] = w1_el;
			h2yy[i][j] = w2_el;
			h3yy[i][j] = w3_el;
			h4yy[i][j] = w4_el;
			
			Axx[i][j] = 1;
			Axy[i][j] = 0;
			Ayx[i][j] = 0;
			Ayy[i][j] = 1;
			
			rho[i][j] = 1.0;
			ux[i][j] = 0;
			uy[i][j] = 0;
			
			phix[i][j] = F_x;
			phiy[i][j] = F_y;
		}
	}
	//========================================================================================================================================================
	cout << "NumX = " << NumXPoints << endl;
	cout << "NumY = " << NumYPoints << endl;
	cout << "tau = " << tau_vi << endl;
	cout << "mu_p = " << mu_p << endl;
	cout << "tau_el = " << tau_el << endl;
	cout << "lambda = " << lambda << endl;
	cout << "Fx = " << F_x << endl;
	//cout << "Re = " << Re << endl << endl;

	
	//=========================================================================================================================
	ofstream* file = new ofstream("Dataout.m");
	
	(*file)<<"dx = "<<dx<<";"<<endl;
	(*file)<<"dt = "<<dt<<";"<<endl;
	
	(*file)<<"i_end = "<< i_end <<";"<<endl;
	(*file)<<"T_end = "<< T_end <<";"<<endl;

	
	(*file)<<"Re = "<< Re <<";"<<endl;
	
	(*file)<<"tau = "<< tau_el <<";"<<endl;
	
	(*file)<<"mu_p = "<< mu_p <<";"<<endl;
	(*file)<<"tau_el = "<< tau_el <<";"<<endl;
	(*file)<<"lambda = "<< lambda <<";"<<endl;
	
	
	(*file)<<"V_cent = [];"<<endl;
	
	(*file)<<"Time_Array = [];"<<endl;
	
	
	file->close();
	delete file;
	
	//=========================================================================================================================
	
	for(t=0; t<i_end;t++)
	{
		if( !(t/100.0-t/100) ) { 
			cout<<"Iteration # "<<t<<endl;
			cout<<"V_cent = "<<ux[30][50]<<endl;
		}

		
	
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		// Boundary Condition
		
		/*
		for(j=0; j<NumXPoints; j++)
		{
			f0[j][0] = f0[j][1];
			f1[j][0] = f5[j][1];
			f2[j][0] = f6[j][1];
			f3[j][0] = f7[j][1];
			f4[j][0] = f8[j][1];
			f5[j][0] = f1[j][1];
			f6[j][0] = f2[j][1];
			f7[j][0] = f3[j][1];
			f8[j][0] = f4[j][1];
			
			h0xx[j][0] = h0xx[j][1];
			h1xx[j][0] = h3xx[j][1];
			h2xx[j][0] = h4xx[j][1];
			h4xx[j][0] = h2xx[j][1];
			h3xx[j][0] = h1xx[j][1];
			
			h0xy[j][0] = h0xy[j][1];
			h1xy[j][0] = h3xy[j][1];
			h2xy[j][0] = h4xy[j][1];
			h4xy[j][0] = h2xy[j][1];
			h3xy[j][0] = h1xy[j][1];
			
			h0yx[j][0] = h0yx[j][1];
			h1yx[j][0] = h3yx[j][1];
			h2yx[j][0] = h4yx[j][1];
			h4yx[j][0] = h2yx[j][1];
			h3yx[j][0] = h1yx[j][1];
			
			h0yy[j][0] = h0yy[j][1];
			h1yy[j][0] = h3yy[j][1];
			h2yy[j][0] = h4yy[j][1];
			h4yy[j][0] = h2yy[j][1];
			h3yy[j][0] = h1yy[j][1];
			
			f0[j][NumYPoints-1] = f0[j][NumYPoints-1-1];
			f1[j][NumYPoints-1] = f5[j][NumYPoints-1-1];
			f2[j][NumYPoints-1] = f6[j][NumYPoints-1-1];
			f3[j][NumYPoints-1] = f7[j][NumYPoints-1-1];
			f4[j][NumYPoints-1] = f8[j][NumYPoints-1-1];
			f5[j][NumYPoints-1] = f1[j][NumYPoints-1-1];
			f6[j][NumYPoints-1] = f2[j][NumYPoints-1-1];
			f7[j][NumYPoints-1] = f3[j][NumYPoints-1-1];
			f8[j][NumYPoints-1] = f4[j][NumYPoints-1-1];
			
			h0xx[j][NumYPoints-1] = h0xx[j][NumYPoints-1-1];
			h1xx[j][NumYPoints-1] = h3xx[j][NumYPoints-1-1];
			h2xx[j][NumYPoints-1] = h4xx[j][NumYPoints-1-1];
			h4xx[j][NumYPoints-1] = h2xx[j][NumYPoints-1-1];
			h3xx[j][NumYPoints-1] = h1xx[j][NumYPoints-1-1];
			
			h0xy[j][NumYPoints-1] = h0xy[j][NumYPoints-1-1];
			h1xy[j][NumYPoints-1] = h3xy[j][NumYPoints-1-1];
			h2xy[j][NumYPoints-1] = h4xy[j][NumYPoints-1-1];
			h4xy[j][NumYPoints-1] = h2xy[j][NumYPoints-1-1];
			h3xy[j][NumYPoints-1] = h1xy[j][NumYPoints-1-1];
			
			h0yx[j][NumYPoints-1] = h0yx[j][NumYPoints-1-1];
			h1yx[j][NumYPoints-1] = h3yx[j][NumYPoints-1-1];
			h2yx[j][NumYPoints-1] = h4yx[j][NumYPoints-1-1];
			h4yx[j][NumYPoints-1] = h2yx[j][NumYPoints-1-1];
			h3yx[j][NumYPoints-1] = h1yx[j][NumYPoints-1-1];
			
			h0yy[j][NumYPoints-1] = h0yy[j][NumYPoints-1-1];
			h1yy[j][NumYPoints-1] = h3yy[j][NumYPoints-1-1];
			h2yy[j][NumYPoints-1] = h4yy[j][NumYPoints-1-1];
			h4yy[j][NumYPoints-1] = h2yy[j][NumYPoints-1-1];
			h3yy[j][NumYPoints-1] = h1yy[j][NumYPoints-1-1];
		}
		*/
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0; k<NumYPoints; k++)
			{
				df0[j][k] = 0;
				df1[j][k] = 0;
				df2[j][k] = 0;
				df3[j][k] = 0;
				df4[j][k] = 0;
				df5[j][k] = 0;
				df6[j][k] = 0;
				df7[j][k] = 0;
				df8[j][k] = 0;
				
				dh0xx[j][k] = 0;
				dh1xx[j][k] = 0;
				dh2xx[j][k] = 0;
				dh3xx[j][k] = 0;
				dh4xx[j][k] = 0;
				
				dh0yx[j][k] = 0;
				dh1yx[j][k] = 0;
				dh2yx[j][k] = 0;
				dh3yx[j][k] = 0;
				dh4yx[j][k] = 0;
				
				dh0xy[j][k] = 0;
				dh1xy[j][k] = 0;
				dh2xy[j][k] = 0;
				dh3xy[j][k] = 0;
				dh4xy[j][k] = 0;
				
				dh0yy[j][k] = 0;
				dh1yy[j][k] = 0;
				dh2yy[j][k] = 0;
				dh3yy[j][k] = 0;
				dh4yy[j][k] = 0;
				
				Gxx[j][k] = 0;
				Gxy[j][k] = 0;
				Gyx[j][k] = 0;
				Gyy[j][k] = 0;
			}
		}

		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
	
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		// Calculate divergence of A
		
		// X derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=0; j<NumYPoints; j++) {
				
				Prv = i-1;
				if (Prv < 0)
					Prv += NumXPoints;
				Nxt = i+1;
				if (Nxt > (NumXPoints-1)) 
					Nxt -= NumXPoints;
				
				Axx_x[i][j] = (Axx[Nxt][j] - Axx[Prv][j])/2.0;
				Axy_x[i][j] = (Axy[Nxt][j] - Axy[Prv][j])/2.0;
				
			}
		}
	
		
		// Y direction
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				Ayx_y[i][j] = (Ayx[i][j+1] - Ayx[i][j-1])/2.0;
				Ayy_y[i][j] = (Ayy[i][j+1] - Ayy[i][j-1])/2.0;
				
			}
		}
		
		// for y = 0 and y = 1
		for (i=0; i<NumXPoints; i++) {
			Ayx_y[i][0] = (-3.0*Ayx[i][0] + 4*Ayx[i][1] - Ayx[i][2])/2.0;
			Ayy_y[i][0] = (-3.0*Ayy[i][0] + 4*Ayy[i][1] - Ayy[i][2])/2.0;

			
			Ayx_y[i][NumYPoints-1] = -1.0*(-3.0*Ayx[i][NumYPoints-1] + 4*Ayx[i][NumYPoints-2] - Ayx[i][NumYPoints-3])/2.0;
			Ayy_y[i][NumYPoints-1] = -1.0*(-3.0*Ayy[i][NumYPoints-1] + 4*Ayy[i][NumYPoints-2] - Ayy[i][NumYPoints-3])/2.0;
		}
		
		for (i=0; i<NumXPoints; i++) {
			for (j=0; j<NumYPoints; j++) {
				
				gx[i][j] = mu_p/lambda*(Axx_x[i][j] + Ayx_y[i][j])/rho[i][j] + phix[i][j];
				gy[i][j] = mu_p/lambda*(Axy_x[i][j] + Ayy_y[i][j])/rho[i][j] + phiy[i][j];

				
			}
		}
		

		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		// Calculate feq
		
		
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				f0eq[j][k] = w0*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e0x*ux[j][k]+e0y*uy[j][k]) + (9.0/2)*(e0x*ux[j][k]+e0y*uy[j][k])*(e0x*ux[j][k]+e0y*uy[j][k]));
				f1eq[j][k] = w1*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e1x*ux[j][k]+e1y*uy[j][k]) + (9.0/2)*(e1x*ux[j][k]+e1y*uy[j][k])*(e1x*ux[j][k]+e1y*uy[j][k]));
				f2eq[j][k] = w2*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e2x*ux[j][k]+e2y*uy[j][k]) + (9.0/2)*(e2x*ux[j][k]+e2y*uy[j][k])*(e2x*ux[j][k]+e2y*uy[j][k]));
				f3eq[j][k] = w3*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e3x*ux[j][k]+e3y*uy[j][k]) + (9.0/2)*(e3x*ux[j][k]+e3y*uy[j][k])*(e3x*ux[j][k]+e3y*uy[j][k]));
				f4eq[j][k] = w4*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e4x*ux[j][k]+e4y*uy[j][k]) + (9.0/2)*(e4x*ux[j][k]+e4y*uy[j][k])*(e4x*ux[j][k]+e4y*uy[j][k]));
				f5eq[j][k] = w5*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e5x*ux[j][k]+e5y*uy[j][k]) + (9.0/2)*(e5x*ux[j][k]+e5y*uy[j][k])*(e5x*ux[j][k]+e5y*uy[j][k]));
				f6eq[j][k] = w6*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e6x*ux[j][k]+e6y*uy[j][k]) + (9.0/2)*(e6x*ux[j][k]+e6y*uy[j][k])*(e6x*ux[j][k]+e6y*uy[j][k]));
				f7eq[j][k] = w7*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e7x*ux[j][k]+e7y*uy[j][k]) + (9.0/2)*(e7x*ux[j][k]+e7y*uy[j][k])*(e7x*ux[j][k]+e7y*uy[j][k]));
				f8eq[j][k] = w8*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e8x*ux[j][k]+e8y*uy[j][k]) + (9.0/2)*(e8x*ux[j][k]+e8y*uy[j][k])*(e8x*ux[j][k]+e8y*uy[j][k]));
			}
		}
		/*
		cout << "f0eq = " << f0eq[50][50]<<endl;
		cout << "f1eq = " << f1eq[50][50]<<endl;
		cout << "f2eq = " << f2eq[50][50]<<endl;
		cout << "f3eq = " << f3eq[50][50]<<endl;
		cout << "f4eq = " << f4eq[50][50]<<endl;
		cout << "f5eq = " << f5eq[50][50]<<endl;
		cout << "f6eq = " << f6eq[50][50]<<endl;
		cout << "f7eq = " << f7eq[50][50]<<endl;
		cout << "f8eq = " << f8eq[50][50]<<endl;
		*/
		
		
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		// Collision step for fi's
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0; k<NumYPoints; k++)
			{
				
				
				df0[j][k] = f0[j][k] - 1.0/tau_vi*(f0[j][k] - f0eq[j][k]);
				df1[j][k] = f1[j][k] - 1.0/tau_vi*(f1[j][k] - f1eq[j][k]);
				df2[j][k] = f2[j][k] - 1.0/tau_vi*(f2[j][k] - f2eq[j][k]);
				df3[j][k] = f3[j][k] - 1.0/tau_vi*(f3[j][k] - f3eq[j][k]);
				df4[j][k] = f4[j][k] - 1.0/tau_vi*(f4[j][k] - f4eq[j][k]);
				df5[j][k] = f5[j][k] - 1.0/tau_vi*(f5[j][k] - f5eq[j][k]);
				df6[j][k] = f6[j][k] - 1.0/tau_vi*(f6[j][k] - f6eq[j][k]);
				df7[j][k] = f7[j][k] - 1.0/tau_vi*(f7[j][k] - f7eq[j][k]);
				df8[j][k] = f8[j][k] - 1.0/tau_vi*(f8[j][k] - f8eq[j][k]);

				
				// Now we add the force
				
				df0[j][k] += (1 - 1/(2.0*tau_vi))*w0*rho[j][k]*((e0x - ux[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0x)*gx[j][k];
				df0[j][k] += (1 - 1/(2.0*tau_vi))*w0*rho[j][k]*((e0y - uy[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0y)*gy[j][k];
				
				df1[j][k] += (1 - 1/(2.0*tau_vi))*w1*rho[j][k]*((e1x - ux[j][k])*3.0 - 9.0*(e1x*ux[j][k] + e1y*uy[j][k])*e1x)*gx[j][k];
				df1[j][k] += (1 - 1/(2.0*tau_vi))*w1*rho[j][k]*((e1y - uy[j][k])*3.0 - 9.0*(e1x*ux[j][k] + e1y*uy[j][k])*e1y)*gy[j][k];
				
				df2[j][k] += (1 - 1/(2.0*tau_vi))*w2*rho[j][k]*((e2x - ux[j][k])*3.0 - 9.0*(e2x*ux[j][k] + e2y*uy[j][k])*e2x)*gx[j][k];
				df2[j][k] += (1 - 1/(2.0*tau_vi))*w2*rho[j][k]*((e2y - uy[j][k])*3.0 - 9.0*(e2x*ux[j][k] + e2y*uy[j][k])*e2y)*gy[j][k];
				
				df3[j][k] += (1 - 1/(2.0*tau_vi))*w3*rho[j][k]*((e3x - ux[j][k])*3.0 - 9.0*(e3x*ux[j][k] + e3y*uy[j][k])*e3x)*gx[j][k];
				df3[j][k] += (1 - 1/(2.0*tau_vi))*w3*rho[j][k]*((e3y - uy[j][k])*3.0 - 9.0*(e3x*ux[j][k] + e3y*uy[j][k])*e3y)*gy[j][k];
				
				df4[j][k] += (1 - 1/(2.0*tau_vi))*w4*rho[j][k]*((e4x - ux[j][k])*3.0 - 9.0*(e4x*ux[j][k] + e4y*uy[j][k])*e4x)*gx[j][k];
				df4[j][k] += (1 - 1/(2.0*tau_vi))*w4*rho[j][k]*((e4y - uy[j][k])*3.0 - 9.0*(e4x*ux[j][k] + e4y*uy[j][k])*e4y)*gy[j][k];
				
				df5[j][k] += (1 - 1/(2.0*tau_vi))*w5*rho[j][k]*((e5x - ux[j][k])*3.0 - 9.0*(e5x*ux[j][k] + e5y*uy[j][k])*e5x)*gx[j][k];
				df5[j][k] += (1 - 1/(2.0*tau_vi))*w5*rho[j][k]*((e5y - uy[j][k])*3.0 - 9.0*(e5x*ux[j][k] + e5y*uy[j][k])*e5y)*gy[j][k];
				
				df6[j][k] += (1 - 1/(2.0*tau_vi))*w6*rho[j][k]*((e6x - ux[j][k])*3.0 - 9.0*(e6x*ux[j][k] + e6y*uy[j][k])*e6x)*gx[j][k];
				df6[j][k] += (1 - 1/(2.0*tau_vi))*w6*rho[j][k]*((e6y - uy[j][k])*3.0 - 9.0*(e6x*ux[j][k] + e6y*uy[j][k])*e6y)*gy[j][k];
				
				df7[j][k] += (1 - 1/(2.0*tau_vi))*w7*rho[j][k]*((e7x - ux[j][k])*3.0 - 9.0*(e7x*ux[j][k] + e7y*uy[j][k])*e7x)*gx[j][k];
				df7[j][k] += (1 - 1/(2.0*tau_vi))*w7*rho[j][k]*((e7y - uy[j][k])*3.0 - 9.0*(e7x*ux[j][k] + e7y*uy[j][k])*e7y)*gy[j][k];
				
				df8[j][k] += (1 - 1/(2.0*tau_vi))*w8*rho[j][k]*((e8x - ux[j][k])*3.0 - 9.0*(e8x*ux[j][k] + e8y*uy[j][k])*e8x)*gx[j][k];
				df8[j][k] += (1 - 1/(2.0*tau_vi))*w8*rho[j][k]*((e8y - uy[j][k])*3.0 - 9.0*(e8x*ux[j][k] + e8y*uy[j][k])*e8y)*gy[j][k];

				
			}
		}
		
		/*cout << "df0 = " << df0[50][50]<<endl;
		cout << "df1 = " << df1[50][50]<<endl;
		cout << "df2 = " << df2[50][50]<<endl;
		cout << "df3 = " << df3[50][50]<<endl;
		cout << "df4 = " << df4[50][50]<<endl;
		cout << "df5 = " << df5[50][50]<<endl;
		cout << "df6 = " << df6[50][50]<<endl;
		cout << "df7 = " << df7[50][50]<<endl;
		cout << "df8 = " << df8[50][50]<<endl;
		 */
		
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	
		// Streaming Step
		// Stream for all expect for y=0 and y=1
		for(j=0; j<NumXPoints; j++)
		{
			for(k=1; k<NumYPoints-1; k++)
			{
				
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints);
				int PrvY = k-1;
				int NxtY = k+1;
				
				f0[j][k] = df0[j][k];
				f1[j][k] = df1[PrvX][k];
				f5[j][k] = df5[NxtX][k];
				
				f3[j][k] = df3[j][PrvY];
				f7[j][k] = df7[j][NxtY];
				
				f2[j][k] = df2[PrvX][PrvY];
				f4[j][k] = df4[NxtX][PrvY];
				
				f6[j][k] = df6[NxtX][NxtY];
				f8[j][k] = df8[PrvX][NxtY];

			}
		}
		
		//Finish streaming on y=0 and y=1
		for(j=0; j<NumXPoints; j++){
			
			int PrvX = j-1;
			if(PrvX<0) PrvX += (NumXPoints);
			int NxtX = j+1;
			if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints);
			
			f0[j][0] = df0[j][0];
			f0[j][NumYPoints-1] = df0[j][NumYPoints-1];
			
			f1[NxtX][0] = df1[j][0];
			f1[NxtX][NumYPoints-1] = df1[j][NumYPoints-1];
			
			f5[PrvX][0] = df5[j][0];
			f5[PrvX][NumYPoints-1] = df5[j][NumYPoints-1];
			
			f7[j][0] = df7[j][1];
			f6[j][0] = df6[NxtX][1];
			f8[j][0] = df8[PrvX][1];
			
			f3[j][NumXPoints-1] = df3[j][NumXPoints-2];
			f2[j][NumXPoints-1] = df2[PrvX][NumXPoints-2];
			f4[j][NumXPoints-1] = df4[NxtX][NumXPoints-2];
			
		}

		
		


		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
			
		// Apply boundary conditions
		
		// for k=0 and k=NumYPoints
		for(j=0; j<NumXPoints; j++){
			
			int PrvX = j-1;
			if(PrvX<0) PrvX += (NumXPoints);
			int NxtX = j+1;
			if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints);
			
			f3[j][0] = f7[j][0];
			f2[j][0] = f6[j][0] + 0.5*(f5[j][0] - f1[j][0]);
			f4[j][0] = f8[j][0] + 0.5*(f1[j][0] - f5[j][0]); 
			
			f7[j][NumXPoints-1] = f3[j][NumXPoints-1];
			f6[j][NumXPoints-1] = f2[j][NumXPoints-1] + 0.5*(f1[j][NumXPoints-1] - f5[j][NumXPoints-1]);
			f8[j][NumXPoints-1] = f4[j][NumXPoints-1] + 0.5*(f5[j][NumXPoints-1] - f1[j][NumXPoints-1]); 
		}
		
		
		
		/*
		cout << endl << "f0 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f0[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f1 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f1[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f2 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f2[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f3 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f3[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f4 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f4[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f5 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f5[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f6 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f6[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f7 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f7[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		
		cout << endl << "f8 = [" << endl;
		for(j=0; j<NumXPoints; j++){
			for(k=0; k<NumYPoints; k++){
				
				cout << f8[j][k] << "  ";
			}
			cout << endl;
		}
		cout << endl;
		*/
		
			
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		// Calculate velocity and density
		
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = 0;
				ux[j][k] = 0;
				uy[j][k] = 0;
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = f0[j][k]+f1[j][k]+f2[j][k]+f3[j][k]+f4[j][k]+f5[j][k]+f6[j][k]+f7[j][k]+f8[j][k];
				
				ux[j][k] = e0x*f0[j][k]+e1x*f1[j][k]+e2x*f2[j][k]+e3x*f3[j][k]+e4x*f4[j][k]+e5x*f5[j][k]+e6x*f6[j][k]+e7x*f7[j][k]+e8x*f8[j][k];
				uy[j][k] = e0y*f0[j][k]+e1y*f1[j][k]+e2y*f2[j][k]+e3y*f3[j][k]+e4y*f4[j][k]+e5y*f5[j][k]+e6y*f6[j][k]+e7y*f7[j][k]+e8y*f8[j][k];
				
				
				
				if( rho[j][k]!=0 )
				{
					ux[j][k] = ux[j][k]/rho[j][k] + gx[j][k]/2.0;
					uy[j][k] = uy[j][k]/rho[j][k] + gy[j][k]/2.0;
				}
				else
				{
					const double eps = 1e-4;
					ux[j][k] = ux[j][k]/eps + gx[j][k]/2.0;
					uy[j][k] = uy[j][k]/eps + gy[j][k]/2.0;
				}
			}
		}


		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

		
		// Calculate grad of velocity
		// X derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=0; j<NumYPoints; j++) {
				
				Prv = i-1;
				if (Prv < 0)
					Prv += NumXPoints;
				Nxt = i+1;
				if (Nxt > (NumXPoints-1)) 
					Nxt -= NumXPoints;
				
				ux_x[i][j] = (ux[Nxt][j] - ux[Prv][j])/2.0;
				uy_x[i][j] = (uy[Nxt][j] - uy[Prv][j])/2.0;
				
				
			}
		}
		
		// Y derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				ux_y[i][j] = (ux[i][j+1] - ux[i][j-1])/2.0;
				uy_y[i][j] = (uy[i][j+1] - uy[i][j-1])/2.0;
				
			}
		}
		
		// for y = 0 and y = 1
		for (i=0; i<NumXPoints; i++) {
			ux_y[i][0] = (-3.0*ux[i][0] + 4*ux[i][1] - ux[i][2])/2.0;
			uy_y[i][0] = (-3.0*uy[i][0] + 4*uy[i][1] - uy[i][2])/2.0;
			
			
			ux_y[i][NumYPoints-1] = -1.0*(-3.0*ux[i][NumYPoints-1] + 4*ux[i][NumYPoints-2] - ux[i][NumYPoints-3])/2.0;
			uy_y[i][NumYPoints-1] = -1.0*(-3.0*uy[i][NumYPoints-1] + 4*uy[i][NumYPoints-2] - uy[i][NumYPoints-3])/2.0;
		}
		
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

		// Calculate heq
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				h0xxeq[j][k] = w0_el*Axx[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1xxeq[j][k] = w1_el*Axx[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2xxeq[j][k] = w2_el*Axx[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3xxeq[j][k] = w3_el*Axx[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4xxeq[j][k] = w4_el*Axx[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
		
				h0xyeq[j][k] = w0_el*Axy[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1xyeq[j][k] = w1_el*Axy[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2xyeq[j][k] = w2_el*Axy[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3xyeq[j][k] = w3_el*Axy[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4xyeq[j][k] = w4_el*Axy[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				h0yxeq[j][k] = w0_el*Ayx[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1yxeq[j][k] = w1_el*Ayx[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2yxeq[j][k] = w2_el*Ayx[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3yxeq[j][k] = w3_el*Ayx[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4yxeq[j][k] = w4_el*Ayx[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
			
				h0yyeq[j][k] = w0_el*Ayy[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1yyeq[j][k] = w1_el*Ayy[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2yyeq[j][k] = w2_el*Ayy[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3yyeq[j][k] = w3_el*Ayy[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4yyeq[j][k] = w4_el*Ayy[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
			}
		}

		
		
		// Calculate G
		for(i=0; i<NumXPoints; i++)
		{
			for(j=0; j<NumYPoints; j++)
			{
				Gxx[i][j] = -1.0/lambda*(Axx[i][j] - 1.0) + 2.0*ux_x[i][j]*Axx[i][j] + ux_y[i][j]*(Ayx[i][j] + Axy[i][j]);	
				Gxy[i][j] = -1.0/lambda*(Axy[i][j]) + ux_x[i][j]*Axy[i][j] + ux_y[i][j]*Ayy[i][j] + uy_x[i][j]*Axx[i][j] + uy_y[i][j]*Axy[i][j];
				Gyx[i][j] = -1.0/lambda*(Ayx[i][j]) + ux_x[i][j]*Ayx[i][j] + ux_y[i][j]*Ayy[i][j] + uy_x[i][j]*Axx[i][j] + uy_y[i][j]*Ayx[i][j];
				Gyy[i][j] = -1.0/lambda*(Ayy[i][j] - 1.0) + 2.0*uy_y[i][j]*Ayy[i][j] + uy_x[i][j]*(Ayx[i][j] + Axy[i][j]);	
			}
		}

		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

		
		
		// Now do the advective diffusion scheme for h
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0; k<NumYPoints; k++)
			{
	
			
				dh0xx[j][k] = h0xx[j][k] - 1/tau_el*(h0xx[j][k] - h0xxeq[j][k]) + (1 - 1/(2*tau_el))*Gxx[j][k]*w0_el*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				dh1xx[j][k] = h1xx[j][k] - 1/tau_el*(h1xx[j][k] - h1xxeq[j][k]) + (1 - 1/(2*tau_el))*Gxx[j][k]*w1_el*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				dh2xx[j][k] = h2xx[j][k] - 1/tau_el*(h2xx[j][k] - h2xxeq[j][k]) + (1 - 1/(2*tau_el))*Gxx[j][k]*w2_el*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				dh3xx[j][k] = h3xx[j][k] - 1/tau_el*(h3xx[j][k] - h3xxeq[j][k]) + (1 - 1/(2*tau_el))*Gxx[j][k]*w3_el*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				dh4xx[j][k] = h4xx[j][k] - 1/tau_el*(h4xx[j][k] - h4xxeq[j][k]) + (1 - 1/(2*tau_el))*Gxx[j][k]*w4_el*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
					
				dh0xy[j][k] = h0xy[j][k] - 1/tau_el*(h0xy[j][k] - h0xyeq[j][k]) + (1 - 1/(2*tau_el))*Gxy[j][k]*w0_el*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				dh1xy[j][k] = h1xy[j][k] - 1/tau_el*(h1xy[j][k] - h1xyeq[j][k]) + (1 - 1/(2*tau_el))*Gxy[j][k]*w1_el*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				dh2xy[j][k] = h2xy[j][k] - 1/tau_el*(h2xy[j][k] - h2xyeq[j][k]) + (1 - 1/(2*tau_el))*Gxy[j][k]*w2_el*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				dh3xy[j][k] = h3xy[j][k] - 1/tau_el*(h3xy[j][k] - h3xyeq[j][k]) + (1 - 1/(2*tau_el))*Gxy[j][k]*w3_el*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				dh4xy[j][k] = h4xy[j][k] - 1/tau_el*(h4xy[j][k] - h4xyeq[j][k]) + (1 - 1/(2*tau_el))*Gxy[j][k]*w4_el*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				dh0yx[j][k] = h0yx[j][k] - 1/tau_el*(h0yx[j][k] - h0yxeq[j][k]) + (1 - 1/(2*tau_el))*Gyx[j][k]*w0_el*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				dh1yx[j][k] = h1yx[j][k] - 1/tau_el*(h1yx[j][k] - h1yxeq[j][k]) + (1 - 1/(2*tau_el))*Gyx[j][k]*w1_el*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				dh2yx[j][k] = h2yx[j][k] - 1/tau_el*(h2yx[j][k] - h2yxeq[j][k]) + (1 - 1/(2*tau_el))*Gyx[j][k]*w2_el*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				dh3yx[j][k] = h3yx[j][k] - 1/tau_el*(h3yx[j][k] - h3yxeq[j][k]) + (1 - 1/(2*tau_el))*Gyx[j][k]*w3_el*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				dh4yx[j][k] = h4yx[j][k] - 1/tau_el*(h4yx[j][k] - h4yxeq[j][k]) + (1 - 1/(2*tau_el))*Gyx[j][k]*w4_el*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				dh0yy[j][k] = h0yy[j][k] - 1/tau_el*(h0yy[j][k] - h0yyeq[j][k]) + (1 - 1/(2*tau_el))*Gyy[j][k]*w0_el*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				dh1yy[j][k] = h1yy[j][k] - 1/tau_el*(h1yy[j][k] - h1yyeq[j][k]) + (1 - 1/(2*tau_el))*Gyy[j][k]*w1_el*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				dh2yy[j][k] = h2yy[j][k] - 1/tau_el*(h2yy[j][k] - h2yyeq[j][k]) + (1 - 1/(2*tau_el))*Gyy[j][k]*w2_el*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				dh3yy[j][k] = h3yy[j][k] - 1/tau_el*(h3yy[j][k] - h3yyeq[j][k]) + (1 - 1/(2*tau_el))*Gyy[j][k]*w3_el*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				dh4yy[j][k] = h4yy[j][k] - 1/tau_el*(h4yy[j][k] - h4yyeq[j][k]) + (1 - 1/(2*tau_el))*Gyy[j][k]*w4_el*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
			}
		}
	
		// stream 
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints-1);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
				int PrvY = k-1;
				int NxtY = k+1;
				
				h0xx[j][k] = dh0xx[j][k];
				h1xx[j][k] = dh1xx[PrvX][k];
				h2xx[j][k] = dh2xx[j][PrvY];
				h3xx[j][k] = dh3xx[NxtX][k];
				h4xx[j][k] = dh4xx[j][NxtY];
				
				h0xy[j][k] = dh0xy[j][k];
				h1xy[j][k] = dh1xy[PrvX][k];
				h2xy[j][k] = dh2xy[j][PrvY];
				h3xy[j][k] = dh3xy[NxtX][k];
				h4xy[j][k] = dh4xy[j][NxtY];
				
				h0yx[j][k] = dh0yx[j][k];
				h1yx[j][k] = dh1yx[PrvX][k];
				h2yx[j][k] = dh2yx[j][PrvY];
				h3yx[j][k] = dh3yx[NxtX][k];
				h4yx[j][k] = dh4yx[j][NxtY];
				
				h0yy[j][k] = dh0yy[j][k];
				h1yy[j][k] = dh1yy[PrvX][k];
				h2yy[j][k] = dh2yy[j][PrvY];
				h3yy[j][k] = dh3yy[NxtX][k];
				h4yy[j][k] = dh4yy[j][NxtY];
				
			}
		}
		
		// finish streaming for y=0  and y=1
		for(j=0; j<NumXPoints; j++)
		{
			int PrvX = j-1;
			if(PrvX<0) PrvX += (NumXPoints-1);
			int NxtX = j+1;
			if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
			
			h0xx[j][0] = dh0xx[j][0];
			h1xx[j][0] = dh1xx[PrvX][0];
			h3xx[j][0] = dh3xx[NxtX][0];
			h4xx[j][0] = dh4xx[j][1];
			
			h0xy[j][0] = dh0xy[j][0];
			h1xy[j][0] = dh1xy[PrvX][0];
			h3xy[j][0] = dh3xy[NxtX][0];
			h4xy[j][0] = dh4xy[j][1];
			
			h0yx[j][0] = dh0yx[j][0];
			h1yx[j][0] = dh1yx[PrvX][0];
			h3yx[j][0] = dh3yx[NxtX][0];
			h4yx[j][0] = dh4yx[j][1];
			
			h0yy[j][0] = dh0yy[j][0];
			h1yy[j][0] = dh1yy[PrvX][0];
			h3yy[j][0] = dh3yy[NxtX][0];
			h4yy[j][0] = dh4yy[j][1];
			
			h0xx[j][NumYPoints-1] = dh0xx[j][NumYPoints-1];
			h1xx[j][NumYPoints-1] = dh1xx[PrvX][NumYPoints-1];
			h3xx[j][NumYPoints-1] = dh3xx[NxtX][NumYPoints-1];
			h2xx[j][NumYPoints-1] = dh2xx[j][NumYPoints-2];
			
			h0xy[j][NumYPoints-1] = dh0xy[j][NumYPoints-1];
			h1xy[j][NumYPoints-1] = dh1xy[PrvX][NumYPoints-1];
			h3xy[j][NumYPoints-1] = dh3xy[NxtX][NumYPoints-1];
			h2xy[j][NumYPoints-1] = dh2xy[j][NumYPoints-2];
			
			h0yx[j][NumYPoints-1] = dh0yx[j][NumYPoints-1];
			h1yx[j][NumYPoints-1] = dh1yx[PrvX][NumYPoints-1];
			h3yx[j][NumYPoints-1] = dh3yx[NxtX][NumYPoints-1];
			h2yx[j][NumYPoints-1] = dh2yx[j][NumYPoints-2];
			
			h0yy[j][NumYPoints-1] = dh0yy[j][NumYPoints-1];
			h1yy[j][NumYPoints-1] = dh1yy[PrvX][NumYPoints-1];
			h3yy[j][NumYPoints-1] = dh3yy[NxtX][NumYPoints-1];
			h2yy[j][NumYPoints-1] = dh2yy[j][NumYPoints-2];
			
		}
		
		
		// Apply BC for h
		for(j=0; j<NumXPoints; j++)
		{
			
			// Do it for k=0 (BC on h2)

			h2xx[j][0] = -h4xx[j][0] + h4xxeq[j][0] + h2xxeq[j][0];

			h2xy[j][0] = -h4xy[j][0] + h4xyeq[j][0] + h2xyeq[j][0];
	
			h2yx[j][0] = -h4yx[j][0] + h4yxeq[j][0] + h2yxeq[j][0];
			
			h2yy[j][0] = -h4yy[j][0] + h4yyeq[j][0] + h2yyeq[j][0];
			
			// Do it for k=NumX_poinrsc(BC on h4)

			h4xx[j][NumYPoints-1] = -h2xx[j][NumYPoints-1] + h4xxeq[j][NumYPoints-1] + h2xxeq[j][NumYPoints-1];

			h4xy[j][NumYPoints-1] = -h2xy[j][NumYPoints-1] + h4xyeq[j][NumYPoints-1] + h2xyeq[j][NumYPoints-1];

			h4yx[j][NumYPoints-1] = -h2yx[j][NumYPoints-1] + h4yxeq[j][NumYPoints-1] + h2yxeq[j][NumYPoints-1];
			
			h4yy[j][NumYPoints-1] = -h2yy[j][NumYPoints-1] + h4yyeq[j][NumYPoints-1] + h2yyeq[j][NumYPoints-1];

		}
		
		
		
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

		
		// Now calculate A again
		
		for(i=0; i<NumXPoints; i++)
		{
			for(j=0; j<NumYPoints; j++)
			{
				Axx[i][j] = h0xx[i][j] + h1xx[i][j] + h2xx[i][j] + h3xx[i][j] + h4xx[i][j] + Gxx[i][j]/2.0;
				Ayx[i][j] = h0yx[i][j] + h1yx[i][j] + h2yx[i][j] + h3yx[i][j] + h4yx[i][j] + Gyx[i][j]/2.0;
				Axy[i][j] = h0xy[i][j] + h1xy[i][j] + h2xy[i][j] + h3xy[i][j] + h4xy[i][j] + Gxy[i][j]/2.0;
				Ayy[i][j] = h0yy[i][j] + h1yy[i][j] + h2yy[i][j] + h3yy[i][j] + h4yy[i][j] + Gyy[i][j]/2.0;
			}
		}


		
		//=========================================================================================================================
		//=========================================================================================================================
		// Record the Data
		 int q = 1; //3000;
		if( !(t/double(q)-t/q) )
		{
			
			ofstream myfile;
			myfile.open("Dataout.m", ios::app);
			myfile.precision(6);
			
			/*myfile<<"xs=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"xs=[xs; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<j<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ys=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ys=[ys; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<k<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"rho=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"rho=[rho; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<rho[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ux=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ux=[ux; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<ux[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"uy=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"uy=[uy; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<uy[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }*/
			
			
			myfile<<"V_cent = [V_cent;"<<ux[50][50]<<"];"<<endl;
			myfile<<"Time_Array = [Time_Array;"<<t*dt<<"];"<<endl;
			
			myfile.close();
		}
	}
}

char* itoa(int val, int base) {
	static char buf[32] = {0};
	int i = 30;
	if(val==0)
	{
     	buf[i]='0';
		return &buf[i];
	}
	for (; val && i; --i, val /= base)
		buf[i] = "0123456789abcdef"[val % base];
	return &buf[i+1];
}
