#include <iostream>
#include <fstream>
using namespace std;
#include <math.h>

#include "a_par.h"
#include "b_par.h"

char* itoa(int val, int base);

int main()
{
	//=======================================================================================================================================================
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	const int NumXPoints = 100;
	const int NumYPoints = 100;
	const double dx = 1.0/NumXPoints;
	
	const int i_end = 100000;
	
	
	const double T_end = .04;
	//const double Relax_Time = 1.5;
	
	const double dt = T_end*1.0/i_end;
	
	//const double b = 2.0*Re/(6.0 + Re)*c;
	
	
	//const double c_s = 1./sqrt(3.0);
	
	//const double nu_kinematic = dt/(dx*dx*Re);
	//const double Relax_Time = nu_kinematic*3.0 + 1.0/2; // dimentionless relaxation time
	
	//const double Relax_Time = 3.0/Re + 1.0/2;
	
	const double Re = .05;
	const double a = .0775;
	const beta = .6;
	
	
	const double omega = 1.25/Re*dt/T_end*(1-beta);
	const double F_term = 1000*a*dt/T_end*(1-beta);
	
	const double F_el_term = 1/3.0*dt*beta;
	
	
	//const double u_scale = dt/dx;
	
	const double phi_x = 1.0e-3;
	const double phi_y = 0.0;
	
	const double w0 = 4.0/9;
	
	const double w1 = 1.0/9;
	const double w3 = 1.0/9;
	const double w5 = 1.0/9;
	const double w7 = 1.0/9;
	
	const double w2 = 1.0/36;
	const double w4 = 1.0/36;
	const double w6 = 1.0/36;
	const double w8 = 1.0/36;
	
	const double e0x = 0;
	const double e0y = 0;
	
	const double e1x = 1.0;
	const double e1y = 0.0;
	
	const double e2x = 1.0*sqrt(2.0);
	const double e2y = 1.0*sqrt(2.0);
	
	const double e3x = 0.0;
	const double e3y = 1.0;
	
	const double e4x = -1.0*sqrt(2.0);
	const double e4y = 1.0*sqrt(2.0);
	
	const double e5x = -1.0;
	const double e5y = 0;
	
	const double e6x = -1.0*sqrt(2.0);
	const double e6y = -1.0*sqrt(2.0);
	
	const double e7x = 0;
	const double e7y = -1.0;
	
	const double e8x = 1.0*sqrt(2.0);
	const double e8y = -1.0*sqrt(2.0);
	
	int i=0, j=0, k=0;
	
	double** rho = new double*[NumXPoints];
	double** ux = new double*[NumXPoints];
	double** uy = new double*[NumXPoints];
	
	double** F_el_x = new double*[NumXPoints];
	double** F_el_y = new double*[NumXPoints];
	
	double** dux = new double*[NumXPoints];
	double** duy = new double*[NumXPoints];
	
	double** f0 = new double*[NumXPoints];
	double** f1 = new double*[NumXPoints];
	double** f2 = new double*[NumXPoints];
	double** f3 = new double*[NumXPoints];
	double** f4 = new double*[NumXPoints];
	double** f5 = new double*[NumXPoints];
	double** f6 = new double*[NumXPoints];
	double** f7 = new double*[NumXPoints];
	double** f8 = new double*[NumXPoints];
	
	double** f0eq = new double*[NumXPoints];
	double** f1eq = new double*[NumXPoints];
	double** f2eq = new double*[NumXPoints];
	double** f3eq = new double*[NumXPoints];
	double** f4eq = new double*[NumXPoints];
	double** f5eq = new double*[NumXPoints];
	double** f6eq = new double*[NumXPoints];
	double** f7eq = new double*[NumXPoints];
	double** f8eq = new double*[NumXPoints];
	
	double** df0 = new double*[NumXPoints];
	double** df1 = new double*[NumXPoints];
	double** df2 = new double*[NumXPoints];
	double** df3 = new double*[NumXPoints];
	double** df4 = new double*[NumXPoints];
	double** df5 = new double*[NumXPoints];
	double** df6 = new double*[NumXPoints];
	double** df7 = new double*[NumXPoints];
	double** df8 = new double*[NumXPoints];
	
	for(i=0; i<NumXPoints; i++)
	{
		rho[i] = new double[NumYPoints];
		ux[i] = new double[NumYPoints];
		uy[i] = new double[NumYPoints];
		
		F_el_x[i] = new double[NumYPoints];
		F_el_y[i] = new double[NumYPoints];
		
		dux[i] = new double[NumYPoints];
		duy[i] = new double[NumYPoints];
		
		f0[i] = new double[NumYPoints];
		f1[i] = new double[NumYPoints];
		f2[i] = new double[NumYPoints];
		f3[i] = new double[NumYPoints];
		f4[i] = new double[NumYPoints];
		f5[i] = new double[NumYPoints];
		f6[i] = new double[NumYPoints];
		f7[i] = new double[NumYPoints];
		f8[i] = new double[NumYPoints];
		
		f0eq[i] = new double[NumYPoints];
		f1eq[i] = new double[NumYPoints];
		f2eq[i] = new double[NumYPoints];
		f3eq[i] = new double[NumYPoints];
		f4eq[i] = new double[NumYPoints];
		f5eq[i] = new double[NumYPoints];
		f6eq[i] = new double[NumYPoints];
		f7eq[i] = new double[NumYPoints];
		f8eq[i] = new double[NumYPoints];
		
		df0[i] = new double[NumYPoints];
		df1[i] = new double[NumYPoints];
		df2[i] = new double[NumYPoints];
		df3[i] = new double[NumYPoints];
		df4[i] = new double[NumYPoints];
		df5[i] = new double[NumYPoints];
		df6[i] = new double[NumYPoints];
		df7[i] = new double[NumYPoints];
		df8[i] = new double[NumYPoints];
	}
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	for(i=0; i<NumXPoints; i++)
	{
		for(j=0; j<NumYPoints; j++)
		{
			f0[i][j] = 1.0;
			f1[i][j] = 0;
			f2[i][j] = 0;
			f3[i][j] = 0;
			f4[i][j] = 0;
			f5[i][j] = 0;
			f6[i][j] = 0;
			f7[i][j] = 0;
			f8[i][j] = 0;
			
			F_el_x[j][k] = 0;
			F_el_y[j][k] = 0;
		}
	}
	//========================================================================================================================================================
	cout << "dx = " << dx << endl;
	cout << "dt = " << dt << endl;
	cout << "O = " << omega << endl;
	cout << "F = " << F_term << endl;
	//cout << "Re = " << Re << endl << endl;
	
	
	//=========================================================================================================================
	ofstream* file = new ofstream("Dataout.m");
	
	(*file)<<"dx = "<<dx<<";"<<endl;
	(*file)<<"dt = "<<dt<<";"<<endl;
	
	(*file)<<"O = "<< omega <<";"<<endl;
	(*file)<<"F = "<< F_term <<";"<<endl;
	
	
	(*file)<<"V_cent = [];"<<endl;
	
	(*file)<<"Time_Array = [];"<<endl;
	
	
	file->close();
	delete file;
	
	//=========================================================================================================================
	
	for(i=0; i<i_end ;i++)
	{
		if( !(i/100.0-i/100) ) { cout<<"Iteration # "<<i<<endl;
		}
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		// Boundary Condition
		for(j=0; j<NumXPoints; j++)
		{
			f0[j][0] = f0[j][1];
			f1[j][0] = f5[j][1];
			f2[j][0] = f6[j][1];
			f3[j][0] = f7[j][1];
			f4[j][0] = f8[j][1];
			f5[j][0] = f1[j][1];
			f6[j][0] = f2[j][1];
			f7[j][0] = f3[j][1];
			f8[j][0] = f4[j][1];
			
			f0[j][NumYPoints-1] = f0[j][NumYPoints-1-1];
			f1[j][NumYPoints-1] = f5[j][NumYPoints-1-1];
			f2[j][NumYPoints-1] = f6[j][NumYPoints-1-1];
			f3[j][NumYPoints-1] = f7[j][NumYPoints-1-1];
			f4[j][NumYPoints-1] = f8[j][NumYPoints-1-1];
			f5[j][NumYPoints-1] = f1[j][NumYPoints-1-1];
			f6[j][NumYPoints-1] = f2[j][NumYPoints-1-1];
			f7[j][NumYPoints-1] = f3[j][NumYPoints-1-1];
			f8[j][NumYPoints-1] = f4[j][NumYPoints-1-1];
		}
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				df0[j][k] = 0;
				df1[j][k] = 0;
				df2[j][k] = 0;
				df3[j][k] = 0;
				df4[j][k] = 0;
				df5[j][k] = 0;
				df6[j][k] = 0;
				df7[j][k] = 0;
				df8[j][k] = 0;
			}
		}
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = 0;
				ux[j][k] = 0;
				uy[j][k] = 0;
				
				dux[j][k] = 0;
				duy[j][k] = 0;
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = f0[j][k]+f1[j][k]+f2[j][k]+f3[j][k]+f4[j][k]+f5[j][k]+f6[j][k]+f7[j][k]+f8[j][k];
				ux[j][k] = e1x*f1[j][k]+e2x*f2[j][k]+e3x*f3[j][k]+e4x*f4[j][k]+e5x*f5[j][k]+e6x*f6[j][k]+e7x*f7[j][k]+e8x*f8[j][k];
				uy[j][k] = e1y*f1[j][k]+e2y*f2[j][k]+e3y*f3[j][k]+e4y*f4[j][k]+e5y*f5[j][k]+e6y*f6[j][k]+e7y*f7[j][k]+e8y*f8[j][k];
				
				if( rho[j][k]!=0 )
				{
					ux[j][k] /= rho[j][k];
					uy[j][k] /= rho[j][k];
				}
				else
				{
					const double eps = 1e-4;
					
					ux[j][k] /= eps;
					uy[j][k] /= eps;
				}
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				f0eq[j][k] = w0*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e0x*ux[j][k]+e0y*uy[j][k]) + (9.0/2)*(e0x*ux[j][k]+e0y*uy[j][k])*(e0x*ux[j][k]+e0y*uy[j][k]));
				f1eq[j][k] = w1*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e1x*ux[j][k]+e1y*uy[j][k]) + (9.0/2)*(e1x*ux[j][k]+e1y*uy[j][k])*(e1x*ux[j][k]+e1y*uy[j][k]));
				f2eq[j][k] = w2*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e2x*ux[j][k]+e2y*uy[j][k]) + (9.0/2)*(e2x*ux[j][k]+e2y*uy[j][k])*(e2x*ux[j][k]+e2y*uy[j][k]));
				f3eq[j][k] = w3*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e3x*ux[j][k]+e3y*uy[j][k]) + (9.0/2)*(e3x*ux[j][k]+e3y*uy[j][k])*(e3x*ux[j][k]+e3y*uy[j][k]));
				f4eq[j][k] = w4*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e4x*ux[j][k]+e4y*uy[j][k]) + (9.0/2)*(e4x*ux[j][k]+e4y*uy[j][k])*(e4x*ux[j][k]+e4y*uy[j][k]));
				f5eq[j][k] = w5*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e5x*ux[j][k]+e5y*uy[j][k]) + (9.0/2)*(e5x*ux[j][k]+e5y*uy[j][k])*(e5x*ux[j][k]+e5y*uy[j][k]));
				f6eq[j][k] = w6*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e6x*ux[j][k]+e6y*uy[j][k]) + (9.0/2)*(e6x*ux[j][k]+e6y*uy[j][k])*(e6x*ux[j][k]+e6y*uy[j][k]));
				f7eq[j][k] = w7*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e7x*ux[j][k]+e7y*uy[j][k]) + (9.0/2)*(e7x*ux[j][k]+e7y*uy[j][k])*(e7x*ux[j][k]+e7y*uy[j][k]));
				f8eq[j][k] = w8*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e8x*ux[j][k]+e8y*uy[j][k]) + (9.0/2)*(e8x*ux[j][k]+e8y*uy[j][k])*(e8x*ux[j][k]+e8y*uy[j][k]));
			}
		}
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		/*
		 for(j=0; j<NumXPoints; j++)
		 {
		 f0eq[j][0] = f0[j][1];
		 f1eq[j][0] = f5[j][1];
		 f2eq[j][0] = f6[j][1];
		 f3eq[j][0] = f7[j][1];
		 f4eq[j][0] = f8[j][1];
		 f5eq[j][0] = f1[j][1];
		 f6eq[j][0] = f2[j][1];
		 f7eq[j][0] = f3[j][1];
		 f8eq[j][0] = f4[j][1];
		 
		 f0eq[j][NumYPoints-1] = f0[j][NumYPoints-1-1];
		 f1eq[j][NumYPoints-1] = f5[j][NumYPoints-1-1];
		 f2eq[j][NumYPoints-1] = f6[j][NumYPoints-1-1];
		 f3eq[j][NumYPoints-1] = f7[j][NumYPoints-1-1];
		 f4eq[j][NumYPoints-1] = f8[j][NumYPoints-1-1];
		 f5eq[j][NumYPoints-1] = f1[j][NumYPoints-1-1];
		 f6eq[j][NumYPoints-1] = f2[j][NumYPoints-1-1];
		 f7eq[j][NumYPoints-1] = f3[j][NumYPoints-1-1];
		 f8eq[j][NumYPoints-1] = f4[j][NumYPoints-1-1];
		 }
		 */
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		//Calculate du
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints-1);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
				int PrvY = k-1;
				int NxtY = k+1;
				
				dux[j][k] +=  w1*(ux[NxtX][k] - ux[j][k]);
				dux[j][k] +=  w2*(ux[NxtX][NxtY] - ux[j][k]);
				dux[j][k] +=  w3*(ux[j][NxtY] - ux[j][k]);
				dux[j][k] +=  w4*(ux[PrvX][NxtY] - ux[j][k]);
				dux[j][k] +=  w5*(ux[PrvX][k] - ux[j][k]);
				dux[j][k] +=  w6*(ux[PrvX][PrvY] - ux[j][k]);
				dux[j][k] +=  w7*(ux[j][PrvY] - ux[j][k]);
				dux[j][k] +=  w8*(ux[NxtX][PrvY] - ux[j][k]);
				
				
				duy[j][k] +=  w1*(uy[NxtX][k] - uy[j][k]);
				duy[j][k] +=  w2*(uy[NxtX][NxtY] - uy[j][k]);
				duy[j][k] +=  w3*(uy[j][NxtY] - uy[j][k]);
				duy[j][k] +=  w4*(uy[PrvX][NxtY] - uy[j][k]);
				duy[j][k] +=  w5*(uy[PrvX][k] - uy[j][k]);
				duy[j][k] +=  w6*(uy[PrvX][PrvY] - uy[j][k]);
				duy[j][k] +=  w7*(uy[j][PrvY] - uy[j][k]);
				duy[j][k] +=  w8*(uy[NxtX][PrvY] - uy[j][k]);
				
			}
		}
		
		
		// Calculate 
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				F_el_x[j][k] += dt*dux[j][k]*mu/tau - dt*1.0/tau*F_el_x[j][k];
				F_el_y[j][k] += dt*duy[j][k]*mu/tau - dt*1.0/tau*F_el_y[j][k];
				
			}
		}
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints-1);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
				int PrvY = k-1;
				int NxtY = k+1;
				
				df0[j][k] = f0[j]   [k] -    omega*(f0[j][k] -     f0eq[j][k]);
				df1[j][k] = f1[PrvX][k] -    omega*(f1[PrvX][k]-   f1eq[PrvX][k]);
				df2[j][k] = f2[PrvX][PrvY] - omega*(f2[PrvX][PrvY]-f2eq[PrvX][PrvY]);
				df3[j][k] = f3[j]   [PrvY] - omega*(f3[j][PrvY]-   f3eq[j][PrvY]);
				df4[j][k] = f4[NxtX][PrvY] - omega*(f4[NxtX][PrvY]-f4eq[NxtX][PrvY]);
				df5[j][k] = f5[NxtX][k] -    omega*(f5[NxtX][k]-   f5eq[NxtX][k]);
				df6[j][k] = f6[NxtX][NxtY] - omega*(f6[NxtX][NxtY]-f6eq[NxtX][NxtY]);
				df7[j][k] = f7[j]   [NxtY] - omega*(f7[j][NxtY]-   f7eq[j][NxtY]);
				df8[j][k] = f8[PrvX][NxtY] - omega*(f8[PrvX][NxtY]-f8eq[PrvX][NxtY]);
				
				
				//Now add the force
				df1[j][k] += ( phi_x*(e1x - ux[j][k]) + phi_y*(e1y - uy[j][k]) )*F_term*3.0*f1eq[j][k];
				df2[j][k] += ( phi_x*(e2x - ux[j][k]) + phi_y*(e2y - uy[j][k]) )*F_term*3.0*f2eq[j][k];
				df3[j][k] += ( phi_x*(e3x - ux[j][k]) + phi_y*(e3y - uy[j][k]) )*F_term*3.0*f3eq[j][k];
				df4[j][k] += ( phi_x*(e4x - ux[j][k]) + phi_y*(e4y - uy[j][k]) )*F_term*3.0*f4eq[j][k];
				df5[j][k] += ( phi_x*(e5x - ux[j][k]) + phi_y*(e5y - uy[j][k]) )*F_term*3.0*f5eq[j][k];
				df6[j][k] += ( phi_x*(e6x - ux[j][k]) + phi_y*(e6y - uy[j][k]) )*F_term*3.0*f6eq[j][k];
				df7[j][k] += ( phi_x*(e7x - ux[j][k]) + phi_y*(e7y - uy[j][k]) )*F_term*3.0*f7eq[j][k];
				df8[j][k] += ( phi_x*(e8x - ux[j][k]) + phi_y*(e8y - uy[j][k]) )*F_term*3.0*f8eq[j][k];
				/*
				 df1[j][k] += ( phi_x*e1x + phi_y*e1y )*F_term;
				 df2[j][k] += ( phi_x*e2x + phi_y*e2y )*F_term;
				 df3[j][k] += ( phi_x*e3x + phi_y*e3y )*F_term;
				 df4[j][k] += ( phi_x*e4x + phi_y*e4y )*F_term;
				 df5[j][k] += ( phi_x*e5x + phi_y*e5y )*F_term;
				 df6[j][k] += ( phi_x*e6x + phi_y*e6y )*F_term;
				 df7[j][k] += ( phi_x*e7x + phi_y*e7y )*F_term;
				 df8[j][k] += ( phi_x*e8x + phi_y*e8y )*F_term;
				 */
				
				// Now add elasticity
				df0[j][k] += F_el_term*(e0x*F_el_x[j][k] + e0y*F_el_y[j][k]);
				df1[j][k] += F_el_term*(e1x*F_el_x[j][k] + e1y*F_el_y[j][k]);
				df2[j][k] += F_el_term*(e2x*F_el_x[j][k] + e2y*F_el_y[j][k]);
				df3[j][k] += F_el_term*(e3x*F_el_x[j][k] + e3y*F_el_y[j][k]);
				df4[j][k] += F_el_term*(e4x*F_el_x[j][k] + e4y*F_el_y[j][k]);
				df5[j][k] += F_el_term*(e5x*F_el_x[j][k] + e5y*F_el_y[j][k]);
				df6[j][k] += F_el_term*(e6x*F_el_x[j][k] + e6y*F_el_y[j][k]);
				df7[j][k] += F_el_term*(e7x*F_el_x[j][k] + e7y*F_el_y[j][k]);
				df8[j][k] += F_el_term*(e8x*F_el_x[j][k] + e8y*F_el_y[j][k]);
				
				
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				f0[j][k] = df0[j][k];
				f1[j][k] = df1[j][k];
				f2[j][k] = df2[j][k];
				f3[j][k] = df3[j][k];
				f4[j][k] = df4[j][k];
				f5[j][k] = df5[j][k];
				f6[j][k] = df6[j][k];
				f7[j][k] = df7[j][k];
				f8[j][k] = df8[j][k];
			}
		}
		
		
		//=========================================================================================================================
		//=========================================================================================================================
		// Record the Data
		int q = 100; //3000;
		if( !(i/double(q)-i/q) )
		{
			
			ofstream myfile;
			myfile.open("Dataout.m", ios::app);
			myfile.precision(6);
			
			/*myfile<<"xs=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"xs=[xs; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<j<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ys=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ys=[ys; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<k<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"rho=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"rho=[rho; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<rho[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ux=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ux=[ux; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<ux[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"uy=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"uy=[uy; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<uy[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }*/
			
			
			myfile<<"V_cent = [V_cent;"<<ux[30][50]<<"];"<<endl;
			myfile<<"Time_Array = [Time_Array;"<<i*dt<<"];"<<endl;
			
			myfile.close();
		}
	}
}

char* itoa(int val, int base) {
	static char buf[32] = {0};
	int i = 30;
	if(val==0)
	{
     	buf[i]='0';
		return &buf[i];
	}
	for (; val && i; --i, val /= base)
		buf[i] = "0123456789abcdef"[val % base];
	return &buf[i+1];
}
