#include <iostream>
#include <fstream>
using namespace std;
#include <math.h>


char* itoa(int val, int base);

int main()
{
	//=======================================================================================================================================================
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	const int NumXPoints = 100;
	const int NumYPoints = 100;
	const double dx = 1.0/NumXPoints;
	
	const int i_end = 100000;
	
	
	const double T_end = .04;
	
	const double dt = T_end*1.0/i_end;
	
	const double Re = .05;
	const double a = .0775;
	
	const double mu_p = 0.0;
	const double lambda = 1.0;
	
	const double c_el = 1.0/sqrt(3.0);
	
	
	const double omega = 1.25e0/Re*dt/T_end;
	const double F_term = 1.0*a*dt/T_end;
	
	const double omega_el = 1.0e4*dt/T_end;
	
	
	//const double u_scale = dt/dx;
	
	const double phi_x = 1.0e-3;
	const double phi_y = 0.0;
	
	const double w0 = 4.0/9;
	
	const double w1 = 1.0/9;
	const double w3 = 1.0/9;
	const double w5 = 1.0/9;
	const double w7 = 1.0/9;
	
	const double w2 = 1.0/36;
	const double w4 = 1.0/36;
	const double w6 = 1.0/36;
	const double w8 = 1.0/36;
	
	const double w0_el = 1.0 - 2.0*c_el*c_el;
	const double w1_el = c_el*c_el/2.0;
	const double w2_el = c_el*c_el/2.0;
	const double w3_el = c_el*c_el/2.0;
	const double w4_el = c_el*c_el/2.0;
	
	const double e0x = 0;
	const double e0y = 0;
	
	const double e1x = 1.0;
	const double e1y = 0.0;
	
	const double e2x = 1.0*sqrt(2.0);
	const double e2y = 1.0*sqrt(2.0);
	
	const double e3x = 0.0;
	const double e3y = 1.0;
	
	const double e4x = -1.0*sqrt(2.0);
	const double e4y = 1.0*sqrt(2.0);
	
	const double e5x = -1.0;
	const double e5y = 0;
	
	const double e6x = -1.0*sqrt(2.0);
	const double e6y = -1.0*sqrt(2.0);
	
	const double e7x = 0;
	const double e7y = -1.0;
	
	const double e8x = 1.0*sqrt(2.0);
	const double e8y = -1.0*sqrt(2.0);
	
	int i=0, j=0, k=0, t=0, Nxt, Prv;
	
	double** rho = new double*[NumXPoints];
	double** ux = new double*[NumXPoints];
	double** uy = new double*[NumXPoints];
	
	double** ux_x = new double*[NumXPoints];
	double** uy_x = new double*[NumXPoints];
	double** ux_y = new double*[NumXPoints];
	double** uy_y = new double*[NumXPoints];
	
	double** Axx = new double*[NumXPoints];
	double** Axy = new double*[NumXPoints];
	double** Ayx = new double*[NumXPoints];
	double** Ayy = new double*[NumXPoints];
	
	double** Axx_x = new double*[NumXPoints];
	double** Ayx_x = new double*[NumXPoints];
	double** Axy_y = new double*[NumXPoints];
	double** Ayy_y = new double*[NumXPoints];
	
	double** Gxx = new double*[NumXPoints];
	double** Gxy = new double*[NumXPoints];
	double** Gyx = new double*[NumXPoints];
	double** Gyy = new double*[NumXPoints];
	
	double** GAxx = new double*[NumXPoints];
	double** GAxy = new double*[NumXPoints];
	double** GAyx = new double*[NumXPoints];
	double** GAyy = new double*[NumXPoints];
	
	double** f0 = new double*[NumXPoints];
	double** f1 = new double*[NumXPoints];
	double** f2 = new double*[NumXPoints];
	double** f3 = new double*[NumXPoints];
	double** f4 = new double*[NumXPoints];
	double** f5 = new double*[NumXPoints];
	double** f6 = new double*[NumXPoints];
	double** f7 = new double*[NumXPoints];
	double** f8 = new double*[NumXPoints];
	
	double** h0xx = new double*[NumXPoints];
	double** h1xx = new double*[NumXPoints];
	double** h2xx = new double*[NumXPoints];
	double** h3xx = new double*[NumXPoints];
	double** h4xx = new double*[NumXPoints];
	double** h0yx = new double*[NumXPoints];
	double** h1yx = new double*[NumXPoints];
	double** h2yx = new double*[NumXPoints];
	double** h3yx = new double*[NumXPoints];
	double** h4yx = new double*[NumXPoints];
	double** h0xy = new double*[NumXPoints];
	double** h1xy = new double*[NumXPoints];
	double** h2xy = new double*[NumXPoints];
	double** h3xy = new double*[NumXPoints];
	double** h4xy = new double*[NumXPoints];
	double** h0yy = new double*[NumXPoints];
	double** h1yy = new double*[NumXPoints];
	double** h2yy = new double*[NumXPoints];
	double** h3yy = new double*[NumXPoints];
	double** h4yy = new double*[NumXPoints];
	
	double** dh0xx = new double*[NumXPoints];
	double** dh1xx = new double*[NumXPoints];
	double** dh2xx = new double*[NumXPoints];
	double** dh3xx = new double*[NumXPoints];
	double** dh4xx = new double*[NumXPoints];
	double** dh0yx = new double*[NumXPoints];
	double** dh1yx = new double*[NumXPoints];
	double** dh2yx = new double*[NumXPoints];
	double** dh3yx = new double*[NumXPoints];
	double** dh4yx = new double*[NumXPoints];
	double** dh0xy = new double*[NumXPoints];
	double** dh1xy = new double*[NumXPoints];
	double** dh2xy = new double*[NumXPoints];
	double** dh3xy = new double*[NumXPoints];
	double** dh4xy = new double*[NumXPoints];
	double** dh0yy = new double*[NumXPoints];
	double** dh1yy = new double*[NumXPoints];
	double** dh2yy = new double*[NumXPoints];
	double** dh3yy = new double*[NumXPoints];
	double** dh4yy = new double*[NumXPoints];
	
	double** h0xxeq = new double*[NumXPoints];
	double** h1xxeq = new double*[NumXPoints];
	double** h2xxeq = new double*[NumXPoints];
	double** h3xxeq = new double*[NumXPoints];
	double** h4xxeq = new double*[NumXPoints];
	double** h0yxeq = new double*[NumXPoints];
	double** h1yxeq = new double*[NumXPoints];
	double** h2yxeq = new double*[NumXPoints];
	double** h3yxeq = new double*[NumXPoints];
	double** h4yxeq = new double*[NumXPoints];
	double** h0xyeq = new double*[NumXPoints];
	double** h1xyeq = new double*[NumXPoints];
	double** h2xyeq = new double*[NumXPoints];
	double** h3xyeq = new double*[NumXPoints];
	double** h4xyeq = new double*[NumXPoints];
	double** h0yyeq = new double*[NumXPoints];
	double** h1yyeq = new double*[NumXPoints];
	double** h2yyeq = new double*[NumXPoints];
	double** h3yyeq = new double*[NumXPoints];
	double** h4yyeq = new double*[NumXPoints];
	
	double** f0eq = new double*[NumXPoints];
	double** f1eq = new double*[NumXPoints];
	double** f2eq = new double*[NumXPoints];
	double** f3eq = new double*[NumXPoints];
	double** f4eq = new double*[NumXPoints];
	double** f5eq = new double*[NumXPoints];
	double** f6eq = new double*[NumXPoints];
	double** f7eq = new double*[NumXPoints];
	double** f8eq = new double*[NumXPoints];
	
	double** df0 = new double*[NumXPoints];
	double** df1 = new double*[NumXPoints];
	double** df2 = new double*[NumXPoints];
	double** df3 = new double*[NumXPoints];
	double** df4 = new double*[NumXPoints];
	double** df5 = new double*[NumXPoints];
	double** df6 = new double*[NumXPoints];
	double** df7 = new double*[NumXPoints];
	double** df8 = new double*[NumXPoints];
	
	for(i=0; i<NumXPoints; i++)
	{
		rho[i] = new double[NumYPoints];
		ux[i] = new double[NumYPoints];
		uy[i] = new double[NumYPoints];
		
		ux_x[i] = new double[NumYPoints];
		uy_x[i] = new double[NumYPoints];
		ux_y[i] = new double[NumYPoints];
		uy_y[i] = new double[NumYPoints];
		
		Axx[i] = new double[NumYPoints];
		Ayx[i] = new double[NumYPoints];
		Axy[i] = new double[NumYPoints];
		Ayy[i] = new double[NumYPoints];
		
		Axx_x[i] = new double[NumYPoints];
		Ayx_x[i] = new double[NumYPoints];
		Axy_y[i] = new double[NumYPoints];
		Ayy_y[i] = new double[NumYPoints];
		
		Gxx[i] = new double[NumYPoints];
		Gyx[i] = new double[NumYPoints];
		Gxy[i] = new double[NumYPoints];
		Gyy[i] = new double[NumYPoints];
		
		GAxx[i] = new double[NumYPoints];
		GAyx[i] = new double[NumYPoints];
		GAxy[i] = new double[NumYPoints];
		GAyy[i] = new double[NumYPoints];
		
		h0xx[i] = new double[NumYPoints];
		h1xx[i] = new double[NumYPoints];
		h2xx[i] = new double[NumYPoints];
		h3xx[i] = new double[NumYPoints];
		h4xx[i] = new double[NumYPoints];
		h0yx[i] = new double[NumYPoints];
		h1yx[i] = new double[NumYPoints];
		h2yx[i] = new double[NumYPoints];
		h3yx[i] = new double[NumYPoints];
		h4yx[i] = new double[NumYPoints];
		h0xy[i] = new double[NumYPoints];
		h1xy[i] = new double[NumYPoints];
		h2xy[i] = new double[NumYPoints];
		h3xy[i] = new double[NumYPoints];
		h4xy[i] = new double[NumYPoints];
		h0yy[i] = new double[NumYPoints];
		h1yy[i] = new double[NumYPoints];
		h2yy[i] = new double[NumYPoints];
		h3yy[i] = new double[NumYPoints];
		h4yy[i] = new double[NumYPoints];
		
		dh0xx[i] = new double[NumYPoints];
		dh1xx[i] = new double[NumYPoints];
		dh2xx[i] = new double[NumYPoints];
		dh3xx[i] = new double[NumYPoints];
		dh4xx[i] = new double[NumYPoints];
		dh0yx[i] = new double[NumYPoints];
		dh1yx[i] = new double[NumYPoints];
		dh2yx[i] = new double[NumYPoints];
		dh3yx[i] = new double[NumYPoints];
		dh4yx[i] = new double[NumYPoints];
		dh0xy[i] = new double[NumYPoints];
		dh1xy[i] = new double[NumYPoints];
		dh2xy[i] = new double[NumYPoints];
		dh3xy[i] = new double[NumYPoints];
		dh4xy[i] = new double[NumYPoints];
		dh0yy[i] = new double[NumYPoints];
		dh1yy[i] = new double[NumYPoints];
		dh2yy[i] = new double[NumYPoints];
		dh3yy[i] = new double[NumYPoints];
		dh4yy[i] = new double[NumYPoints];
		
		h0xxeq[i] = new double[NumYPoints];
		h1xxeq[i] = new double[NumYPoints];
		h2xxeq[i] = new double[NumYPoints];
		h3xxeq[i] = new double[NumYPoints];
		h4xxeq[i] = new double[NumYPoints];
		h0yxeq[i] = new double[NumYPoints];
		h1yxeq[i] = new double[NumYPoints];
		h2yxeq[i] = new double[NumYPoints];
		h3yxeq[i] = new double[NumYPoints];
		h4yxeq[i] = new double[NumYPoints];
		h0xyeq[i] = new double[NumYPoints];
		h1xyeq[i] = new double[NumYPoints];
		h2xyeq[i] = new double[NumYPoints];
		h3xyeq[i] = new double[NumYPoints];
		h4xyeq[i] = new double[NumYPoints];
		h0yyeq[i] = new double[NumYPoints];
		h1yyeq[i] = new double[NumYPoints];
		h2yyeq[i] = new double[NumYPoints];
		h3yyeq[i] = new double[NumYPoints];
		h4yyeq[i] = new double[NumYPoints];
		
		
		f0[i] = new double[NumYPoints];
		f1[i] = new double[NumYPoints];
		f2[i] = new double[NumYPoints];
		f3[i] = new double[NumYPoints];
		f4[i] = new double[NumYPoints];
		f5[i] = new double[NumYPoints];
		f6[i] = new double[NumYPoints];
		f7[i] = new double[NumYPoints];
		f8[i] = new double[NumYPoints];
		
		f0eq[i] = new double[NumYPoints];
		f1eq[i] = new double[NumYPoints];
		f2eq[i] = new double[NumYPoints];
		f3eq[i] = new double[NumYPoints];
		f4eq[i] = new double[NumYPoints];
		f5eq[i] = new double[NumYPoints];
		f6eq[i] = new double[NumYPoints];
		f7eq[i] = new double[NumYPoints];
		f8eq[i] = new double[NumYPoints];
		
		df0[i] = new double[NumYPoints];
		df1[i] = new double[NumYPoints];
		df2[i] = new double[NumYPoints];
		df3[i] = new double[NumYPoints];
		df4[i] = new double[NumYPoints];
		df5[i] = new double[NumYPoints];
		df6[i] = new double[NumYPoints];
		df7[i] = new double[NumYPoints];
		df8[i] = new double[NumYPoints];
	}
	//========================================================================================================================================================
	
	//========================================================================================================================================================
	//
	for(i=0; i<NumXPoints; i++)
	{
		for(j=0; j<NumYPoints; j++)
		{
			f0[i][j] = 1.0;
			f1[i][j] = 0;
			f2[i][j] = 0;
			f3[i][j] = 0;
			f4[i][j] = 0;
			f5[i][j] = 0;
			f6[i][j] = 0;
			f7[i][j] = 0;
			f8[i][j] = 0;
			
			h0xx[i][j] = 1.0;
			h1xx[i][j] = 0;
			h2xx[i][j] = 0;
			h3xx[i][j] = 0;
			h4xx[i][j] = 0;
			h0yx[i][j] = 1.0;
			h1yx[i][j] = 0;
			h2yx[i][j] = 0;
			h3yx[i][j] = 0;
			h4yx[i][j] = 0;
			h0xy[i][j] = 1.0;
			h1xy[i][j] = 0;
			h2xy[i][j] = 0;
			h3xy[i][j] = 0;
			h4xy[i][j] = 0;
			h0yy[i][j] = 1.0;
			h1yy[i][j] = 0;
			h2yy[i][j] = 0;
			h3yy[i][j] = 0;
			h4yy[i][j] = 0;
			
			Axx[i][j] = 1;
			Axy[i][j] = 0;
			Ayx[i][j] = 0;
			Ayy[i][j] = 1;
			
			
			
		}
	}
	//========================================================================================================================================================
	cout << "dx = " << dx << endl;
	cout << "dt = " << dt << endl;
	cout << "O = " << omega << endl;
	cout << "F = " << F_term << endl;
	//cout << "Re = " << Re << endl << endl;
	
	
	//=========================================================================================================================
	ofstream* file = new ofstream("Dataout.m");
	
	(*file)<<"dx = "<<dx<<";"<<endl;
	(*file)<<"dt = "<<dt<<";"<<endl;
	
	(*file)<<"i_end = "<< i_end <<";"<<endl;
	(*file)<<"T_end = "<< T_end <<";"<<endl;
	
	(*file)<<"O = "<< omega <<";"<<endl;
	(*file)<<"F = "<< F_term <<";"<<endl;
	
	(*file)<<"Re = "<< Re <<";"<<endl;
	(*file)<<"a = "<< a <<";"<<endl;
	
	(*file)<<"mu_p = "<< mu_p <<";"<<endl;
	(*file)<<"lambda = "<< lambda <<";"<<endl;
	(*file)<<"omega_el = "<< omega_el <<";"<<endl;
	
	
	(*file)<<"V_cent = [];"<<endl;
	
	(*file)<<"Time_Array = [];"<<endl;
	
	
	file->close();
	delete file;
	
	//=========================================================================================================================
	
	for(t=0; t<i_end;t++)
	{
		if( !(t/100.0-t/100) ) { 
			cout<<"Iteration # "<<t<<endl;
			cout<<"V_cent = "<<ux[30][50]<<endl;
		}
		
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		// Boundary Condition
		for(j=0; j<NumXPoints; j++)
		{
			f0[j][0] = f0[j][1];
			f1[j][0] = f5[j][1];
			f2[j][0] = f6[j][1];
			f3[j][0] = f7[j][1];
			f4[j][0] = f8[j][1];
			f5[j][0] = f1[j][1];
			f6[j][0] = f2[j][1];
			f7[j][0] = f3[j][1];
			f8[j][0] = f4[j][1];
			
			h0xx[j][0] = h0xx[j][1];
			h1xx[j][0] = h3xx[j][1];
			h2xx[j][0] = h4xx[j][1];
			h4xx[j][0] = h2xx[j][1];
			h3xx[j][0] = h1xx[j][1];
			
			h0xy[j][0] = h0xy[j][1];
			h1xy[j][0] = h3xy[j][1];
			h2xy[j][0] = h4xy[j][1];
			h4xy[j][0] = h2xy[j][1];
			h3xy[j][0] = h1xy[j][1];
			
			h0yx[j][0] = h0yx[j][1];
			h1yx[j][0] = h3yx[j][1];
			h2yx[j][0] = h4yx[j][1];
			h4yx[j][0] = h2yx[j][1];
			h3yx[j][0] = h1yx[j][1];
			
			h0yy[j][0] = h0yy[j][1];
			h1yy[j][0] = h3yy[j][1];
			h2yy[j][0] = h4yy[j][1];
			h4yy[j][0] = h2yy[j][1];
			h3yy[j][0] = h1yy[j][1];
			
			f0[j][NumYPoints-1] = f0[j][NumYPoints-1-1];
			f1[j][NumYPoints-1] = f5[j][NumYPoints-1-1];
			f2[j][NumYPoints-1] = f6[j][NumYPoints-1-1];
			f3[j][NumYPoints-1] = f7[j][NumYPoints-1-1];
			f4[j][NumYPoints-1] = f8[j][NumYPoints-1-1];
			f5[j][NumYPoints-1] = f1[j][NumYPoints-1-1];
			f6[j][NumYPoints-1] = f2[j][NumYPoints-1-1];
			f7[j][NumYPoints-1] = f3[j][NumYPoints-1-1];
			f8[j][NumYPoints-1] = f4[j][NumYPoints-1-1];
			
			h0xx[j][NumYPoints-1] = h0xx[j][NumYPoints-1-1];
			h1xx[j][NumYPoints-1] = h3xx[j][NumYPoints-1-1];
			h2xx[j][NumYPoints-1] = h4xx[j][NumYPoints-1-1];
			h4xx[j][NumYPoints-1] = h2xx[j][NumYPoints-1-1];
			h3xx[j][NumYPoints-1] = h1xx[j][NumYPoints-1-1];
			
			h0xy[j][NumYPoints-1] = h0xy[j][NumYPoints-1-1];
			h1xy[j][NumYPoints-1] = h3xy[j][NumYPoints-1-1];
			h2xy[j][NumYPoints-1] = h4xy[j][NumYPoints-1-1];
			h4xy[j][NumYPoints-1] = h2xy[j][NumYPoints-1-1];
			h3xy[j][NumYPoints-1] = h1xy[j][NumYPoints-1-1];
			
			h0yx[j][NumYPoints-1] = h0yx[j][NumYPoints-1-1];
			h1yx[j][NumYPoints-1] = h3yx[j][NumYPoints-1-1];
			h2yx[j][NumYPoints-1] = h4yx[j][NumYPoints-1-1];
			h4yx[j][NumYPoints-1] = h2yx[j][NumYPoints-1-1];
			h3yx[j][NumYPoints-1] = h1yx[j][NumYPoints-1-1];
			
			h0yy[j][NumYPoints-1] = h0yy[j][NumYPoints-1-1];
			h1yy[j][NumYPoints-1] = h3yy[j][NumYPoints-1-1];
			h2yy[j][NumYPoints-1] = h4yy[j][NumYPoints-1-1];
			h4yy[j][NumYPoints-1] = h2yy[j][NumYPoints-1-1];
			h3yy[j][NumYPoints-1] = h1yy[j][NumYPoints-1-1];
		}
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				df0[j][k] = 0;
				df1[j][k] = 0;
				df2[j][k] = 0;
				df3[j][k] = 0;
				df4[j][k] = 0;
				df5[j][k] = 0;
				df6[j][k] = 0;
				df7[j][k] = 0;
				df8[j][k] = 0;
				
				dh0xx[j][k] = 0;
				dh1xx[j][k] = 0;
				dh2xx[j][k] = 0;
				dh3xx[j][k] = 0;
				dh4xx[j][k] = 0;
				
				dh0yx[j][k] = 0;
				dh1yx[j][k] = 0;
				dh2yx[j][k] = 0;
				dh3yx[j][k] = 0;
				dh4yx[j][k] = 0;
				
				dh0xy[j][k] = 0;
				dh1xy[j][k] = 0;
				dh2xy[j][k] = 0;
				dh3xy[j][k] = 0;
				dh4xy[j][k] = 0;
				
				dh0yy[j][k] = 0;
				dh1yy[j][k] = 0;
				dh2yy[j][k] = 0;
				dh3yy[j][k] = 0;
				dh4yy[j][k] = 0;
				
				Gxx[j][k] = 0;
				Gxy[j][k] = 0;
				Gyx[j][k] = 0;
				Gyy[j][k] = 0;
			}
		}
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		
		
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				f0eq[j][k] = w0*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e0x*ux[j][k]+e0y*uy[j][k]) + (9.0/2)*(e0x*ux[j][k]+e0y*uy[j][k])*(e0x*ux[j][k]+e0y*uy[j][k]));
				f1eq[j][k] = w1*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e1x*ux[j][k]+e1y*uy[j][k]) + (9.0/2)*(e1x*ux[j][k]+e1y*uy[j][k])*(e1x*ux[j][k]+e1y*uy[j][k]));
				f2eq[j][k] = w2*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e2x*ux[j][k]+e2y*uy[j][k]) + (9.0/2)*(e2x*ux[j][k]+e2y*uy[j][k])*(e2x*ux[j][k]+e2y*uy[j][k]));
				f3eq[j][k] = w3*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e3x*ux[j][k]+e3y*uy[j][k]) + (9.0/2)*(e3x*ux[j][k]+e3y*uy[j][k])*(e3x*ux[j][k]+e3y*uy[j][k]));
				f4eq[j][k] = w4*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e4x*ux[j][k]+e4y*uy[j][k]) + (9.0/2)*(e4x*ux[j][k]+e4y*uy[j][k])*(e4x*ux[j][k]+e4y*uy[j][k]));
				f5eq[j][k] = w5*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e5x*ux[j][k]+e5y*uy[j][k]) + (9.0/2)*(e5x*ux[j][k]+e5y*uy[j][k])*(e5x*ux[j][k]+e5y*uy[j][k]));
				f6eq[j][k] = w6*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e6x*ux[j][k]+e6y*uy[j][k]) + (9.0/2)*(e6x*ux[j][k]+e6y*uy[j][k])*(e6x*ux[j][k]+e6y*uy[j][k]));
				f7eq[j][k] = w7*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e7x*ux[j][k]+e7y*uy[j][k]) + (9.0/2)*(e7x*ux[j][k]+e7y*uy[j][k])*(e7x*ux[j][k]+e7y*uy[j][k]));
				f8eq[j][k] = w8*rho[j][k]*(1.0 - (3.0/2)*(ux[j][k]*ux[j][k]+uy[j][k]*uy[j][k]) + (3.0)*(e8x*ux[j][k]+e8y*uy[j][k]) + (9.0/2)*(e8x*ux[j][k]+e8y*uy[j][k])*(e8x*ux[j][k]+e8y*uy[j][k]));
			}
		}
		
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		// Calculate divergence of A
		
		// X derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				Prv = i-1;
				if (Prv < 0)
					Prv += NumXPoints;
				Nxt = i+1;
				if (Nxt > (NumXPoints-1)) 
					Nxt -= NumXPoints;
				
				Axx_x[i][j] = (Axx[Nxt][j] - Axx[Prv][j])/2.0;
				Ayx_x[i][j] = (Ayx[Nxt][j] - Ayx[Prv][j])/2.0;
				
			}
		}
		
		
		// Y direction
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				Axy_y[i][j] = (Axy[i][j+1] - Axy[i][j-1])/2.0;
				Ayy_y[i][j] = (Ayy[i][j+1] - Ayy[i][j-1])/2.0;
				
			}
		}
		
		cout<<"Iteration # "<<t;
		cout<<"    V_cent = "<<ux[30][50]<<endl;
		//cout<<"D of A = " << Axx_x[30][50] << "  "<< Ayx_x[30][50] << "    "<<Axy_y[30][50] << "   " << Ayy_y[30][50]<<endl;
		
		//---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints-1);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
				int PrvY = k-1;
				int NxtY = k+1;
				
				df0[j][k] = f0[j]   [k] -    omega*(f0[j][k] -     f0eq[j][k]);
				df1[j][k] = f1[PrvX][k] -    omega*(f1[PrvX][k]-   f1eq[PrvX][k]);
				df2[j][k] = f2[PrvX][PrvY] - omega*(f2[PrvX][PrvY]-f2eq[PrvX][PrvY]);
				df3[j][k] = f3[j]   [PrvY] - omega*(f3[j][PrvY]-   f3eq[j][PrvY]);
				df4[j][k] = f4[NxtX][PrvY] - omega*(f4[NxtX][PrvY]-f4eq[NxtX][PrvY]);
				df5[j][k] = f5[NxtX][k] -    omega*(f5[NxtX][k]-   f5eq[NxtX][k]);
				df6[j][k] = f6[NxtX][NxtY] - omega*(f6[NxtX][NxtY]-f6eq[NxtX][NxtY]);
				df7[j][k] = f7[j]   [NxtY] - omega*(f7[j][NxtY]-   f7eq[j][NxtY]);
				df8[j][k] = f8[PrvX][NxtY] - omega*(f8[PrvX][NxtY]-f8eq[PrvX][NxtY]);
				
				// Now we add the force
				
				df0[j][k] += F_term*w0*((e0x - ux[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0x)*(phi_x*rho[j][k] + mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				df0[j][k] += F_term*w0*((e0y - uy[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0y)*(phi_y*rho[j][k] + mu_p/lambda*(Ayx_x[j][k] + Ayy_y[j][k]));
				
				df1[j][k] += F_term*w1*((e1x - ux[PrvX][k])*3.0 - 9.0*(e1x*ux[PrvX][k] + e1y*uy[PrvX][k])*e1x)*(phi_x*rho[PrvX][k] + mu_p/lambda*(Axx_x[PrvX][k] + Axy_y[PrvX][k]));
				df1[j][k] += F_term*w1*((e1y - uy[PrvX][k])*3.0 - 9.0*(e1x*ux[PrvX][k] + e1y*uy[PrvX][k])*e1y)*(phi_y*rho[PrvX][k] + mu_p/lambda*(Ayx_x[PrvX][k] + Ayy_y[PrvX][k]));
				
				df2[j][k] += F_term*w2*((e2x - ux[PrvX][PrvY])*3.0 - 9.0*(e2x*ux[PrvX][PrvY] + e2y*uy[PrvX][PrvY])*e2x)*(phi_x*rho[PrvX][PrvY] + mu_p/lambda*(Axx_x[PrvX][PrvY] + Axy_y[PrvX][PrvY]));
				df2[j][k] += F_term*w2*((e2y - uy[PrvX][PrvY])*3.0 - 9.0*(e2x*ux[PrvX][PrvY] + e2y*uy[PrvX][PrvY])*e2y)*(phi_y*rho[PrvX][PrvY] + mu_p/lambda*(Ayx_x[PrvX][PrvY] + Ayy_y[PrvX][PrvY]));
				
				df3[j][k] += F_term*w3*((e3x - ux[j][PrvY])*3.0 - 9.0*(e3x*ux[j][PrvY] + e3y*uy[j][PrvY])*e3x)*(phi_x*rho[j][PrvY] + mu_p/lambda*(Axx_x[j][PrvY] + Axy_y[j][PrvY]));
				df3[j][k] += F_term*w3*((e3y - uy[j][PrvY])*3.0 - 9.0*(e3x*ux[j][PrvY] + e3y*uy[j][PrvY])*e3y)*(phi_y*rho[j][PrvY] + mu_p/lambda*(Ayx_x[j][PrvY] + Ayy_y[j][PrvY]));
				
				df4[j][k] += F_term*w4*((e4x - ux[NxtX][PrvY])*3.0 - 9.0*(e4x*ux[NxtX][PrvY] + e4y*uy[NxtX][PrvY])*e4x)*(phi_x*rho[NxtX][PrvY] + mu_p/lambda*(Axx_x[NxtX][PrvY] + Axy_y[NxtX][PrvY]));
				df4[j][k] += F_term*w4*((e4y - uy[NxtX][PrvY])*3.0 - 9.0*(e4x*ux[NxtX][PrvY] + e4y*uy[NxtX][PrvY])*e4y)*(phi_y*rho[NxtX][PrvY] + mu_p/lambda*(Ayx_x[NxtX][PrvY] + Ayy_y[NxtX][PrvY]));
				
				df5[j][k] += F_term*w5*((e5x - ux[NxtX][k])*3.0 - 9.0*(e5x*ux[NxtX][k] + e5y*uy[NxtX][k])*e5x)*(phi_x*rho[NxtX][k] + mu_p/lambda*(Axx_x[NxtX][k] + Axy_y[NxtX][k]));
				df5[j][k] += F_term*w5*((e5y - uy[NxtX][k])*3.0 - 9.0*(e5x*ux[NxtX][k] + e5y*uy[NxtX][k])*e5y)*(phi_y*rho[NxtX][k] + mu_p/lambda*(Ayx_x[NxtX][k] + Ayy_y[NxtX][k]));
				
				df6[j][k] += F_term*w6*((e6x - ux[NxtX][NxtY])*3.0 - 9.0*(e6x*ux[NxtX][NxtY] + e6y*uy[NxtX][NxtY])*e6x)*(phi_x*rho[NxtX][NxtY] + mu_p/lambda*(Axx_x[NxtX][NxtY] + Axy_y[NxtX][NxtY]));
				df6[j][k] += F_term*w6*((e6y - uy[NxtX][NxtY])*3.0 - 9.0*(e6x*ux[NxtX][NxtY] + e6y*uy[NxtX][NxtY])*e6y)*(phi_y*rho[NxtX][NxtY] + mu_p/lambda*(Ayx_x[NxtX][NxtY] + Ayy_y[NxtX][NxtY]));
				
				df7[j][k] += F_term*w7*((e7x - ux[j][NxtY])*3.0 - 9.0*(e7x*ux[j][NxtY] + e7y*uy[j][NxtY])*e7x)*(phi_x*rho[j][NxtY] + mu_p/lambda*(Axx_x[j][NxtY] + Axy_y[j][NxtY]));
				df7[j][k] += F_term*w7*((e7y - uy[j][NxtY])*3.0 - 9.0*(e7x*ux[j][NxtY] + e7y*uy[j][NxtY])*e7y)*(phi_y*rho[j][NxtY] + mu_p/lambda*(Ayx_x[j][NxtY] + Ayy_y[j][NxtY]));
				
				df8[j][k] += F_term*w8*((e8x - ux[PrvX][NxtY])*3.0 - 9.0*(e8x*ux[PrvX][NxtY] + e8y*uy[PrvX][NxtY])*e8x)*(phi_x*rho[PrvX][NxtY] + mu_p/lambda*(Axx_x[PrvX][NxtY] + Axy_y[PrvX][NxtY]));
				df8[j][k] += F_term*w8*((e8y - uy[PrvX][NxtY])*3.0 - 9.0*(e8x*ux[PrvX][NxtY] + e8y*uy[PrvX][NxtY])*e8y)*(phi_y*rho[PrvX][NxtY] + mu_p/lambda*(Ayx_x[PrvX][NxtY] + Ayy_y[PrvX][NxtY]));
				
				
				/*df0[j][k] += F_term*w0*((e0x - ux[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0x)*(phi_x + mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				 df0[j][k] += F_term*w0*((e0y - uy[j][k])*3.0 - 9.0*(e0x*ux[j][k] + e0y*uy[j][k])*e0y)*(phi_y + mu_p/lambda*(Ayx_x[j][k] + Ayy_y[j][k]));
				 
				 df1[j][k] += F_term*w1*((e1x - ux[PrvX][k])*3.0 - 9.0*(e1x*ux[PrvX][k] + e1y*uy[PrvX][k])*e1x)*(phi_x + mu_p/lambda*(Axx_x[PrvX][k] + Axy_y[PrvX][k]));
				 df1[j][k] += F_term*w1*((e1y - uy[PrvX][k])*3.0 - 9.0*(e1x*ux[PrvX][k] + e1y*uy[PrvX][k])*e1y)*(phi_y + mu_p/lambda*(Ayx_x[PrvX][k] + Ayy_y[PrvX][k]));
				 
				 df2[j][k] += F_term*w2*((e2x - ux[PrvX][PrvY])*3.0 - 9.0*(e2x*ux[PrvX][PrvY] + e2y*uy[PrvX][PrvY])*e2x)*(phi_x + mu_p/lambda*(Axx_x[PrvX][PrvY] + Axy_y[PrvX][PrvY]));
				 df2[j][k] += F_term*w2*((e2y - uy[PrvX][PrvY])*3.0 - 9.0*(e2x*ux[PrvX][PrvY] + e2y*uy[PrvX][PrvY])*e2y)*(phi_y + mu_p/lambda*(Ayx_x[PrvX][PrvY] + Ayy_y[PrvX][PrvY]));
				 
				 df3[j][k] += F_term*w3*((e3x - ux[j][PrvY])*3.0 - 9.0*(e3x*ux[j][PrvY] + e3y*uy[j][PrvY])*e3x)*(phi_x + mu_p/lambda*(Axx_x[j][PrvY] + Axy_y[j][PrvY]));
				 df3[j][k] += F_term*w3*((e3y - uy[j][PrvY])*3.0 - 9.0*(e3x*ux[j][PrvY] + e3y*uy[j][PrvY])*e3y)*(phi_y + mu_p/lambda*(Ayx_x[j][PrvY] + Ayy_y[j][PrvY]));
				 
				 df4[j][k] += F_term*w4*((e4x - ux[NxtX][PrvY])*3.0 - 9.0*(e4x*ux[NxtX][PrvY] + e4y*uy[NxtX][PrvY])*e4x)*(phi_x + mu_p/lambda*(Axx_x[NxtX][PrvY] + Axy_y[NxtX][PrvY]));
				 df4[j][k] += F_term*w4*((e4y - uy[NxtX][PrvY])*3.0 - 9.0*(e4x*ux[NxtX][PrvY] + e4y*uy[NxtX][PrvY])*e4y)*(phi_y + mu_p/lambda*(Ayx_x[NxtX][PrvY] + Ayy_y[NxtX][PrvY]));
				 
				 df5[j][k] += F_term*w5*((e5x - ux[NxtX][k])*3.0 - 9.0*(e5x*ux[NxtX][k] + e5y*uy[NxtX][k])*e5x)*(phi_x + mu_p/lambda*(Axx_x[NxtX][k] + Axy_y[NxtX][k]));
				 df5[j][k] += F_term*w5*((e5y - uy[NxtX][k])*3.0 - 9.0*(e5x*ux[NxtX][k] + e5y*uy[NxtX][k])*e5y)*(phi_y + mu_p/lambda*(Ayx_x[NxtX][k] + Ayy_y[NxtX][k]));
				 
				 df6[j][k] += F_term*w6*((e6x - ux[NxtX][NxtY])*3.0 - 9.0*(e6x*ux[NxtX][NxtY] + e6y*uy[NxtX][NxtY])*e6x)*(phi_x + mu_p/lambda*(Axx_x[NxtX][NxtY] + Axy_y[NxtX][NxtY]));
				 df6[j][k] += F_term*w6*((e6y - uy[NxtX][NxtY])*3.0 - 9.0*(e6x*ux[NxtX][NxtY] + e6y*uy[NxtX][NxtY])*e6y)*(phi_y + mu_p/lambda*(Ayx_x[NxtX][NxtY] + Ayy_y[NxtX][NxtY]));
				 
				 df7[j][k] += F_term*w7*((e7x - ux[j][NxtY])*3.0 - 9.0*(e7x*ux[j][NxtY] + e7y*uy[j][NxtY])*e7x)*(phi_x + mu_p/lambda*(Axx_x[j][NxtY] + Axy_y[j][NxtY]));
				 df7[j][k] += F_term*w7*((e7y - uy[j][NxtY])*3.0 - 9.0*(e7x*ux[j][NxtY] + e7y*uy[j][NxtY])*e7y)*(phi_y + mu_p/lambda*(Ayx_x[j][NxtY] + Ayy_y[j][NxtY]));
				 
				 df8[j][k] += F_term*w8*((e8x - ux[PrvX][NxtY])*3.0 - 9.0*(e8x*ux[PrvX][NxtY] + e8y*uy[PrvX][NxtY])*e8x)*(phi_x + mu_p/lambda*(Axx_x[PrvX][NxtY] + Axy_y[PrvX][NxtY]));
				 df8[j][k] += F_term*w8*((e8y - uy[PrvX][NxtY])*3.0 - 9.0*(e8x*ux[PrvX][NxtY] + e8y*uy[PrvX][NxtY])*e8y)*(phi_y + mu_p/lambda*(Ayx_x[PrvX][NxtY] + Ayy_y[PrvX][NxtY]));
				 */
				
				
			}
		}
		
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				f0[j][k] = df0[j][k];
				f1[j][k] = df1[j][k];
				f2[j][k] = df2[j][k];
				f3[j][k] = df3[j][k];
				f4[j][k] = df4[j][k];
				f5[j][k] = df5[j][k];
				f6[j][k] = df6[j][k];
				f7[j][k] = df7[j][k];
				f8[j][k] = df8[j][k];
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = 0;
				ux[j][k] = 0;
				uy[j][k] = 0;
			}
		}
		
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				rho[j][k] = f0[j][k]+f1[j][k]+f2[j][k]+f3[j][k]+f4[j][k]+f5[j][k]+f6[j][k]+f7[j][k]+f8[j][k];
				//ux[j][k] = e1x*f1[j][k]+e2x*f2[j][k]+e3x*f3[j][k]+e4x*f4[j][k]+e5x*f5[j][k]+e6x*f6[j][k]+e7x*f7[j][k]+e8x*f8[j][k] + .5*(phi_x*rho[j][k] + mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				//uy[j][k] = e1y*f1[j][k]+e2y*f2[j][k]+e3y*f3[j][k]+e4y*f4[j][k]+e5y*f5[j][k]+e6y*f6[j][k]+e7y*f7[j][k]+e8y*f8[j][k] + .5*(phi_y*rho[j][k] + mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				
				//ux[j][k] = e1x*f1[j][k]+e2x*f2[j][k]+e3x*f3[j][k]+e4x*f4[j][k]+e5x*f5[j][k]+e6x*f6[j][k]+e7x*f7[j][k]+e8x*f8[j][k];
				//uy[j][k] = e1y*f1[j][k]+e2y*f2[j][k]+e3y*f3[j][k]+e4y*f4[j][k]+e5y*f5[j][k]+e6y*f6[j][k]+e7y*f7[j][k]+e8y*f8[j][k];
				
				
				ux[j][k] = e1x*f1[j][k]+e2x*f2[j][k]+e3x*f3[j][k]+e4x*f4[j][k]+e5x*f5[j][k]+e6x*f6[j][k]+e7x*f7[j][k]+e8x*f8[j][k] + .5*(mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				uy[j][k] = e1y*f1[j][k]+e2y*f2[j][k]+e3y*f3[j][k]+e4y*f4[j][k]+e5y*f5[j][k]+e6y*f6[j][k]+e7y*f7[j][k]+e8y*f8[j][k] + .5*(mu_p/lambda*(Axx_x[j][k] + Axy_y[j][k]));
				
				
				
				
				if( rho[j][k]!=0 )
				{
					ux[j][k] /= rho[j][k];
					uy[j][k] /= rho[j][k];
				}
				else
				{
					const double eps = 1e-4;
					
					ux[j][k] /= eps;
					uy[j][k] /= eps;
				}
			}
		}
		
		// Calculate heq
		for(j=0; j<NumXPoints; j++)
		{
			//for(k=0+1; k<NumYPoints-1; k++)
			for(k=0; k<NumYPoints; k++)
			{
				h0xxeq[j][k] = w0_el*Axx[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1xxeq[j][k] = w1_el*Axx[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2xxeq[j][k] = w2_el*Axx[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3xxeq[j][k] = w3_el*Axx[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4xxeq[j][k] = w4_el*Axx[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				h0xyeq[j][k] = w0_el*Axy[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1xyeq[j][k] = w1_el*Axy[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2xyeq[j][k] = w2_el*Axy[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3xyeq[j][k] = w3_el*Axy[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4xyeq[j][k] = w4_el*Axy[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				h0yxeq[j][k] = w0_el*Ayx[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1yxeq[j][k] = w1_el*Ayx[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2yxeq[j][k] = w2_el*Ayx[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3yxeq[j][k] = w3_el*Ayx[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4yxeq[j][k] = w4_el*Ayx[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
				h0yyeq[j][k] = w0_el*Ayy[j][k]*(1.0 + 9.0*(e0x*ux[j][k] + e0y*uy[j][k]));
				h1yyeq[j][k] = w1_el*Ayy[j][k]*(1.0 + 9.0*(e1x*ux[j][k] + e1y*uy[j][k]));
				h2yyeq[j][k] = w2_el*Ayy[j][k]*(1.0 + 9.0*(e3x*ux[j][k] + e3y*uy[j][k]));
				h3yyeq[j][k] = w3_el*Ayy[j][k]*(1.0 + 9.0*(e5x*ux[j][k] + e5y*uy[j][k]));
				h4yyeq[j][k] = w4_el*Ayy[j][k]*(1.0 + 9.0*(e7x*ux[j][k] + e7y*uy[j][k]));
				
			}
		}
		
		
		
		// Calculate grad of velocity
		// X derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				Prv = i-1;
				if (Prv < 0)
					Prv += NumXPoints;
				Nxt = i+1;
				if (Nxt > (NumXPoints-1)) 
					Nxt -= NumXPoints;
				
				ux_x[i][j] = (ux[Nxt][j] - ux[Prv][j])/2.0;
				uy_x[i][j] = (uy[Nxt][j] - uy[Prv][j])/2.0;
				
				
			}
		}
		
		// Y derivative
		for (i=0; i<NumXPoints; i++) {
			for (j=1; j<(NumYPoints-1); j++) {
				
				ux_y[i][j] = (ux[i][j+1] - ux[i][j-1])/2.0;
				uy_y[i][j] = (uy[i][j+1] - uy[i][j-1])/2.0;
				
			}
		}
		
		
		// Calculate G
		for(i=0; i<NumXPoints; i++)
		{
			for(j=1; j<(NumYPoints-1); j++)
			{
				Gxx[i][j] = -1.0/lambda*(Axx[i][j] - 1.0) + 2.0*(ux_x[i][j]*Axx[i][j] + ux_y[i][j]*Ayx[i][j]);	
				Gyx[i][j] = -1.0/lambda*(Ayx[i][j]) + ux_x[i][j]*Axy[i][j] + ux_y[i][j]*Ayy[i][j] + uy_x[i][j]*Axx[i][j] + uy_y[i][j]*Ayx[i][j];
				Gxy[i][j] = -1.0/lambda*(Axy[i][j]) + ux_x[i][j]*Axy[i][j] + ux_y[i][j]*Ayy[i][j] + uy_x[i][j]*Axx[i][j] + uy_y[i][j]*Ayx[i][j];
				Gyy[i][j] = -1.0/lambda*(Ayy[i][j] - 1.0) + 2.0*(uy_x[i][j]*Axy[i][j] + uy_y[i][j]*Ayy[i][j]);
			}
		}
		
		
		// Calculate GA
		for(i=0; i<NumXPoints; i++)
		{
			for(j=1; j<(NumYPoints-1); j++)
			{
				
				
				if( Axx[i][j]!=0 )
				{
					GAxx[i][j] = Gxx[i][j]/Axx[i][j];
				}
				else
				{
					const double eps = 1e-4;
					GAxx[i][j] = Gxx[i][j]/eps;
				}
				
				if( Axy[i][j]!=0 )
				{
					GAxy[i][j] = Gxy[i][j]/Axy[i][j];
				}
				else
				{
					const double eps = 1e-4;
					GAxy[i][j] = Gxy[i][j]/eps;
				}
				
				if( Ayx[i][j]!=0 )
				{
					GAyx[i][j] = Gyx[i][j]/Ayx[i][j];
				}
				else
				{
					const double eps = 1e-4;
					GAyx[i][j] = Gyx[i][j]/eps;
				}
				
				if( Ayy[i][j]!=0 )
				{
					GAyy[i][j] = Gyy[i][j]/Ayy[i][j];
				}
				else
				{
					const double eps = 1e-4;
					GAyy[i][j] = Gyy[i][j]/eps;
				}
			}
		}
		
		// Now do the advective diffusion scheme for h
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				int PrvX = j-1;
				if(PrvX<0) PrvX += (NumXPoints-1);
				int NxtX = j+1;
				if(NxtX>(NumXPoints-1))  NxtX += -(NumXPoints-1);
				int PrvY = k-1;
				int NxtY = k+1;
				
				dh0xx[j][k] = h0xx[j]   [k] - omega_el*(h0xx[j][k] -     h0xxeq[j][k]) +    (1 - .5*omega_el)*GAxx[j][k]*h0xxeq[j][k];
				dh1xx[j][k] = h1xx[PrvX][k] - omega_el*(h1xx[PrvX][k]-   h1xxeq[PrvX][k]) + (1 - .5*omega_el)*GAxx[PrvX][k]*h1xxeq[PrvX][k];
				dh2xx[j][k] = h2xx[j][PrvY] - omega_el*(h2xx[j][PrvY]-   h2xxeq[j][PrvY]) + (1 - .5*omega_el)*GAxx[j][PrvY]*h2xxeq[j][PrvY];
				dh3xx[j][k] = h3xx[NxtX][k] - omega_el*(h3xx[NxtX][k]-   h3xxeq[NxtX][k]) + (1 - .5*omega_el)*GAxx[NxtX][k]*h3xxeq[NxtX][k];
				dh4xx[j][k] = h4xx[j][NxtY] - omega_el*(h4xx[j][NxtY]-   h4xxeq[j][NxtY]) + (1 - .5*omega_el)*GAxx[j][NxtY]*h4xxeq[j][NxtY];
				
				dh0xy[j][k] = h0xy[j]   [k] - omega_el*(h0xy[j][k] -     h0xyeq[j][k]) +    (1 - .5*omega_el)*GAxy[j][k]*h0xyeq[j][k];
				dh1xy[j][k] = h1xy[PrvX][k] - omega_el*(h1xy[PrvX][k]-   h1xyeq[PrvX][k]) + (1 - .5*omega_el)*GAxy[PrvX][k]*h1xyeq[PrvX][k];
				dh2xy[j][k] = h2xy[j][PrvY] - omega_el*(h2xy[j][PrvY]-   h2xyeq[j][PrvY]) + (1 - .5*omega_el)*GAxy[j][PrvY]*h2xyeq[j][PrvY];
				dh3xy[j][k] = h3xy[NxtX][k] - omega_el*(h3xy[NxtX][k]-   h3xyeq[NxtX][k]) + (1 - .5*omega_el)*GAxy[NxtX][k]*h3xyeq[NxtX][k];
				dh4xy[j][k] = h4xy[j][NxtY] - omega_el*(h4xy[j][NxtY]-   h4xyeq[j][NxtY]) + (1 - .5*omega_el)*GAxy[j][NxtY]*h4xyeq[j][NxtY];
				
				dh0yx[j][k] = h0yx[j]   [k] - omega_el*(h0yx[j][k] -     h0yxeq[j][k]) +    (1 - .5*omega_el)*GAyx[j][k]*h0yxeq[j][k];
				dh1yx[j][k] = h1yx[PrvX][k] - omega_el*(h1yx[PrvX][k]-   h1yxeq[PrvX][k]) + (1 - .5*omega_el)*GAyx[PrvX][k]*h1yxeq[PrvX][k];
				dh2yx[j][k] = h2yx[j][PrvY] - omega_el*(h2yx[j][PrvY]-   h2yxeq[j][PrvY]) + (1 - .5*omega_el)*GAyx[j][PrvY]*h2yxeq[j][PrvY];
				dh3yx[j][k] = h3yx[NxtX][k] - omega_el*(h3yx[NxtX][k]-   h3yxeq[NxtX][k]) + (1 - .5*omega_el)*GAyx[NxtX][k]*h3yxeq[NxtX][k];
				dh4yx[j][k] = h4yx[j][NxtY] - omega_el*(h4yx[j][NxtY]-   h4yxeq[j][NxtY]) + (1 - .5*omega_el)*GAyx[j][NxtY]*h4yxeq[j][NxtY];
				
				dh0yy[j][k] = h0yy[j]   [k] - omega_el*(h0yy[j][k] -     h0yyeq[j][k]) +    (1 - .5*omega_el)*GAyy[j][k]*h0yyeq[j][k];
				dh1yy[j][k] = h1yy[PrvX][k] - omega_el*(h1yy[PrvX][k]-   h1yyeq[PrvX][k]) + (1 - .5*omega_el)*GAyy[PrvX][k]*h1yyeq[PrvX][k];
				dh2yy[j][k] = h2yy[j][PrvY] - omega_el*(h2yy[j][PrvY]-   h2yyeq[j][PrvY]) + (1 - .5*omega_el)*GAyy[j][PrvY]*h2yyeq[j][PrvY];
				dh3yy[j][k] = h3yy[NxtX][k] - omega_el*(h3yy[NxtX][k]-   h3yyeq[NxtX][k]) + (1 - .5*omega_el)*GAyy[NxtX][k]*h3yyeq[NxtX][k];
				dh4yy[j][k] = h4yy[j][NxtY] - omega_el*(h4yy[j][NxtY]-   h4yyeq[j][NxtY]) + (1 - .5*omega_el)*GAyy[j][NxtY]*h4yyeq[j][NxtY];
				
			}
		}
		
		
		
		for(j=0; j<NumXPoints; j++)
		{
			for(k=0+1; k<NumYPoints-1; k++)
			{
				h0xx[j][k] = dh0xx[j][k];
				h1xx[j][k] = dh1xx[j][k];
				h2xx[j][k] = dh2xx[j][k];
				h3xx[j][k] = dh3xx[j][k];
				h4xx[j][k] = dh4xx[j][k];
				
				h0xy[j][k] = dh0xy[j][k];
				h1xy[j][k] = dh1xy[j][k];
				h2xy[j][k] = dh2xy[j][k];
				h3xy[j][k] = dh3xy[j][k];
				h4xy[j][k] = dh4xy[j][k];
				
				h0yx[j][k] = dh0yx[j][k];
				h1yx[j][k] = dh1yx[j][k];
				h2yx[j][k] = dh2yx[j][k];
				h3yx[j][k] = dh3yx[j][k];
				h4yx[j][k] = dh4yx[j][k];
				
				h0yy[j][k] = dh0yy[j][k];
				h1yy[j][k] = dh1yy[j][k];
				h2yy[j][k] = dh2yy[j][k];
				h3yy[j][k] = dh3yy[j][k];
				h4yy[j][k] = dh4yy[j][k];
				
			}
		}
		
		// Now calculate A again
		
		for(i=0; i<NumXPoints; i++)
		{
			for(j=0; j<NumYPoints; j++)
			{
				Axx[i][j] = h0xx[i][j] + h1xx[i][j] + h2xx[i][j] + h3xx[i][j] + h4xx[i][j] + Gxx[i][j]/2.0;
				Ayx[i][j] = h0yx[i][j] + h1yx[i][j] + h2yx[i][j] + h3yx[i][j] + h4yx[i][j] + Gyx[i][j]/2.0;
				Axy[i][j] = h0xy[i][j] + h1xy[i][j] + h2xy[i][j] + h3xy[i][j] + h4xy[i][j] + Gxy[i][j]/2.0;
				Ayy[i][j] = h0yy[i][j] + h1yy[i][j] + h2yy[i][j] + h3yy[i][j] + h4yy[i][j] + Gyy[i][j]/2.0;
			}
		}
		
		
		
		//=========================================================================================================================
		//=========================================================================================================================
		// Record the Data
		int q = 100; //3000;
		if( !(t/double(q)-t/q) )
		{
			
			ofstream myfile;
			myfile.open("Dataout.m", ios::app);
			myfile.precision(6);
			
			/*myfile<<"xs=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"xs=[xs; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<j<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ys=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ys=[ys; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<k<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"rho=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"rho=[rho; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<rho[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"ux=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"ux=[ux; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<ux[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }
			 
			 myfile<<"uy=[];"<<endl;
			 for(j=0; j<NumXPoints; j+=1)
			 {
			 myfile<<"uy=[uy; ";
			 for(k=0; k<NumYPoints; k+=1)
			 {
			 myfile<<uy[j][k]<<" ";
			 }
			 myfile<<"];"<<endl;
			 }*/
			
			
			myfile<<"V_cent = [V_cent;"<<ux[30][50]<<"];"<<endl;
			myfile<<"Time_Array = [Time_Array;"<<t*dt<<"];"<<endl;
			
			myfile.close();
		}
	}
}

char* itoa(int val, int base) {
	static char buf[32] = {0};
	int i = 30;
	if(val==0)
	{
     	buf[i]='0';
		return &buf[i];
	}
	for (; val && i; --i, val /= base)
		buf[i] = "0123456789abcdef"[val % base];
	return &buf[i+1];
}
