%% This awesome file is the simualtion of a viscoelastic Oldroyd-B fluid in
% 3 dimentions.
close all; clear all;clc;
%% Setup the System

NumX = 100;
NumY = 100;
NumZ = 100;

% Lattice weights for D3Q19
cs = 1/sqrt(3);

% center 
w0 = 1/3;

%Direct connection
w1 = 1/18;
w2 = 1/18;
w3 = 1/18;
w10 = 1/18;
w11 = 1/18;
w12 = 1/18;

% Diagonal connection
w4 = 1/36;
w5 = 1/36;
w6 = 1/36;
w7 = 1/36;
w8 = 1/36;
w9 = 1/36;
w13 = 1/36;
w14 = 1/36;
w15 = 1/36;
w16 = 1/36;
w17 = 1/36;
w18 = 1/36;



% Lattice velocities for D3Q19
e0 = [0, 0, 0];

%Direct connection
e1 = [-1, 0, 0];
e2 = [0, -1, 0];
e3 = [0, 0, -1];
e10 = [1, 0, 0];
e11 = [0, 1, 0];
e12 = [0, 0, 1];

% Diagonal connection
e4 = [-1, -1, 0];
e5 = [-1, 1, 0];
e6 = [-1, 0, -1];
e7 = [-1, 0, 1];
e8 = [0, -1, -1];
e9 = [0, -1, 1];
e13 = [1, 1, 0];
e14 = [1, -1, 0];
e15 = [1, 0, 1];
e16 = [1, 0, -1];
e17 = [0, 1, 1];
e18 = [0, 1, -1];

tau = .8;

%% Initiate the matricies

rho = ones(NumX, NumY, NumZ);

ux = zeros(NumX, NumY, NumZ);
uy = zeros(NumX, NumY, NumZ);
uz = zeros(NumX, NumY, NumZ);

phix = zeros(NumX, NumY, NumZ);
phiy = zeros(NumX, NumY, NumZ);
phiz = zeros(NumX, NumY, NumZ);

X = linspace(-10, 10, 100); X1 = repmat(X, 100, 1);
Y = linspace(-10, 10, 100)'; Y1 = repmat(Y, 1, 100);
phix(:, :, 3) = -10^(-3)*exp(-Y1.^2/10).*X1.*exp(-X1.^2);
phix(:, :, 2) = -.3*10^(-3)*exp(-Y1.^2/10).*X1.*exp(-X1.^2);
phix(:, :, 4) = -.3*10^(-3)*exp(-Y1.^2/10).*X1.*exp(-X1.^2);

f0 = w0*ones(NumX, NumY, NumZ); f0eq = zeros(NumX, NumY, NumZ); df0 = zeros(NumX, NumY, NumZ);
f1 = w1*ones(NumX, NumY, NumZ); f1eq = zeros(NumX, NumY, NumZ); df1 = zeros(NumX, NumY, NumZ);
f2 = w2*ones(NumX, NumY, NumZ); f2eq = zeros(NumX, NumY, NumZ); df2 = zeros(NumX, NumY, NumZ);
f3 = w3*ones(NumX, NumY, NumZ); f3eq = zeros(NumX, NumY, NumZ); df3 = zeros(NumX, NumY, NumZ);
f4 = w4*ones(NumX, NumY, NumZ); f4eq = zeros(NumX, NumY, NumZ); df4 = zeros(NumX, NumY, NumZ);
f5 = w5*ones(NumX, NumY, NumZ); f5eq = zeros(NumX, NumY, NumZ); df5 = zeros(NumX, NumY, NumZ);
f6 = w6*ones(NumX, NumY, NumZ); f6eq = zeros(NumX, NumY, NumZ); df6 = zeros(NumX, NumY, NumZ);
f7 = w7*ones(NumX, NumY, NumZ); f7eq = zeros(NumX, NumY, NumZ); df7 = zeros(NumX, NumY, NumZ);
f8 = w8*ones(NumX, NumY, NumZ); f8eq = zeros(NumX, NumY, NumZ); df8 = zeros(NumX, NumY, NumZ);
f9 = w9*ones(NumX, NumY, NumZ); f9eq = zeros(NumX, NumY, NumZ); df9 = zeros(NumX, NumY, NumZ);
f10 = w10*ones(NumX, NumY, NumZ); f10eq = zeros(NumX, NumY, NumZ); df10 = zeros(NumX, NumY, NumZ);
f11 = w11*ones(NumX, NumY, NumZ); f11eq = zeros(NumX, NumY, NumZ); df11 = zeros(NumX, NumY, NumZ);
f12 = w12*ones(NumX, NumY, NumZ); f12eq = zeros(NumX, NumY, NumZ); df12 = zeros(NumX, NumY, NumZ);
f13 = w13*ones(NumX, NumY, NumZ); f13eq = zeros(NumX, NumY, NumZ); df13 = zeros(NumX, NumY, NumZ);
f14 = w14*ones(NumX, NumY, NumZ); f14eq = zeros(NumX, NumY, NumZ); df14 = zeros(NumX, NumY, NumZ);
f15 = w15*ones(NumX, NumY, NumZ); f15eq = zeros(NumX, NumY, NumZ); df15 = zeros(NumX, NumY, NumZ);
f16 = w16*ones(NumX, NumY, NumZ); f16eq = zeros(NumX, NumY, NumZ); df16 = zeros(NumX, NumY, NumZ);
f17 = w17*ones(NumX, NumY, NumZ); f17eq = zeros(NumX, NumY, NumZ); df17 = zeros(NumX, NumY, NumZ);
f18 = w18*ones(NumX, NumY, NumZ); f18eq = zeros(NumX, NumY, NumZ); df18 = zeros(NumX, NumY, NumZ);

%% Time Loop

for t = 1:1000,
    disp(['t = ', num2str(t)])
    disp(['max(ux) = ', num2str(max(max(max(ux)))), '    max(uy) = ', num2str(max(max(max(uy)))), '    max(uz) = ', num2str(max(max(max(uz))))]);
    
    %% Add force
        gx = phix; gy = phiy; gz = phiz;
    
    %% Calculate the equilibrium distribution
    f0eq = w0*rho.*calc_feq_3d(e0, ux, uy, uz, cs);
    f1eq = w1*rho.*calc_feq_3d(e1, ux, uy, uz, cs);
    f2eq = w2*rho.*calc_feq_3d(e2, ux, uy, uz, cs);
    f3eq = w3*rho.*calc_feq_3d(e3, ux, uy, uz, cs);
    f4eq = w4*rho.*calc_feq_3d(e4, ux, uy, uz, cs);
    f5eq = w5*rho.*calc_feq_3d(e5, ux, uy, uz, cs);
    f6eq = w6*rho.*calc_feq_3d(e6, ux, uy, uz, cs);
    f7eq = w7*rho.*calc_feq_3d(e7, ux, uy, uz, cs);
    f8eq = w8*rho.*calc_feq_3d(e8, ux, uy, uz, cs);
    f9eq = w9*rho.*calc_feq_3d(e9, ux, uy, uz, cs);
    f10eq = w10*rho.*calc_feq_3d(e10, ux, uy, uz, cs);
    f11eq = w11*rho.*calc_feq_3d(e11, ux, uy, uz, cs);
    f12eq = w12*rho.*calc_feq_3d(e12, ux, uy, uz, cs);
    f13eq = w13*rho.*calc_feq_3d(e13, ux, uy, uz, cs);
    f14eq = w14*rho.*calc_feq_3d(e14, ux, uy, uz, cs);
    f15eq = w15*rho.*calc_feq_3d(e15, ux, uy, uz, cs);
    f16eq = w16*rho.*calc_feq_3d(e16, ux, uy, uz, cs);
    f17eq = w17*rho.*calc_feq_3d(e17, ux, uy, uz, cs);
    f18eq = w18*rho.*calc_feq_3d(e18, ux, uy, uz, cs);
    
    %% Do the LB algorithm
    df0 = f0 - 1/tau*(f0 - f0eq) + (1 - 1/(2*tau))*calc_Fi_3d(w0, e0, ux, uy, uz, rho, gx, gy, gz, cs);
    df1 = f1 - 1/tau*(f1 - f1eq) + (1 - 1/(2*tau))*calc_Fi_3d(w1, e1, ux, uy, uz, rho, gx, gy, gz, cs);
    df2 = f2 - 1/tau*(f2 - f2eq) + (1 - 1/(2*tau))*calc_Fi_3d(w2, e2, ux, uy, uz, rho, gx, gy, gz, cs);
    df3 = f3 - 1/tau*(f3 - f3eq) + (1 - 1/(2*tau))*calc_Fi_3d(w3, e3, ux, uy, uz, rho, gx, gy, gz, cs);
    df4 = f4 - 1/tau*(f4 - f4eq) + (1 - 1/(2*tau))*calc_Fi_3d(w4, e4, ux, uy, uz, rho, gx, gy, gz, cs);
    df5 = f5 - 1/tau*(f5 - f5eq) + (1 - 1/(2*tau))*calc_Fi_3d(w5, e5, ux, uy, uz, rho, gx, gy, gz, cs);
    df6 = f6 - 1/tau*(f6 - f6eq) + (1 - 1/(2*tau))*calc_Fi_3d(w6, e6, ux, uy, uz, rho, gx, gy, gz, cs);
    df7 = f7 - 1/tau*(f7 - f7eq) + (1 - 1/(2*tau))*calc_Fi_3d(w7, e7, ux, uy, uz, rho, gx, gy, gz, cs);
    df8 = f8 - 1/tau*(f8 - f8eq) + (1 - 1/(2*tau))*calc_Fi_3d(w8, e8, ux, uy, uz, rho, gx, gy, gz, cs);
    df9 = f9 - 1/tau*(f9 - f9eq) + (1 - 1/(2*tau))*calc_Fi_3d(w9, e9, ux, uy, uz, rho, gx, gy, gz, cs);
    df10 = f10 - 1/tau*(f10 - f10eq) + (1 - 1/(2*tau))*calc_Fi_3d(w10, e10, ux, uy, uz, rho, gx, gy, gz, cs);
    df11 = f11 - 1/tau*(f11 - f11eq) + (1 - 1/(2*tau))*calc_Fi_3d(w11, e11, ux, uy, uz, rho, gx, gy, gz, cs);
    df12 = f12 - 1/tau*(f12 - f12eq) + (1 - 1/(2*tau))*calc_Fi_3d(w12, e12, ux, uy, uz, rho, gx, gy, gz, cs);
    df13 = f13 - 1/tau*(f13 - f13eq) + (1 - 1/(2*tau))*calc_Fi_3d(w13, e13, ux, uy, uz, rho, gx, gy, gz, cs);
    df14 = f14 - 1/tau*(f14 - f14eq) + (1 - 1/(2*tau))*calc_Fi_3d(w14, e14, ux, uy, uz, rho, gx, gy, gz, cs);
    df15 = f15 - 1/tau*(f15 - f15eq) + (1 - 1/(2*tau))*calc_Fi_3d(w15, e15, ux, uy, uz, rho, gx, gy, gz, cs);
    df16 = f16 - 1/tau*(f16 - f16eq) + (1 - 1/(2*tau))*calc_Fi_3d(w16, e16, ux, uy, uz, rho, gx, gy, gz, cs);
    df17 = f17 - 1/tau*(f17 - f17eq) + (1 - 1/(2*tau))*calc_Fi_3d(w17, e17, ux, uy, uz, rho, gx, gy, gz, cs);
    df18 = f18 - 1/tau*(f18 - f18eq) + (1 - 1/(2*tau))*calc_Fi_3d(w18, e18, ux, uy, uz, rho, gx, gy, gz, cs);
    
    %% Streaming
    %fi(x+ei, t+1) = dfi(x, t)
    
    f0 = df0;
 
    f1(1:end-1, :, :) = df1(2:end, :, :); f1(end, :, :) = df1(1, :, :);
    f2(:, 1:end-1, :) = df2(:, 2:end, :); f2(:, end, :) = df2(:, 1, :);
    f3(:, :, 1:end-1) = df3(:, :, 2:end); f3(:, :, end) = df3(:, :, 1); %Obeys bdny conditions
    f10(2:end, :, :) = df10(1:end-1, :, :); f10(1, :, :) = df10(end, :, :);
    f11(:, 2:end, :) = df11(:, 1:end-1, :); f11(:, 1, :) = df11(:, end, :);
    f12(:, :, 2:end) = df12(:, :, 1:end-1); f12(:, :, 1) = df12(:, :, end); %Obeys bdny conditions
    
    
    tmp = zeros(NumX, NumY, NumZ);
    
    tmp(1:end-1, :, :) = df4(2:end, :, :); tmp(end, :, :) = df4(1, :, :);
    f4(:, 1:end-1, :) = tmp(:, 2:end, :); f4(:, end, :) = tmp(:, 1, :);
    
    tmp(1:end-1, :, :) = df5(2:end, :, :); tmp(end, :, :) = df5(1, :, :);
    f5(:, 2:end, :) = tmp(:, 1:end-1, :); f5(:, 1, :) = tmp(:, end, :);
    
    tmp(1:end-1, :, :) = df6(2:end, :, :); tmp(end, :, :) = df6(1, :, :);
    f6(:, :, 1:end-1) = tmp(:, :, 2:end); f6(:, :, end) = tmp(:, :, 1);%Obeys bdny conditions
    
    tmp(1:end-1, :, :) = df7(2:end, :, :); tmp(end, :, :) = df7(1, :, :);
    f7(:, :, 2:end) = tmp(:, :, 1:end-1); f7(:, :, 1) = tmp(:, :, end);%Obeys bdny conditions
    
    tmp(2:end, :, :) = df13(1:end-1, :, :); tmp(1, :, :) = df13(end, :, :);
    f13(:, 2:end, :) = tmp(:, 1:end-1, :); f13(:, 1, :) = tmp(:, end, :);
    
    tmp(2:end, :, :) = df14(1:end-1, :, :); tmp(1, :, :) = df14(end, :, :);
    f14(:, 1:end-1, :) = tmp(:, 2:end, :); f14(:, end, :) = tmp(:, 1, :);
    
    tmp(2:end, :, :) = df15(1:end-1, :, :); tmp(1, :, :) = df15(end, :, :);
    f15(:, :, 2:end) = tmp(:, :, 1:end-1); f15(:, :, 1) = tmp(:, :, end);%Obeys bdny conditions
    
    tmp(2:end, :, :) = df16(1:end-1, :, :); tmp(1, :, :) = df16(end, :, :);
    f16(:, :, 1:end-1) = tmp(:, :, 2:end); f16(:, :, end) = tmp(:, :, 1);%Obeys bdny conditions
    
    tmp(:, 2:end, :) = df17(:, 1:end-1, :); tmp(:, 1, :) = df17(:, end, :);
    f17(:, :, 2:end) = tmp(:, :, 1:end-1); f17(:, :, 1) = tmp(:, :, end);%Obeys bdny conditions
    
    tmp(:, 2:end, :) = df18(:, 1:end-1, :); tmp(:, 1, :) = df18(:, end, :);
    f18(:, :, 1:end-1) = tmp(:, :, 2:end); f18(:, :, end) = tmp(:, :, 1);%Obeys bdny conditions
    
    tmp(:, 1:end-1, :) = df8(:, 2:end, :); tmp(:, end, :) = df8(:, 1, :);
    f8(:, :, 1:end-1) = tmp(:, :, 2:end); f8(:, :, end) = tmp(:, :, 1);%Obeys bdny conditions
    
    tmp(:, 1:end-1, :) = df9(:, 2:end, :); tmp(:, end, :) = df9(:, 1, :);
    f9(:, :, 2:end) = tmp(:, :, 1:end-1); f9(:, :, 1) = tmp(:, :, end);
    
    
    %% Apply Boundary conditions
    % At Z = 0; e12, e7, e9, e17, e15 are underfined
   
    f12(:, :, 1) = df3(:, :, 1);
    f17(:, :, 1) = df6(:, :, 1);
    f15(:, :, 1) = df8(:, :, 1);
    f7(:, :, 1) = df18(:, :, 1);
    f9(:, :, 1) = df16(:, :, 1);
    
    % At Z = Zmax; e3, e6, e8, e16, e18 are underfined
    f3(:, :, end) = df12(:, :, end);
    f6(:, :, end) = df17(:, :, end);
    f8(:, :, end) = df15(:, :, end);
    f16(:, :, end) = df9(:, :, end);
    f18(:, :, end) = df7(:, :, end);
    
    %% Calculate density and velocity field
    
    rho =f0 + f1 + f2 + f3 + f4 + f5 + f6 + f7 + f8 + f9 + f10 + f11 + f12 + f13 + f14 + f15 + f16 + f17 + f18;
    
    ux = e0(1)*f0+e1(1)*f1+e2(1)*f2+e3(1)*f3+e4(1)*f4+e5(1)*f5+e6(1)*f6+...
        e7(1)*f7+e8(1)*f8+e9(1)*f9+e10(1)*f10+e11(1)*f11+e12(1)*f12+e13(1)*f13...
        +e14(1)*f14+e15(1)*f15+e16(1)*f16+e17(1)*f17+e18(1)*f18;
    
    uy = e0(2)*f0+e1(2)*f1+e2(2)*f2+e3(2)*f3+e4(2)*f4+e5(2)*f5+e6(2)*f6+...
        e7(2)*f7+e8(2)*f8+e9(2)*f9+e10(2)*f10+e11(2)*f11+e12(2)*f12+e13(2)*f13...
        +e14(2)*f14+e15(2)*f15+e16(2)*f16+e17(2)*f17+e18(2)*f18;
    
    uz = e0(3)*f0+e1(3)*f1+e2(3)*f2+e3(3)*f3+e4(3)*f4+e5(3)*f5+e6(3)*f6+...
        e7(3)*f7+e8(3)*f8+e9(3)*f9+e10(3)*f10+e11(3)*f11+e12(3)*f12+e13(3)*f13...
        +e14(3)*f14+e15(3)*f15+e16(3)*f16+e17(3)*f17+e18(3)*f18;
    
    ux = ux./rho + gx/2;
    uy = uy./rho + gy/2;
    uz = uz./rho + gz/2;
    
    
end
