%% LBM Simulations in 2 dimentions
%We have included viscoelastic effects in these simulations
clear all;close all;clc;
%clear all;clc;
movie_count = 1;
figure('Position', [100,100,1200,800]);
%%

NumX = 300;
NumY = 50;

w0 = 4/9;

w1 = 1/9;
w3 = 1/9;
w5 = 1/9;
w7 = 1/9;

w2 = 1/36;
w4 = 1/36;
w6 = 1/36;
w8 = 1/36;

cs = 1/sqrt(3);

e0 = [0,0];
e1 = [1,0];
e2 = [1,1];
e3 = [0,1];
e4 = [-1,1];
e5 = [-1,0];
e6 = [-1,-1];
e7 = [0,-1];
e8 = [1,-1];

%v_s = [1e-6, 1e-5, 1e-4, 1e-3, 1e-2, 1e-1, 1, 10, 100, 1000, 10000, 100000];
%tau = [2.0000, 1.9999, 1.9988, 1.9881, 1.8868, 1.2500, 0.2857, 0.0328, 0.0033, 0.0003, 0.0000, 0.0000];
tau = 0.9;
v_s = cs^2*(1/tau - 1/2);
disp(v_s);

phix = zeros(NumX, NumY);
phiy = zeros(NumX, NumY);

X = linspace(-150, 150, NumX)';
Y = linspace(0, 50, NumY);


X1 = repmat(X, 1, NumY);
Y1 = repmat(Y, NumX, 1);

%phix = ones(NumX, NumY)*1e-5;
%phiy = zeros(NumX, NumY);

%%{
% Line force
phix = zeros(NumX, NumY);
phiy = zeros(NumX, NumY);

ux_mat = [];
uy_mat = [];

mov = avifile('test.avi');
scrsz = get(0,'ScreenSize');
fig = figure('Position',[1 scrsz(4) scrsz(3)/1.5 scrsz(4)/2]);

M_num = 20;

M_x = [-10*ones(1, 40), linspace(-10, 10, 20), 10*ones(1, 40), linspace(10, -10, 20)];
M_y = [linspace(30, 1, 40), 1*ones(1, 20), linspace(1, 30, 40), 30*ones(1, 20)];

%phix(:, floor(NumY/2)) = 1e-6;
%phix(:, 3) = -X.*exp(-X.^2/100)*1e-6;
phix(:, 3) = -X.*exp(-X.^2/100)*1e-6;% -(X+20).*exp(-(X+20).^2/100)*1e-6;
%phix(:, 4) = -X.*exp(-X.^2/100)*1e-6*1/3;
%phix(:, 2) = -X.*exp(-X.^2/100)*1e-6*1/3;
%}
%{
% expanding or contracting force
phix = -2*X1.*exp(-(X1.^2 + Y1.^2)/100)*1e-6;
phiy = -2*Y1.*exp(-(X1.^2 + Y1.^2)/100)*1e-6;
%}

%{
% moving force
X_right = linspace(0, NumX/2, NumX/2)'-5;
X_left = linspace(-NumX/2, 0, NumX/2)'+5;
Y_right = exp(-X_right.^2/10)*1e-6;
Y_left = -exp(-X_left.^2/10)*1e-6;
F = [Y_left;Y_right];
phix(:, NumY/2) = F;
phiy = zeros(NumX, NumY);
F_mat = [];
U_mat = [];

%}



v_cent = [];

P_M_x =  [];
P_M_y = [];

P_pos_x = [linspace(-25, 25, 50)];
P_pos_y = [zeros(1, 50)+1];
d_o = sqrt((P_pos_x(2) - P_pos_x(1))^2 + (P_pos_y(2) - P_pos_y(1))^2);

%% Elastic Part
cl = 1/sqrt(3);

lambda = 100;

mu_p = 0;

%tau_el = 20;

tau_el = 1/(10e-6*mu_p/cl^2 + 1/2);



w0el = 1 - 2*cl^2;
w1el = cl^2/2;
w2el = cl^2/2;
w3el = cl^2/2;
w4el = cl^2/2;


h0xx = w0el*ones(NumX, NumY);h1xx = w1el*ones(NumX, NumY);h2xx = w2el*ones(NumX, NumY);h3xx = w3el*ones(NumX, NumY);h4xx = w4el*ones(NumX, NumY);

h0xy = w0el*zeros(NumX, NumY);h1xy = w1el*zeros(NumX, NumY);h2xy = w2el*zeros(NumX, NumY);h3xy = w3el*zeros(NumX, NumY);h4xy = w4el*zeros(NumX, NumY);

h0yx = w0el*zeros(NumX, NumY);h1yx = w1el*zeros(NumX, NumY);h2yx = w2el*zeros(NumX, NumY);h3yx = w3el*zeros(NumX, NumY);h4yx = w4el*zeros(NumX, NumY);

h0yy = w0el*ones(NumX, NumY);h1yy = w1el*ones(NumX, NumY);h2yy = w2el*ones(NumX, NumY);h3yy = w3el*ones(NumX, NumY);h4yy = w4el*ones(NumX, NumY);

Axx = ones(NumX, NumY);
Axy = zeros(NumX, NumY);
Ayx = zeros(NumX, NumY);
Ayy = ones(NumX, NumY);




%%

rho = ones(NumX, NumY);

X = linspace(-NumX/2, NumX/2, NumX);
ux_temp = (-X.^2 + X(1).^2)/X(1).^2;

%ux = repmat(ux_temp, NumX, 1)*1e-6;


ux = zeros(NumX, NumY);
uy = zeros(NumX, NumY);

%%{
f0 = w0*ones(NumX, NumY);
f1 = w1*ones(NumX, NumY);
f2 = w2*ones(NumX, NumY);
f3 = w3*ones(NumX, NumY);
f4 = w4*ones(NumX, NumY);
f5 = w5*ones(NumX, NumY);
f6 = w6*ones(NumX, NumY);
f7 = w7*ones(NumX, NumY);
f8 = w8*ones(NumX, NumY);
%}

%{
f0 = w0*rho.*calc_feq(e0, ux, uy, cs);
f1 = w1*rho.*calc_feq(e1, ux, uy, cs);
f2 = w2*rho.*calc_feq(e2, ux, uy, cs);
f3 = w3*rho.*calc_feq(e3, ux, uy, cs);
f4 = w4*rho.*calc_feq(e4, ux, uy, cs);
f5 = w5*rho.*calc_feq(e5, ux, uy, cs);
f6 = w6*rho.*calc_feq(e6, ux, uy, cs);
f7 = w7*rho.*calc_feq(e7, ux, uy, cs);
f8 = w8*rho.*calc_feq(e8, ux, uy, cs);
%}

%uc = e0(1)*f0+e1(1)*f1+e2(1)*f2+e3(1)*f3+e4(1)*f4+e5(1)*f5+e6(1)*f6+e7(1)*f7+e8(1)*f8;

f0eq = zeros(NumX, NumY);
f1eq = zeros(NumX, NumY);
f2eq = zeros(NumX, NumY);
f3eq = zeros(NumX, NumY);
f4eq = zeros(NumX, NumY);
f5eq = zeros(NumX, NumY);
f6eq = zeros(NumX, NumY);
f7eq = zeros(NumX, NumY);
f8eq = zeros(NumX, NumY);

df0 = zeros(NumX, NumY);
df1 = zeros(NumX, NumY);
df2 = zeros(NumX, NumY);
df3 = zeros(NumX, NumY);
df4 = zeros(NumX, NumY);
df5 = zeros(NumX, NumY);
df6 = zeros(NumX, NumY);
df7 = zeros(NumX, NumY);
df8 = zeros(NumX, NumY);





%% Time Loop
for t=0:200,
disp(['t = ', num2str(t)])
disp(['max_uy = ', num2str(max(max(uy)))])
disp(tau);

%% Update the force
%{
X_r = X_right - .001*t;
X_l = X_left + .001*t;

Y_right = exp(-X_r.^2/10)*1e-6;
Y_left = -exp(-X_l.^2/10)*1e-6;
F = [Y_left;Y_right];
phix(:, NumY/2) = F;
F_mat = [F_mat, F];
U_mat = [U_mat, ux(:, NumY/2)];
%}
%figure(1), plot(F), drawnow, pause(.1)

    

%% Calculate derivative of A
%%{
Axx_x = ([Axx(2:end, :); Axx(1, :)] - [Axx(end, :); Axx(1:end-1, :)])/2;
Axy_x = ([Axy(2:end, :); Axy(1, :)] - [Axy(end, :); Axy(1:end-1, :)])/2;

Ayx_y = zeros(NumX, NumY);
Ayx_y(:, 2:end-1) = (Ayx(:, 3:end) - Ayx(:, 1:end-2))/2;
Ayx_y(:, 1) = (-3*Ayx(:, 1) + 4*Ayx(:, 2) - Ayx(:, 3))/2;
Ayx_y(:, end) = -(-3*Ayx(:, end) + 4*Ayx(:, end-1) - Ayx(:, end-2))/2;

Ayy_y = zeros(NumX, NumY);
Ayy_y(:, 2:end-1) = (Ayy(:, 3:end) - Ayy(:, 1:end-2))/2;
Ayy_y(:, 1) = (-3*Ayy(:, 1) + 4*Ayy(:, 2) - Ayy(:, 3))/2;
Ayy_y(:, end) = -(-3*Ayy(:, end) + 4*Ayy(:, end-1) - Ayy(:, end-2))/2;
%}

gx = mu_p/lambda*(Axx_x + Ayx_y)./rho + phix;
gy = mu_p/lambda*(Axy_x + Ayy_y)./rho + phiy;
%disp(max(max(mu_p/lambda*abs((Axx_x + Ayx_y)))))


%% Calculate the equilibrium distibution
			
f0eq = w0*rho.*calc_feq(e0, ux, uy, cs);
f1eq = w1*rho.*calc_feq(e1, ux, uy, cs);
f2eq = w2*rho.*calc_feq(e2, ux, uy, cs);
f3eq = w3*rho.*calc_feq(e3, ux, uy, cs);
f4eq = w4*rho.*calc_feq(e4, ux, uy, cs);
f5eq = w5*rho.*calc_feq(e5, ux, uy, cs);
f6eq = w6*rho.*calc_feq(e6, ux, uy, cs);
f7eq = w7*rho.*calc_feq(e7, ux, uy, cs);
f8eq = w8*rho.*calc_feq(e8, ux, uy, cs);




%% Do the LB algorithm

%local

df0 = f0 - 1/tau*(f0 - f0eq) + (1 - 1/(2*tau))*calc_Fi(w0, e0, ux, uy, rho, gx, gy, cs);
df1 = f1 - 1/tau*(f1 - f1eq) + (1 - 1/(2*tau))*calc_Fi(w1, e1, ux, uy, rho, gx, gy, cs);
df2 = f2 - 1/tau*(f2 - f2eq) + (1 - 1/(2*tau))*calc_Fi(w2, e2, ux, uy, rho, gx, gy, cs);
df3 = f3 - 1/tau*(f3 - f3eq) + (1 - 1/(2*tau))*calc_Fi(w3, e3, ux, uy, rho, gx, gy, cs);
df4 = f4 - 1/tau*(f4 - f4eq) + (1 - 1/(2*tau))*calc_Fi(w4, e4, ux, uy, rho, gx, gy, cs);
df5 = f5 - 1/tau*(f5 - f5eq) + (1 - 1/(2*tau))*calc_Fi(w5, e5, ux, uy, rho, gx, gy, cs);
df6 = f6 - 1/tau*(f6 - f6eq) + (1 - 1/(2*tau))*calc_Fi(w6, e6, ux, uy, rho, gx, gy, cs);
df7 = f7 - 1/tau*(f7 - f7eq) + (1 - 1/(2*tau))*calc_Fi(w7, e7, ux, uy, rho, gx, gy, cs);
df8 = f8 - 1/tau*(f8 - f8eq) + (1 - 1/(2*tau))*calc_Fi(w8, e8, ux, uy, rho, gx, gy, cs);


%{
disp(['df0 = ', num2str(df0(end/2, end/2))])
disp(['df1 = ', num2str(df1(end/2, end/2))])
disp(['df2 = ', num2str(df2(end/2, end/2))])
disp(['df3 = ', num2str(df3(end/2, end/2))])
disp(['df4 = ', num2str(df4(end/2, end/2))])
disp(['df5 = ', num2str(df5(end/2, end/2))])
disp(['df6 = ', num2str(df6(end/2, end/2))])
disp(['df7 = ', num2str(df7(end/2, end/2))])
disp(['df8 = ', num2str(df8(end/2, end/2))])
%}

%%
%streaming

f0 = df0;
%fi(x+ei, t+1) = dfi(x, t)
f1 = [df1(end, :);df1(1:end-1, :)];
f5 = [df5(2:end, :);df5(1, :)];

f7 = [df7(:, 2:end),f7(:, end)];
f3 = [f3(:, 1), df3(:, 1:end-1)];

tmp2 = [df2(end,:);df2(1:end-1,:)];
f2 = [f2(:, 1), tmp2(:, 1:end-1)];

tmp4 = [df4(2:end,:);df4(1,:)];
f4 = [f4(:, 1), tmp4(:, 1:end-1)];

tmp8 = [df8(end,:);df8(1:end-1,:)];
f8 = [tmp8(:, 2:end), f8(:, end)];

tmp6 = [df6(2:end,:);df6(1,:)];
f6 = [tmp6(:, 2:end), f6(:, end)];



%% Calculate Boundary Conditions for 2,3,4
%{

%ux(:, 1) = 0;
%uy(:, 1) = 0;
%rho_tmp1 = 1./(1 + uy(:, 1)).*(2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));
rho_tmp1 = (2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));

%rho_tmp1 = rho(:,1);

f1_tmp = f1(:, 1) - f1eq(:, 1);
f0_tmp = f0(:, 1) - f0eq(:, 1);
f5_tmp = f5(:, 1) - f5eq(:, 1);
f6_tmp = f6(:, 1) - f6eq(:, 1);
f7_tmp = f7(:, 1) - f7eq(:, 1);
f8_tmp = f8(:, 1) - f8eq(:, 1);

Sxx = -1./(rho_tmp1*tau*cs^2).*(2*(e6(1)*e6(1)*f6_tmp + e7(1)*e7(1)*f7_tmp + e8(1)*e8(1)*f8_tmp) + e1(1)*e1(1)*f1_tmp + e0(1)*e0(1)*f0_tmp + e5(1)*e5(1)*f5_tmp);
Sxy = -1./(rho_tmp1*tau*cs^2).*(2*(e6(1)*e6(2)*f6_tmp + e7(1)*e7(2)*f7_tmp + e8(1)*e8(2)*f8_tmp) + e1(1)*e1(2)*f1_tmp + e0(1)*e0(2)*f0_tmp + e5(1)*e5(2)*f5_tmp);
Syx = -1./(rho_tmp1*tau*cs^2).*(2*(e6(2)*e6(1)*f6_tmp + e7(2)*e7(1)*f7_tmp + e8(2)*e8(1)*f8_tmp) + e1(2)*e1(1)*f1_tmp + e0(2)*e0(1)*f0_tmp + e5(2)*e5(1)*f5_tmp);
Syy = -1./(rho_tmp1*tau*cs^2).*(2*(e6(2)*e6(2)*f6_tmp + e7(2)*e7(2)*f7_tmp + e8(2)*e8(2)*f8_tmp) + e1(2)*e1(2)*f1_tmp + e0(2)*e0(2)*f0_tmp + e5(2)*e5(2)*f5_tmp);

fd0 = -w0*tau/cs^2*rho_tmp1.*((e0(1)*e0(1) - cs^2)*Sxx + (e0(1)*e0(2))*Sxy + (e0(2)*e0(1))*Syx + (e0(2)*e0(2) - cs^2)*Syy);
fd1 = -w1*tau/cs^2*rho_tmp1.*((e1(1)*e1(1) - cs^2)*Sxx + (e1(1)*e1(2))*Sxy + (e1(2)*e1(1))*Syx + (e1(2)*e1(2) - cs^2)*Syy);
fd2 = -w2*tau/cs^2*rho_tmp1.*((e2(1)*e2(1) - cs^2)*Sxx + (e2(1)*e2(2))*Sxy + (e2(2)*e2(1))*Syx + (e2(2)*e2(2) - cs^2)*Syy);
fd3 = -w3*tau/cs^2*rho_tmp1.*((e3(1)*e3(1) - cs^2)*Sxx + (e3(1)*e3(2))*Sxy + (e3(2)*e3(1))*Syx + (e3(2)*e3(2) - cs^2)*Syy);
fd4 = -w4*tau/cs^2*rho_tmp1.*((e4(1)*e4(1) - cs^2)*Sxx + (e4(1)*e4(2))*Sxy + (e4(2)*e4(1))*Syx + (e4(2)*e4(2) - cs^2)*Syy);
fd5 = -w5*tau/cs^2*rho_tmp1.*((e5(1)*e5(1) - cs^2)*Sxx + (e5(1)*e5(2))*Sxy + (e5(2)*e5(1))*Syx + (e5(2)*e5(2) - cs^2)*Syy);
fd6 = -w6*tau/cs^2*rho_tmp1.*((e6(1)*e6(1) - cs^2)*Sxx + (e6(1)*e6(2))*Sxy + (e6(2)*e6(1))*Syx + (e6(2)*e6(2) - cs^2)*Syy);
fd7 = -w7*tau/cs^2*rho_tmp1.*((e7(1)*e7(1) - cs^2)*Sxx + (e7(1)*e7(2))*Sxy + (e7(2)*e7(1))*Syx + (e7(2)*e7(2) - cs^2)*Syy);
fd8 = -w8*tau/cs^2*rho_tmp1.*((e8(1)*e8(1) - cs^2)*Sxx + (e8(1)*e8(2))*Sxy + (e8(2)*e8(1))*Syx + (e8(2)*e8(2) - cs^2)*Syy);

f0(:, 1) = f0eq(:, 1) + fd0;
f1(:, 1) = f1eq(:, 1) + fd1;
f2(:, 1) = f2eq(:, 1) + fd2;
f3(:, 1) = f3eq(:, 1) + fd3;
f4(:, 1) = f4eq(:, 1) + fd4;
f5(:, 1) = f5eq(:, 1) + fd5;
f6(:, 1) = f6eq(:, 1) + fd6;
f7(:, 1) = f7eq(:, 1) + fd7;
f8(:, 1) = f8eq(:, 1) + fd8;

%figure(1), plot(f2(5, 1:20)),hold on, plot(f1(5, 1:20), 'r'), plot(f8(5, 1:20), 'g'), drawnow
disp_thing = [[f0(5,1), f0(5, 2), f0(5, 3)];[f1(5,1), f1(5, 2), f1(5, 3)];[f2(5,1), f2(5, 2), f2(5, 3)];[f3(5,1), f3(5, 2), f3(5, 3)];[f4(5,1), f4(5, 2), f4(5, 3)];[f5(5,1), f5(5, 2), f5(5, 3)];[f6(5,1), f6(5, 2), f6(5, 3)];[f7(5,1), f7(5, 2), f7(5, 3)];[f8(5,1), f8(5, 2), f2(5, 3)]];
disp(disp_thing);
%pause(.1);
%}

%% Calculate Boundary Conditions for 6,7,8
%{

%ux(:, 1) = 0;
%uy(:, 1) = 0;
%rho_tmp1 = 1./(1 + uy(:, 1)).*(2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));
rho_tmp1 = (2*(f2(:, end) + f3(:, end) + f4(:, end)) + f1(:, end) + f0(:, end) + f5(:, end));

%rho_tmp1 = rho(:,end);

f1_tmp = f1(:, end) - f1eq(:, end);
f0_tmp = f0(:, end) - f0eq(:, end);
f5_tmp = f5(:, end) - f5eq(:, end);
f2_tmp = f2(:, end) - f2eq(:, end);
f3_tmp = f3(:, end) - f3eq(:, end);
f4_tmp = f4(:, end) - f4eq(:, end);

Sxx = -1./(rho_tmp1*tau*cs^2).*(2*(e2(1)*e2(1)*f2_tmp + e3(1)*e3(1)*f3_tmp + e4(1)*e4(1)*f4_tmp) + e1(1)*e1(1)*f1_tmp + e0(1)*e0(1)*f0_tmp + e5(1)*e5(1)*f5_tmp);
Sxy = -1./(rho_tmp1*tau*cs^2).*(2*(e2(1)*e2(2)*f2_tmp + e3(1)*e3(2)*f3_tmp + e4(1)*e4(2)*f4_tmp) + e1(1)*e1(2)*f1_tmp + e0(1)*e0(2)*f0_tmp + e5(1)*e5(2)*f5_tmp);
Syx = -1./(rho_tmp1*tau*cs^2).*(2*(e2(2)*e2(1)*f2_tmp + e3(2)*e3(1)*f3_tmp + e4(2)*e4(1)*f4_tmp) + e1(2)*e1(1)*f1_tmp + e0(2)*e0(1)*f0_tmp + e5(2)*e5(1)*f5_tmp);
Syy = -1./(rho_tmp1*tau*cs^2).*(2*(e2(2)*e2(2)*f2_tmp + e3(2)*e3(2)*f3_tmp + e4(2)*e4(2)*f4_tmp) + e1(2)*e1(2)*f1_tmp + e0(2)*e0(2)*f0_tmp + e5(2)*e5(2)*f5_tmp);

fd0 = w0*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e0(1)*e0(1) - cs^2)*Sxx + (e0(1)*e0(2))*Sxy + (e0(2)*e0(1))*Syx + (e0(2)*e0(2) - cs^2)*Syy)));
fd1 = w1*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e1(1)*e1(1) - cs^2)*Sxx + (e1(1)*e1(2))*Sxy + (e1(2)*e1(1))*Syx + (e1(2)*e1(2) - cs^2)*Syy)));
fd2 = w2*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e2(1)*e2(1) - cs^2)*Sxx + (e2(1)*e2(2))*Sxy + (e2(2)*e2(1))*Syx + (e2(2)*e2(2) - cs^2)*Syy)));
fd3 = w3*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e3(1)*e3(1) - cs^2)*Sxx + (e3(1)*e3(2))*Sxy + (e3(2)*e3(1))*Syx + (e3(2)*e3(2) - cs^2)*Syy)));
fd4 = w4*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e4(1)*e4(1) - cs^2)*Sxx + (e4(1)*e4(2))*Sxy + (e4(2)*e4(1))*Syx + (e4(2)*e4(2) - cs^2)*Syy)));
fd5 = w5*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e5(1)*e5(1) - cs^2)*Sxx + (e5(1)*e5(2))*Sxy + (e5(2)*e5(1))*Syx + (e5(2)*e5(2) - cs^2)*Syy)));
fd6 = w6*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e6(1)*e6(1) - cs^2)*Sxx + (e6(1)*e6(2))*Sxy + (e6(2)*e6(1))*Syx + (e6(2)*e6(2) - cs^2)*Syy)));
fd7 = w7*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e7(1)*e7(1) - cs^2)*Sxx + (e7(1)*e7(2))*Sxy + (e7(2)*e7(1))*Syx + (e7(2)*e7(2) - cs^2)*Syy)));
fd8 = w8*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e8(1)*e8(1) - cs^2)*Sxx + (e8(1)*e8(2))*Sxy + (e8(2)*e8(1))*Syx + (e8(2)*e8(2) - cs^2)*Syy)));


f0(:, end) = f0eq(:, end) + fd0;
f1(:, end) = f1eq(:, end) + fd1;
f2(:, end) = f2eq(:, end) + fd2;
f3(:, end) = f3eq(:, end) + fd3;
f4(:, end) = f4eq(:, end) + fd4;
f5(:, end) = f5eq(:, end) + fd5;
f6(:, end) = f6eq(:, end) + fd6;
f7(:, end) = f7eq(:, end) + fd7;
f8(:, end) = f8eq(:, end) + fd8;
%}
%figure(1), plot(f2(5, 1:20)),hold on, plot(f1(5, 1:20), 'r'), plot(f8(5, 1:20), 'g'), drawnow
%disp_thing = [[f0(5,1), f0(5, 2), f0(5, 3)];[f1(5,1), f1(5, 2), f1(5, 3)];[f2(5,1), f2(5, 2), f2(5, 3)];[f3(5,1), f3(5, 2), f3(5, 3)];[f4(5,1), f4(5, 2), f4(5, 3)];[f5(5,1), f5(5, 2), f5(5, 3)];[f6(5,1), f6(5, 2), f6(5, 3)];[f7(5,1), f7(5, 2), f7(5, 3)];[f8(5,1), f8(5, 2), f2(5, 3)]];
%disp(disp_thing);
%pause(.1);

%% Working BC

%%{
f3(:, 1) = f7(:, 1);
f2(:, 1) = f6(:, 1) + 1/2*(f5(:, 1) - f1(:, 1));
f4(:, 1) = f8(:, 1) + 1/2*(f1(:, 1) - f5(:, 1));
%}
%%{
f7(:, end) = f3(:, end);
f6(:, end) = f2(:, end) + 1/2*(f1(:, end) - f5(:, end));
f8(:, end) = f4(:, end) + 1/2*(f5(:, end) - f1(:, end));
%}


%% Calculate density and velocity field

rho = f0 + f1 + f2 + f3 + f4 + f5 + f6 + f7 + f8;

ux = e0(1)*f0+e1(1)*f1+e2(1)*f2+e3(1)*f3+e4(1)*f4+e5(1)*f5+e6(1)*f6+e7(1)*f7+e8(1)*f8;
uy = e0(2)*f0+e1(2)*f1+e2(2)*f2+e3(2)*f3+e4(2)*f4+e5(2)*f5+e6(2)*f6+e7(2)*f7+e8(2)*f8;

%S_xx = e0(1)*e0(1)*f0+e1(1)*e1(1)*f1+e2(1)*e2(1)*f2+e3(1)*e3(1)*f3+e4(1)*e4(1)*f4+e5(1)*e5(1)*f5+e6(1)*e6(1)*f6+e7(1)*e7(1)*f7+e8(1)*e8(1)*f8;
%S_xy = e0(1)*e0(2)*f0+e1(1)*e1(2)*f1+e2(1)*e2(2)*f2+e3(1)*e3(2)*f3+e4(1)*e4(2)*f4+e5(1)*e5(2)*f5+e6(1)*e6(2)*f6+e7(1)*e7(2)*f7+e8(1)*e8(2)*f8;
%S_yx = e0(2)*e0(1)*f0+e1(2)*e1(1)*f1+e2(2)*e2(1)*f2+e3(2)*e3(1)*f3+e4(2)*e4(1)*f4+e5(2)*e5(1)*f5+e6(2)*e6(1)*f6+e7(2)*e7(1)*f7+e8(2)*e8(1)*f8;
%S_yy = e0(2)*e0(2)*f0+e1(2)*e1(2)*f1+e2(2)*e2(2)*f2+e3(2)*e3(2)*f3+e4(2)*e4(2)*f4+e5(2)*e5(2)*f5+e6(2)*e6(2)*f6+e7(2)*e7(2)*f7+e8(2)*e8(2)*f8;

%ux(:, 1) = 0;ux(:, end) = 0;
%uy(:, 1) = 0;uy(:, end) = 0;

%{

rho(:, 1) =  1./(1 + uy(:, 1)).*(2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));
rho(:, end) =  1./(1 + uy(:, end)).*(2*(f2(:, end) + f3(:, end) + f4(:, end)) + f1(:, end) + f0(:, end) + f5(:, end));


%}
ux = ux./rho + gx/2;
uy = uy./rho + gy/2;
%v_cent = [v_cent;[max(ux(:, 1)), max(ux(:, 2)),max(ux(:, 3)), max(ux(:, 4)), max(ux(:, 5)), max(ux(:, 6))];
%figure(1)
%figure(1),hold off, plot(ux(:, 1), 'r.-');hold on; plot(ux(:, 2), 'r.-');plot(ux(:, 2), 'b.-');plot(ux(:, 4), 'g.-');plot(ux(:, 5), 'g.-'); title(t), drawnow;%pause(.1)
%figure(1), surf(ux), shading interp, title(t), drawnow;
%figure(1), plot(S_yy(5, :), '.-');drawnow;%pause(.1)
%figure(1), plot(Axx(5, :), '.-');drawnow;
%figure(1), plot(gx(5, :), '.-');drawnow;
%quiver(X1, Y1, ux, uy, .5, 'linewidth', 1), ...
    %axis([-50 50 0 30]), title(['time = ', num2str(t)]), drawnow;
%figure(1), subplot(2, 1, 1), imagesc(ux'), xlabel('y'), ylabel('x'), title('mu'),  drawnow
    %subplot(2, 1, 2), imagesc(uy'), xlabel('y'), ylabel('x'), title('uy'),  drawnow
    %subplot(3, 1, 3), quiver(X1, Y1, ux, uy, .5, 'linewidth', 1), hold on, scatter(M_x, M_y), hold off, drawnow


    if (t > 500),
        phix = zeros(NumX, NumY);
        phiy = zeros(NumX, NumY);
        
        %figure(1), quiver(X1, Y1, ux, uy, .5, 'linewidth', 1), axis([-50 50 0 30]), axis off, drawnow;
        %pause(.5)
        
    end
    
        
        %quiver(X1, Y1, ux, uy, .5, 'linewidth', 1), axis([-50 50 0 30]), title(['time = ', num2str(t)]), drawnow;
        %M_tmp(movie_count) = getframe(gca);
        

    
    
%{
if (mod(t, 10) == 0),
    figure(1), subplot(2, 1, 1), imagesc(ux), xlabel('y'), ylabel('x'), title('mu'),  drawnow
    subplot(2, 1, 2), imagesc(uy), xlabel('y'), ylabel('x'), title('uy'),  drawnow
end
%}
%{
if (t == 500),
   %phix(:, 3) = -X.*exp(-X.^2/100)*1e-6.*(abs(X) > 6);
   %phix(:, 3) = -X.*exp(-X.^2/100)*2e-6;
end

 


x_m = floor(M_x) + 150;
y_m = floor(M_y);
id_m = x_m + 300*y_m;
dx_m = 1000;

M_x = M_x + ux(id_m)*dx_m;
M_y = M_y + uy(id_m)*dx_m;

figure(1), scatter(M_x, M_y, 'filled', 'r'), axis([-150 150 0 50]), drawnow;

%figure(2), scatter(P_pos_x, P_pos_y, 'fillled', 'b'), axis([-52 52 -.5 4]), title(t)% ...
    %,hold on, quiver(X1, Y1, ux, uy, 1), hold off

temp = [max(ux(:, 1)), max(ux(:, 2)), max(ux(:, 3)), max(ux(:, 4)), max(ux(:, 5)), max(ux(:, 6))];
v_cent = [v_cent;temp];
%}

%{
if (t == 500),
    ux_10 = ux;
    uy_10 = uy;
end

if (t == 10500),
    ux_50 = ux;
    uy_50 = uy;
end

if (t == 18500),
    ux_100 = ux;
    uy_100 = uy;
end
%}


%figure(1), quiver(X1, Y1, ux, uy, 5), drawnow, pause(.5);


%% Calculate Boundary Conditions for 2,3,4 and 6,7,8 (Not really working...)
%{

ux(:, 1) = 0;
uy(:, 1) = 0;
rho_tmp1 = 1/(1 + uy(:, 1))*(2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));
%rho_tmp1 = (2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));


f1_tmp = f1(:, 1) - f1eq(:, 1);
f0_tmp = f0(:, 1) - f0eq(:, 1);
f5_tmp = f5(:, 1) - f5eq(:, 1);
f6_tmp = f6(:, 1) - f6eq(:, 1);
f7_tmp = f7(:, 1) - f7eq(:, 1);
f8_tmp = f8(:, 1) - f8eq(:, 1);

%f2(:, 1) = w2*rho_tmp1.*calc_feq(e2, ux(:, 1), uy(:, 1), cs) + f6_tmp;
%f3(:, 1) = w3*rho_tmp1.*calc_feq(e3, ux(:, 1), uy(:, 1), cs) + f7_tmp;
%f4(:, 1) = w4*rho_tmp1.*calc_feq(e4, ux(:, 1), uy(:, 1), cs) + f8_tmp;

Sxx = -1./(rho_tmp1*tau*cs^2).*(2*(e6(1)*e6(1)*f6_tmp(:, 1) + e7(1)*e7(1)*f7_tmp(:, 1) + e8(1)*e8(1)*f8_tmp(:, 1)) + e1(1)*e1(1)*f1_tmp(:, 1) + e0(1)*e0(1)*f0_tmp(:, 1) + e5(1)*e5(1)*f5_tmp(:, 1));
Sxy = -1./(rho_tmp1*tau*cs^2).*(2*(e6(1)*e6(2)*f6_tmp(:, 1) + e7(1)*e7(2)*f7_tmp(:, 1) + e8(1)*e8(2)*f8_tmp(:, 1)) + e1(1)*e1(2)*f1_tmp(:, 1) + e0(1)*e0(2)*f0_tmp(:, 1) + e5(1)*e5(2)*f5_tmp(:, 1));
Syx = -1./(rho_tmp1*tau*cs^2).*(2*(e6(2)*e6(1)*f6_tmp(:, 1) + e7(2)*e7(1)*f7_tmp(:, 1) + e8(2)*e8(1)*f8_tmp(:, 1)) + e1(2)*e1(1)*f1_tmp(:, 1) + e0(2)*e0(1)*f0_tmp(:, 1) + e5(2)*e5(1)*f5_tmp(:, 1));
Syy = -1./(rho_tmp1*tau*cs^2).*(2*(e6(2)*e6(2)*f6_tmp(:, 1) + e7(2)*e7(2)*f7_tmp(:, 1) + e8(2)*e8(2)*f8_tmp(:, 1)) + e1(2)*e1(2)*f1_tmp(:, 1) + e0(2)*e0(2)*f0_tmp(:, 1) + e5(2)*e5(2)*f5_tmp(:, 1));

fd0 = w0*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e0(1)*e0(1) - cs^2)*Sxx + (e0(1)*e0(2))*Sxy + (e0(2)*e0(1))*Syx + (e0(2)*e0(2) - cs^2)*Syy)));
fd1 = w1*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e1(1)*e1(1) - cs^2)*Sxx + (e1(1)*e1(2))*Sxy + (e1(2)*e1(1))*Syx + (e1(2)*e1(2) - cs^2)*Syy)));
fd2 = w2*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e2(1)*e2(1) - cs^2)*Sxx + (e2(1)*e2(2))*Sxy + (e2(2)*e2(1))*Syx + (e2(2)*e2(2) - cs^2)*Syy)));
fd3 = w3*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e3(1)*e3(1) - cs^2)*Sxx + (e3(1)*e3(2))*Sxy + (e3(2)*e3(1))*Syx + (e3(2)*e3(2) - cs^2)*Syy)));
fd4 = w4*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e4(1)*e4(1) - cs^2)*Sxx + (e4(1)*e4(2))*Sxy + (e4(2)*e4(1))*Syx + (e4(2)*e4(2) - cs^2)*Syy)));
fd5 = w5*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e5(1)*e5(1) - cs^2)*Sxx + (e5(1)*e5(2))*Sxy + (e5(2)*e5(1))*Syx + (e5(2)*e5(2) - cs^2)*Syy)));
fd6 = w6*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e6(1)*e6(1) - cs^2)*Sxx + (e6(1)*e6(2))*Sxy + (e6(2)*e6(1))*Syx + (e6(2)*e6(2) - cs^2)*Syy)));
fd7 = w7*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e7(1)*e7(1) - cs^2)*Sxx + (e7(1)*e7(2))*Sxy + (e7(2)*e7(1))*Syx + (e7(2)*e7(2) - cs^2)*Syy)));
fd8 = w8*rho_tmp1.*(1/(2*cs^4)*(-2*cs^2*tau*((e8(1)*e8(1) - cs^2)*Sxx + (e8(1)*e8(2))*Sxy + (e8(2)*e8(1))*Syx + (e8(2)*e8(2) - cs^2)*Syy)));
%}
%{
f1(:, 1) = w1*rho_tmp1.*calc_feq(e1, ux(:, 1), uy(:, 1), cs) + w1/(2*cs^4)*(e1(1)^2*P00 + e1(1)*e1(2)*P01 + e1(2)*e1(1)*P10 + e1(2)*e1(2)*P11);
f2(:, 1) = w2*rho_tmp1.*calc_feq(e2, ux(:, 1), uy(:, 1), cs) + w2/(2*cs^4)*(e2(1)^2*P00 + e2(1)*e2(2)*P01 + e2(2)*e2(1)*P10 + e2(2)*e2(2)*P11);
f3(:, 1) = w3*rho_tmp1.*calc_feq(e3, ux(:, 1), uy(:, 1), cs) + w3/(2*cs^4)*(e3(1)^2*P00 + e3(1)*e3(2)*P01 + e3(2)*e3(1)*P10 + e3(2)*e3(2)*P11);
f4(:, 1) = w4*rho_tmp1.*calc_feq(e4, ux(:, 1), uy(:, 1), cs) + w4/(2*cs^4)*(e4(1)^2*P00 + e4(1)*e4(2)*P01 + e4(2)*e4(1)*P10 + e4(2)*e4(2)*P11);
f5(:, 1) = w5*rho_tmp1.*calc_feq(e5, ux(:, 1), uy(:, 1), cs) + w5/(2*cs^4)*(e5(1)^2*P00 + e5(1)*e5(2)*P01 + e5(2)*e5(1)*P10 + e5(2)*e5(2)*P11);
f6(:, 1) = w6*rho_tmp1.*calc_feq(e6, ux(:, 1), uy(:, 1), cs) + w6/(2*cs^4)*(e6(1)^2*P00 + e6(1)*e6(2)*P01 + e6(2)*e6(1)*P10 + e6(2)*e6(2)*P11);
f7(:, 1) = w7*rho_tmp1.*calc_feq(e7, ux(:, 1), uy(:, 1), cs) + w7/(2*cs^4)*(e7(1)^2*P00 + e7(1)*e7(2)*P01 + e7(2)*e7(1)*P10 + e7(2)*e7(2)*P11);
f8(:, 1) = w8*rho_tmp1.*calc_feq(e8, ux(:, 1), uy(:, 1), cs) + w8/(2*cs^4)*(e8(1)^2*P00 + e8(1)*e8(2)*P01 + e8(2)*e8(1)*P10 + e8(2)*e8(2)*P11);
f0(:, 1) = w0*rho_tmp1.*calc_feq(e0, ux(:, 1), uy(:, 1), cs) + w0/(2*cs^4)*(e0(1)^2*P00 + e0(1)*e0(2)*P01 + e0(2)*e0(1)*P10 + e0(2)*e0(2)*P11);
%}
%{
f0(:, 1) = w0*rho_tmp1.*calc_feq(e0, ux(:, 1), uy(:, 1), cs) + fd0;
f1(:, 1) = w1*rho_tmp1.*calc_feq(e1, ux(:, 1), uy(:, 1), cs) + fd1;
f2(:, 1) = w2*rho_tmp1.*calc_feq(e2, ux(:, 1), uy(:, 1), cs) + fd2;
f3(:, 1) = w3*rho_tmp1.*calc_feq(e3, ux(:, 1), uy(:, 1), cs) + fd3;
f4(:, 1) = w4*rho_tmp1.*calc_feq(e4, ux(:, 1), uy(:, 1), cs) + fd4;
f5(:, 1) = w5*rho_tmp1.*calc_feq(e5, ux(:, 1), uy(:, 1), cs) + fd5;
f6(:, 1) = w6*rho_tmp1.*calc_feq(e6, ux(:, 1), uy(:, 1), cs) + fd6;
f7(:, 1) = w7*rho_tmp1.*calc_feq(e7, ux(:, 1), uy(:, 1), cs) + fd7;
f8(:, 1) = w8*rho_tmp1.*calc_feq(e8, ux(:, 1), uy(:, 1), cs) + fd8;
%}
%{
f0(:, 1) = f0eq(:, 1);
f1(:, 1) = f1eq(:, 1);
f2(:, 1) = f2eq(:, 1);
f3(:, 1) = f3eq(:, 1);
f4(:, 1) = f4eq(:, 1);
f5(:, 1) = f5eq(:, 1);
f6(:, 1) = f6eq(:, 1);
f7(:, 1) = f7eq(:, 1);
f8(:, 1) = f8eq(:, 1);
%}
%figure(1), plot(f2(5, 1:20)),hold on, plot(f1(5, 1:20), 'r'), plot(f8(5, 1:20), 'g'), drawnow
%disp_thing = [[f0(5,1), f0(5, 2), f0(5, 3)];[f1(5,1), f1(5, 2), f1(5, 3)];[f2(5,1), f2(5, 2), f2(5, 3)];[f3(5,1), f3(5, 2), f3(5, 3)];[f4(5,1), f4(5, 2), f4(5, 3)];[f5(5,1), f5(5, 2), f5(5, 3)];[f6(5,1), f6(5, 2), f6(5, 3)];[f7(5,1), f7(5, 2), f7(5, 3)];[f8(5,1), f8(5, 2), f2(5, 3)]];
%disp(disp_thing);
%pause(.5);

%pause(.5)
%{
term_tmp = (2*((e6*e6')*f6_tmp + (e7*e7')*f7_tmp + (e8*e8')*f8_tmp) + (e1*e1')*f1_tmp + (e0*e0')*f0_tmp + (e5*e5')*f5_tmp);



f1(:, 1) = w1/cs^4*(2*((e1*e6')^2*f6_tmp + (e1*e7')^2*f7_tmp + (e1*e8')^2*f8_tmp) + (e1*e1')^2*f1_tmp + (e1*e0')^2*f0_tmp + (e1*e5')^2*f5_tmp) - ...
    w1/cs^2*term_tmp;

f0(:, 1) = w0/cs^4*(2*((e0*e6')^2*f6_tmp + (e0*e7')^2*f7_tmp + (e0*e8')^2*f8_tmp) + (e0*e1')^2*f1_tmp + (e0*e0')^2*f0_tmp + (e0*e5')^2*f5_tmp) - ...
    w0/cs^2*term_tmp;

f5(:, 1) = w5/cs^4*(2*((e5*e6')^2*f6_tmp + (e5*e7')^2*f7_tmp + (e5*e8')^2*f8_tmp) + (e5*e1')^2*f1_tmp + (e5*e0')^2*f0_tmp + (e5*e5')^2*f5_tmp) - ...
    w5/cs^2*term_tmp;

f6(:, 1) = w6/cs^4*(2*((e6*e6')^2*f6_tmp + (e6*e7')^2*f7_tmp + (e6*e8')^2*f8_tmp) + (e6*e1')^2*f1_tmp + (e6*e0')^2*f0_tmp + (e6*e5')^2*f5_tmp) - ...
    w6/cs^2*term_tmp;

f7(:, 1) = w7/cs^4*(2*((e7*e6')^2*f6_tmp + (e8*e7')^2*f7_tmp + (e7*e8')^2*f8_tmp) + (e7*e1')^2*f1_tmp + (e7*e0')^2*f0_tmp + (e7*e5')^2*f5_tmp) - ...
    w7/cs^2*term_tmp;

f8(:, 1) = w8/cs^4*(2*((e8*e6')^2*f6_tmp + (e7*e7')^2*f7_tmp + (e8*e8')^2*f8_tmp) + (e8*e1')^2*f1_tmp + (e8*e0')^2*f0_tmp + (e8*e5')^2*f5_tmp) - ...
    w8/cs^2*term_tmp;

f2(:, 1) = w2/cs^4*(2*((e2*e6')^2*f6_tmp + (e2*e7')^2*f7_tmp + (e2*e8')^2*f8_tmp) + (e2*e1')^2*f1_tmp + (e2*e0')^2*f0_tmp + (e2*e5')^2*f5_tmp) - ...
    w2/cs^2*term_tmp;

f3(:, 1) = w3/cs^4*(2*((e3*e6')^2*f6_tmp + (e3*e7')^2*f7_tmp + (e3*e8')^2*f8_tmp) + (e3*e1')^2*f1_tmp + (e3*e0')^2*f0_tmp + (e3*e5')^2*f5_tmp) - ...
    w3/cs^2*term_tmp;

f4(:, 1) = w4/cs^4*(2*((e4*e6')^2*f6_tmp + (e4*e7')^2*f7_tmp + (e4*e8')^2*f8_tmp) + (e4*e1')^2*f1_tmp + (e4*e0')^2*f0_tmp + (e4*e5')^2*f5_tmp) - ...
    w4/cs^2*term_tmp;

f1(:, 1) = f1(:, 1) + w1*rho_tmp1.*calc_feq(e1, ux(:, 1), uy(:, 1), cs);
f0(:, 1) = f0(:, 1) + w0*rho_tmp1.*calc_feq(e0, ux(:, 1), uy(:, 1), cs);
f5(:, 1) = f5(:, 1) + w5*rho_tmp1.*calc_feq(e5, ux(:, 1), uy(:, 1), cs);
f6(:, 1) = f6(:, 1) + w6*rho_tmp1.*calc_feq(e6, ux(:, 1), uy(:, 1), cs);
f7(:, 1) = f7(:, 1) + w7*rho_tmp1.*calc_feq(e7, ux(:, 1), uy(:, 1), cs);
f8(:, 1) = f8(:, 1) + w8*rho_tmp1.*calc_feq(e8, ux(:, 1), uy(:, 1), cs);
f2(:, 1) = f2(:, 1) + w2*rho_tmp1.*calc_feq(e2, ux(:, 1), uy(:, 1), cs);
f3(:, 1) = f3(:, 1) + w3*rho_tmp1.*calc_feq(e3, ux(:, 1), uy(:, 1), cs);
f4(:, 1) = f4(:, 1) + w4*rho_tmp1.*calc_feq(e4, ux(:, 1), uy(:, 1), cs);
%}

%{
rho_tmp2 = 1/(1 + uy(:, end))*(2*(f2(:, end) + f3(:, end) + f4(:, end)) + f1(:, end) + f0(:, end) + f5(:, end));

f1_tmp = f1(:, end) - w1*rho_tmp2.*calc_feq(e1, ux(:, end), uy(:, end), cs);%f1eq(:, end);
f0_tmp = f0(:, end) - w0*rho_tmp2.*calc_feq(e0, ux(:, end), uy(:, end), cs);%f0eq(:, end);
f5_tmp = f5(:, end) - w5*rho_tmp2.*calc_feq(e5, ux(:, end), uy(:, end), cs);%f5eq(:, end);
f2_tmp = f2(:, end) - w2*rho_tmp2.*calc_feq(e2, ux(:, end), uy(:, end), cs);%f2eq(:, end);
f3_tmp = f3(:, end) - w3*rho_tmp2.*calc_feq(e3, ux(:, end), uy(:, end), cs);%f3eq(:, end);
f4_tmp = f4(:, end) - w4*rho_tmp2.*calc_feq(e4, ux(:, end), uy(:, end), cs);%f4eq(:, end);


term_tmp = (2*((e2*e2')*f2_tmp + (e3*e3')*f3_tmp + (e4*e4')*f4_tmp) + (e1*e1')*f1_tmp + (e0*e0')*f0_tmp + (e5*e5')*f5_tmp);

f1(:, end) = w1/cs^4*(2*((e1*e2')^2*f2_tmp + (e1*e3')^2*f3_tmp + (e1*e4')^2*f4_tmp) + (e1*e1')^2*f1_tmp + (e1*e0')^2*f0_tmp + (e1*e5')^2*f5_tmp) - ...
    w1/cs^2*term_tmp;

f0(:, end) = w0/cs^4*(2*((e0*e2')^2*f2_tmp + (e0*e3')^2*f3_tmp + (e0*e4')^2*f4_tmp) + (e0*e1')^2*f1_tmp + (e0*e0')^2*f0_tmp + (e0*e5')^2*f5_tmp) - ...
    w0/cs^2*term_tmp;

f5(:, end) = w5/cs^4*(2*((e5*e2')^2*f2_tmp + (e5*e3')^2*f3_tmp + (e5*e4')^2*f4_tmp) + (e5*e1')^2*f1_tmp + (e5*e0')^2*f0_tmp + (e5*e5')^2*f5_tmp) - ...
    w5/cs^2*term_tmp;

f2(:, end) = w2/cs^4*(2*((e2*e2')^2*f2_tmp + (e2*e3')^2*f3_tmp + (e2*e4')^2*f4_tmp) + (e2*e1')^2*f1_tmp + (e2*e0')^2*f0_tmp + (e2*e5')^2*f5_tmp) - ...
    w2/cs^2*term_tmp;

f3(:, end) = w3/cs^4*(2*((e3*e2')^2*f2_tmp + (e3*e3')^2*f3_tmp + (e3*e4')^2*f4_tmp) + (e3*e1')^2*f1_tmp + (e3*e0')^2*f0_tmp + (e3*e5')^2*f5_tmp) - ...
    w3/cs^2*term_tmp;

f4(:, end) = w4/cs^4*(2*((e4*e2')^2*f2_tmp + (e4*e3')^2*f3_tmp + (e4*e4')^2*f4_tmp) + (e4*e1')^2*f1_tmp + (e4*e0')^2*f0_tmp + (e4*e5')^2*f5_tmp) - ...
    w4/cs^2*term_tmp;

f6(:, end) = w6/cs^4*(2*((e6*e2')^2*f2_tmp + (e6*e3')^2*f3_tmp + (e6*e4')^2*f4_tmp) + (e6*e1')^2*f1_tmp + (e6*e0')^2*f0_tmp + (e6*e5')^2*f5_tmp) - ...
    w6/cs^2*term_tmp;

f7(:, end) = w7/cs^4*(2*((e7*e2')^2*f2_tmp + (e7*e3')^2*f3_tmp + (e7*e4')^2*f4_tmp) + (e7*e1')^2*f1_tmp + (e7*e0')^2*f0_tmp + (e7*e5')^2*f5_tmp) - ...
    w7/cs^2*term_tmp;

f8(:, end) = w8/cs^4*(2*((e8*e2')^2*f2_tmp + (e8*e3')^2*f3_tmp + (e8*e4')^2*f4_tmp) + (e8*e1')^2*f1_tmp + (e8*e0')^2*f0_tmp + (e8*e5')^2*f5_tmp) - ...
    w8/cs^2*term_tmp;

f1(:, end) = f1(:, end) + w1*rho_tmp2.*calc_feq(e1, ux(:, end), uy(:, end), cs);
f0(:, end) = f0(:, end) + w0*rho_tmp2.*calc_feq(e0, ux(:, end), uy(:, end), cs);
f5(:, end) = f5(:, end) + w5*rho_tmp2.*calc_feq(e5, ux(:, end), uy(:, end), cs);
f2(:, end) = f2(:, end) + w2*rho_tmp2.*calc_feq(e2, ux(:, end), uy(:, end), cs);
f3(:, end) = f3(:, end) + w3*rho_tmp2.*calc_feq(e3, ux(:, end), uy(:, end), cs);
f4(:, end) = f4(:, end) + w4*rho_tmp2.*calc_feq(e4, ux(:, end), uy(:, end), cs);
f6(:, end) = f6(:, end) + w6*rho_tmp2.*calc_feq(e6, ux(:, end), uy(:, end), cs);
f7(:, end) = f7(:, end) + w7*rho_tmp2.*calc_feq(e7, ux(:, end), uy(:, end), cs);
f8(:, end) = f8(:, end) + w8*rho_tmp2.*calc_feq(e8, ux(:, end), uy(:, end), cs);

%figure(1), plot(f2(5, :)), drawnow
%pause(1)
%}


%% Another BC
%{
f0(:, 1) = f0(:, 2);
f1(:, 1) = f5(:, 2);
f2(:, 1) = f6(:, 2);
f3(:, 1) = f7(:, 2);
f4(:, 1) = f8(:, 2);
f5(:, 1) = f1(:, 2);
f6(:, 1) = f2(:, 2);
f7(:, 1) = f3(:, 2);
f8(:, 1) = f4(:, 2);

f0(:, end) = f0(:, end-1);
f1(:, end) = f5(:, end-1);
f2(:, end) = f6(:, end-1);
f3(:, end) = f7(:, end-1);
f4(:, end) = f8(:, end-1);
f5(:, end) = f1(:, end-1);
f6(:, end) = f2(:, end-1);
f7(:, end) = f3(:, end-1);
f8(:, end) = f4(:, end-1);
%}

%% Yet another BC
%{
rho_tmp1 = 1/(1 - uy(:, 1))*(2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) + f1(:, 1) + f0(:, 1) + f5(:, 1));
P00 = f1(:, 1) + f5(:, 1) + 2*(f6(:, 1) + f8(:, 1)) - rho_tmp1.*(uy(:,1)/3 + ux(:, 1).^2 + 1/3);
P01 = 2*(f8(:, 1) - f6(:, 1)) - rho_tmp1.*(ux(:,1)/3 + ux(:, 1).*uy(:, 1));
P10 = 2*(f8(:, 1) - f6(:, 1)) - rho_tmp1.*(uy(:,1)/3 + ux(:, 1).*uy(:, 1));
P11 = 2*(f6(:, 1) + f7(:, 1) + f8(:, 1)) - rho_tmp1.*(uy(:, 1) + uy(:, 1).^2 + 1/3);

f1(:, 1) = w1*rho_tmp1.*calc_feq(e1, ux(:, 1), uy(:, 1), cs) + w1/(2*cs^4)*(e1(1)^2*P00 + e1(1)*e1(2)*P01 + e1(2)*e1(1)*P10 + e1(2)*e1(2)*P11);
f2(:, 1) = w2*rho_tmp1.*calc_feq(e2, ux(:, 1), uy(:, 1), cs) + w2/(2*cs^4)*(e2(1)^2*P00 + e2(1)*e2(2)*P01 + e2(2)*e2(1)*P10 + e2(2)*e2(2)*P11);
f3(:, 1) = w3*rho_tmp1.*calc_feq(e3, ux(:, 1), uy(:, 1), cs) + w3/(2*cs^4)*(e3(1)^2*P00 + e3(1)*e3(2)*P01 + e3(2)*e3(1)*P10 + e3(2)*e3(2)*P11);
f4(:, 1) = w4*rho_tmp1.*calc_feq(e4, ux(:, 1), uy(:, 1), cs) + w4/(2*cs^4)*(e4(1)^2*P00 + e4(1)*e4(2)*P01 + e4(2)*e4(1)*P10 + e4(2)*e4(2)*P11);
f5(:, 1) = w5*rho_tmp1.*calc_feq(e5, ux(:, 1), uy(:, 1), cs) + w5/(2*cs^4)*(e5(1)^2*P00 + e5(1)*e5(2)*P01 + e5(2)*e5(1)*P10 + e5(2)*e5(2)*P11);
f6(:, 1) = w6*rho_tmp1.*calc_feq(e6, ux(:, 1), uy(:, 1), cs) + w6/(2*cs^4)*(e6(1)^2*P00 + e6(1)*e6(2)*P01 + e6(2)*e6(1)*P10 + e6(2)*e6(2)*P11);
f7(:, 1) = w7*rho_tmp1.*calc_feq(e7, ux(:, 1), uy(:, 1), cs) + w7/(2*cs^4)*(e7(1)^2*P00 + e7(1)*e7(2)*P01 + e7(2)*e7(1)*P10 + e7(2)*e7(2)*P11);
f8(:, 1) = w8*rho_tmp1.*calc_feq(e8, ux(:, 1), uy(:, 1), cs) + w8/(2*cs^4)*(e8(1)^2*P00 + e8(1)*e8(2)*P01 + e8(2)*e8(1)*P10 + e8(2)*e8(2)*P11);
f0(:, 1) = w0*rho_tmp1.*calc_feq(e0, ux(:, 1), uy(:, 1), cs) + w0/(2*cs^4)*(e0(1)^2*P00 + e0(1)*e0(2)*P01 + e0(2)*e0(1)*P10 + e0(2)*e0(2)*P11);




rho_tmp1 = 1/(1 + uy(:, end))*(2*(f2(:, end) + f3(:, end) + f4(:, end)) + f1(:, end) + f0(:, end) + f5(:, end));
P00 = f1(:, end) + f5(:, end) + 2*(f4(:, end) + f2(:, end)) - rho_tmp1.*(uy(:,end)/3 + ux(:, end).^2 + 1/3);
P01 = 2*(f2(:, end) - f4(:, end)) - rho_tmp1.*(ux(:,1)/3 + ux(:, end).*uy(:, end));
P10 = 2*(f2(:, end) - f4(:, end)) - rho_tmp1.*(uy(:,1)/3 + ux(:, end).*uy(:, end));
P11 = 2*(f2(:, end) + f3(:, end) + f4(:, end)) - rho_tmp1.*(uy(:, end) + uy(:, end).^2 + 1/3);

f1(:, end) = w1*rho_tmp1.*calc_feq(e1, ux(:, end), uy(:, end), cs) + w1/(2*cs^4)*(e1(1)^2*P00 + e1(1)*e1(2)*P01 + e1(2)*e1(1)*P10 + e1(2)*e1(2)*P11);
f2(:, end) = w2*rho_tmp1.*calc_feq(e2, ux(:, end), uy(:, end), cs) + w2/(2*cs^4)*(e2(1)^2*P00 + e2(1)*e2(2)*P01 + e2(2)*e2(1)*P10 + e2(2)*e2(2)*P11);
f3(:, end) = w3*rho_tmp1.*calc_feq(e3, ux(:, end), uy(:, end), cs) + w3/(2*cs^4)*(e3(1)^2*P00 + e3(1)*e3(2)*P01 + e3(2)*e3(1)*P10 + e3(2)*e3(2)*P11);
f4(:, end) = w4*rho_tmp1.*calc_feq(e4, ux(:, end), uy(:, end), cs) + w4/(2*cs^4)*(e4(1)^2*P00 + e4(1)*e4(2)*P01 + e4(2)*e4(1)*P10 + e4(2)*e4(2)*P11);
f5(:, end) = w5*rho_tmp1.*calc_feq(e5, ux(:, end), uy(:, end), cs) + w5/(2*cs^4)*(e5(1)^2*P00 + e5(1)*e5(2)*P01 + e5(2)*e5(1)*P10 + e5(2)*e5(2)*P11);
f6(:, end) = w6*rho_tmp1.*calc_feq(e6, ux(:, end), uy(:, end), cs) + w6/(2*cs^4)*(e6(1)^2*P00 + e6(1)*e6(2)*P01 + e6(2)*e6(1)*P10 + e6(2)*e6(2)*P11);
f7(:, end) = w7*rho_tmp1.*calc_feq(e7, ux(:, end), uy(:, end), cs) + w7/(2*cs^4)*(e7(1)^2*P00 + e7(1)*e7(2)*P01 + e7(2)*e7(1)*P10 + e7(2)*e7(2)*P11);
f8(:, end) = w8*rho_tmp1.*calc_feq(e8, ux(:, end), uy(:, end), cs) + w8/(2*cs^4)*(e8(1)^2*P00 + e8(1)*e8(2)*P01 + e8(2)*e8(1)*P10 + e8(2)*e8(2)*P11);
f0(:, end) = w0*rho_tmp1.*calc_feq(e0, ux(:, end), uy(:, end), cs) + w0/(2*cs^4)*(e0(1)^2*P00 + e0(1)*e0(2)*P01 + e0(2)*e0(1)*P10 + e0(2)*e0(2)*P11);


%}

%% Calculate derivative of velocity
%%{
ux_x = ([ux(2:end, :); ux(1, :)] - [ux(end, :); ux(1:end-1, :)])/2;
uy_x = ([uy(2:end, :); uy(1, :)] - [uy(end, :); uy(1:end-1, :)])/2;

ux_y = zeros(NumX, NumY);
ux_y(:, 2:end-1) = (ux(:, 3:end) - ux(:, 1:end-2))/2;
ux_y(:, 1) = (-3*ux(:, 1) + 4*ux(:, 2) - ux(:, 3))/2;
ux_y(:, end) = -(-3*ux(:, end) + 4*ux(:, end-1) - ux(:, end-2))/2;



uy_y = zeros(NumX, NumY);
uy_y(:, 2:end-1) = (uy(:, 3:end) - uy(:, 1:end-2))/2;
uy_y(:, 1) = (-3*uy(:, 1) + 4*uy(:, 2) - uy(:, 3))/2;
uy_y(:, end) = -(-3*uy(:, end) + 4*uy(:, end-1) - uy(:, end-2))/2;

%v_cent = [v_cent;ux(end/2, end/2)];
%}

%% Calculate heq
%%{
h0xxeq = w0el*Axx.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
h1xxeq = w1el*Axx.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
h2xxeq = w2el*Axx.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
h3xxeq = w3el*Axx.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
h4xxeq = w4el*Axx.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

h0xyeq = w0el*Axy.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
h1xyeq = w1el*Axy.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
h2xyeq = w2el*Axy.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
h3xyeq = w3el*Axy.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
h4xyeq = w4el*Axy.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

h0yxeq = w0el*Ayx.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
h1yxeq = w1el*Ayx.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
h2yxeq = w2el*Ayx.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
h3yxeq = w3el*Ayx.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
h4yxeq = w4el*Ayx.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

h0yyeq = w0el*Ayy.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
h1yyeq = w1el*Ayy.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
h2yyeq = w2el*Ayy.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
h3yyeq = w3el*Ayy.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
h4yyeq = w4el*Ayy.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);
%}

%% Calculate G
%%{
Gxx = -1/lambda*(Axx - 1) + 2*Axx.*ux_x + (Axy + Ayx).*ux_y;
Gxy = -1/lambda*(Axy) + Axx.*uy_x + Ayy.*ux_y + Axy.*ux_x + Axy.*uy_y;
Gyx = -1/lambda*(Ayx) + Axx.*uy_x + Ayy.*ux_y + Ayx.*ux_x + Ayx.*uy_y;
Gyy = -1/lambda*(Ayy - 1) + 2*Ayy.*uy_y + (Axy + Ayx).*uy_x;
%}




%% Do LBM for the elastic tensor A
dh0xx = h0xx - 1/tau_el*(h0xx - h0xxeq) + (1 - 1/(2*tau_el))*w0el*Gxx.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
dh1xx = h1xx - 1/tau_el*(h1xx - h1xxeq) + (1 - 1/(2*tau_el))*w1el*Gxx.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
dh2xx = h2xx - 1/tau_el*(h2xx - h2xxeq) + (1 - 1/(2*tau_el))*w2el*Gxx.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
dh3xx = h3xx - 1/tau_el*(h3xx - h3xxeq) + (1 - 1/(2*tau_el))*w3el*Gxx.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
dh4xx = h4xx - 1/tau_el*(h4xx - h4xxeq) + (1 - 1/(2*tau_el))*w4el*Gxx.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

dh0xy = h0xy - 1/tau_el*(h0xy - h0xyeq) + (1 - 1/(2*tau_el))*w0el*Gxy.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
dh1xy = h1xy - 1/tau_el*(h1xy - h1xyeq) + (1 - 1/(2*tau_el))*w1el*Gxy.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
dh2xy = h2xy - 1/tau_el*(h2xy - h2xyeq) + (1 - 1/(2*tau_el))*w2el*Gxy.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
dh3xy = h3xy - 1/tau_el*(h3xy - h3xyeq) + (1 - 1/(2*tau_el))*w3el*Gxy.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
dh4xy = h4xy - 1/tau_el*(h4xy - h4xyeq) + (1 - 1/(2*tau_el))*w4el*Gxy.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

dh0yx = h0yx - 1/tau_el*(h0yx - h0yxeq) + (1 - 1/(2*tau_el))*w0el*Gyx.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
dh1yx = h1yx - 1/tau_el*(h1yx - h1yxeq) + (1 - 1/(2*tau_el))*w1el*Gyx.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
dh2yx = h2yx - 1/tau_el*(h2yx - h2yxeq) + (1 - 1/(2*tau_el))*w2el*Gyx.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
dh3yx = h3yx - 1/tau_el*(h3yx - h3yxeq) + (1 - 1/(2*tau_el))*w3el*Gyx.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
dh4yx = h4yx - 1/tau_el*(h4yx - h4yxeq) + (1 - 1/(2*tau_el))*w4el*Gyx.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

dh0yy = h0yy - 1/tau_el*(h0yy - h0yyeq) + (1 - 1/(2*tau_el))*w0el*Gyy.*(1 + (e0(1)*ux + e0(2)*uy)/cl^2);
dh1yy = h1yy - 1/tau_el*(h1yy - h1yyeq) + (1 - 1/(2*tau_el))*w1el*Gyy.*(1 + (e1(1)*ux + e1(2)*uy)/cl^2);
dh2yy = h2yy - 1/tau_el*(h2yy - h2yyeq) + (1 - 1/(2*tau_el))*w2el*Gyy.*(1 + (e3(1)*ux + e3(2)*uy)/cl^2);
dh3yy = h3yy - 1/tau_el*(h3yy - h3yyeq) + (1 - 1/(2*tau_el))*w3el*Gyy.*(1 + (e5(1)*ux + e5(2)*uy)/cl^2);
dh4yy = h4yy - 1/tau_el*(h4yy - h4yyeq) + (1 - 1/(2*tau_el))*w4el*Gyy.*(1 + (e7(1)*ux + e7(2)*uy)/cl^2);

%% Now Stream

h0xx = dh0xx;
h0xy = dh0xy;
h0yx = dh0yx;
h0yy = dh0yy;

h1xx = [dh1xx(end, :);dh1xx(1:end-1, :)];
h1xy = [dh1xy(end, :);dh1xy(1:end-1, :)];
h1yx = [dh1yx(end, :);dh1yx(1:end-1, :)];
h1yy = [dh1yy(end, :);dh1yy(1:end-1, :)];

h3xx = [dh3xx(2:end, :); dh3xx(1, :)];
h3xy = [dh3xy(2:end, :); dh3xy(1, :)];
h3yx = [dh3yx(2:end, :); dh3yx(1, :)];
h3yy = [dh3yy(2:end, :); dh3yy(1, :)];

h2xx = [h2xx(:, 1), dh2xx(:, 1:end-1)];
h2xy = [h2xy(:, 1), dh2xy(:, 1:end-1)];
h2yx = [h2yx(:, 1), dh2yx(:, 1:end-1)];
h2yy = [h2yy(:, 1), dh2yy(:, 1:end-1)];

h4xx = [dh4xx(:, 2:end), h4xx(:, end)];
h4xy = [dh4xy(:, 2:end), h4xy(:, end)];
h4yx = [dh4yx(:, 2:end), h4yx(:, end)];
h4yy = [dh4yy(:, 2:end), h4yy(:, end)];

%% BC for h 
% for h2
h2xx(:, 1) = -h4xx(:, 1) + h4xxeq(:, 1) + h2xxeq(:, 1);
h2xy(:, 1) = -h4xy(:, 1) + h4xyeq(:, 1) + h2xyeq(:, 1);
h2yx(:, 1) = -h4yx(:, 1) + h4yxeq(:, 1) + h2yxeq(:, 1);
h2yy(:, 1) = -h4yy(:, 1) + h4yyeq(:, 1) + h2yyeq(:, 1);

% for h4
h4xx(:, end) = -h2xx(:, end) + h4xxeq(:, end) + h2xxeq(:, end);
h4xy(:, end) = -h2xy(:, end) + h4xyeq(:, end) + h2xyeq(:, end);
h4yx(:, end) = -h2yx(:, end) + h4yxeq(:, end) + h2yxeq(:, end);
h4yy(:, end) = -h2yy(:, end) + h4yyeq(:, end) + h2yyeq(:, end);

%% Now calculate A again


Axx = h0xx + h1xx + h2xx + h3xx + h4xx + Gxx/2;
Ayx = h0yx + h1yx + h2yx + h3yx + h4yx + Gyx/2;
Axy = h0xy + h1xy + h2xy + h3xy + h4xy + Gxy/2;
Ayy = h0yy + h1yy + h2yy + h3yy + h4yy + Gyy/2;

%sum(sum(rho))/10000

end

movie2avi(M_tmp, 'Test');


%%
close all;
tmp_vel = (ux(5, :) - phix/2)/phix;
y = linspace(0, NumY, NumY);
figure, plot(y, tmp_vel)
u_th = -1*(y.^2 - NumY*y)/(2);
f_factor = max(u_th)/max(tmp_vel);
hold on;plot(y, u_th/f_factor, 'r-.')

%%
figure(4), plot(ux(5, :), 'b-.')


%%
figure, surf(ux), xlabel('Y'), ylabel('X'), title('ux'), shading interp;
figure, surf(uy), xlabel('Y'), ylabel('X'), title('uy'), shading interp;
figure, surf(phix), xlabel('Y'), ylabel('X'), title('phix'), shading interp;
figure, surf(phiy), xlabel('Y'), ylabel('X'), title('phiy'), shading interp;


%% test of the force



X_static = linspace(-NumX/2, NumX/2, NumX)';
X_right = linspace(0, NumX/2, NumX/2)';
X_left = linspace(-NumX/2, 0, NumX/2)';
Y_right = X_right.*exp(-X_right.^2/5);
Y_left = X_left.*exp(-X_left.^2/5);
F = [Y_left;Y_right];


for k=0:100,
    
    X1 = X_right - .1*k;
    X2 = X_left + .1*k;
    
    
    Y_right = exp(-X1.^2/5);
    Y_left = -exp(-X2.^2/5);
    F = [Y_left;Y_right];
    
    
    figure(1), plot(X_static, F), title(k), drawnow, pause(.2);
end



%%
Xo = zeros(100, 33);Yo = Xo;uxo = Xo;uyo = Xo;
a = 3;
for i=1:100,
    for j=1:33, 
        Xo(i, j) = X1(a*i, a*j);
        Yo(i, j) = Y1(a*i, a*j);
        uxo(i, j) = ux(a*i, a*j);
        uyo(i, j) = uy(a*i, a*j);
    end
end

%%


 P_M_x =  [];
P_M_y = [];

P_pos_x = [linspace(-25, 25, 50)];
P_pos_y = [zeros(1, 50)+.5];
d_o = sqrt((P_pos_x(2) - P_pos_x(1))^2 + (P_pos_y(2) - P_pos_y(1))^2);

d_t = 1000;
K = .001;

for k=0:10000,
    


   D_X = zeros(size(P_pos_x));
   D_Y = zeros(size(P_pos_y));
    for i=1:50,
        
            P_x = floor(P_pos_x(i) + 150);
            P_y = floor(P_pos_y(i)) + 2;
        
        if (i>1)&&(i<50),
            d_x_r = P_pos_x(i+1) - P_pos_x(i);
            d_x_l = P_pos_x(i-1) - P_pos_x(i);
            d_y_r = P_pos_y(i+1) - P_pos_y(i);
            d_y_l = P_pos_y(i-1) - P_pos_y(i);
            
            d_r = sqrt(d_x_r^2 + d_y_r^2);
            d_l = sqrt(d_x_l^2 + d_y_l^2);
            
            D_F_x = K*(d_r - d_o)*d_x_r/d_r + K*(d_l - d_o)*d_x_l/d_l;
            D_F_y = K*(d_r - d_o)*d_y_r/d_r + K*(d_l - d_o)*d_y_l/d_l;
            
        elseif (i==1),
            d_x_r = P_pos_x(i+1) - P_pos_x(i);
            d_y_r = P_pos_y(i+1) - P_pos_y(i);
            
            d_r = sqrt(d_x_r^2 + d_y_r^2);
           
            
            D_F_x = K*(d_r - d_o)*d_x_r/d_r;
            D_F_y = K*(d_r - d_o)*d_y_r/d_r;
        elseif (i==50),
            
            d_x_l = P_pos_x(i-1) - P_pos_x(i);
            d_y_l = P_pos_y(i-1) - P_pos_y(i);
            
            d_l = sqrt(d_x_l^2 + d_y_l^2);
            
            D_F_x = K*(d_l - d_o)*d_x_l/d_l;
            D_F_y = K*(d_l - d_o)*d_y_l/d_l;
        end
        
            D_X(i) = ux(P_x, P_y)*d_t + D_F_x;
            D_Y(i) = uy(P_x, P_y)*d_t + D_F_y;
        
    end
        
    P_pos_x = P_pos_x + D_X;
    P_pos_y = P_pos_y + D_Y;
    figure(2), scatter(P_pos_x, P_pos_y, 'fillled', 'b'), axis([-50 50 -1 1]), title(k)
    
end
        

%%
[X, Y] = meshgrid(linspace(-150, 150, 300), linspace(0, 50, 50));

%startx = [zeros(1, 10) - 1, zeros(1, 10) + 1];
%starty = [linspace(0, 5, 10), linspace(0, 5, 10)];
figure('Position', [100,100,1200,800]);
startx = [linspace(-30, -15, 10), linspace(15, 30, 10)];
starty = [linspace(5, 15, 10), linspace(15, 5, 10)];
quiver(X1, Y1, ux, uy, .5, 'linewidth', 1);hold on;
scatter(startx, starty, 'r', 'filled');
streamline(X, Y, ux', uy', startx, starty, 1, 'r');
axis([-50 50 0 30]);








